/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: conf.h 1.10 89/10/10 $"

#ifndef	_SYS_CONF_H_

/* $Log:	conf.h,v $
*/

/*
 * Declaration of block device switch. Each entry (row) is
 * the only link between the main unix code and the driver.
 * The initialization of the device switches is in the file conf.c.
 */
/*
 * Definitions left here because some monop stuff uses it.
 */
struct bdevsw {
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_strategy)();
	int	(*d_minphys)();
	int	(*d_psize)();
	int	(*d_print)();
};

/*
 * Character device switch.
 */
struct cdevsw {
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_read)();
	int	(*d_write)();
	int	(*d_ioctl)();
	int	(*d_mmap)();
	struct tty *d_ttys;
	struct streamtab *d_str;
};

#define	FMNAMESZ	8

struct fmodsw {
	char	f_name[FMNAMESZ+1];
	struct  streamtab *f_str;
};
extern struct fmodsw fmodsw[];

extern int	bdevcnt;
extern int	cdevcnt;
extern int	fmodcnt;

/*
 * Firmware interface switch 
 */
struct firmwaresw {
	int	(*fw_boot)();
	int	(*fw_return)();
	int	(*fw_inittodr)();
	int	(*fw_resettodr)();
	int	(*fw_wdtinit)();
	int	(*fw_wdtreset)();
};
extern struct firmwaresw *firmwaresw;

#define FW_BOOT		(*firmwaresw->fw_boot)
#define FW_RETURN_FW	(*firmwaresw->fw_return)
#define FW_INITTODR	(*firmwaresw->fw_inittodr)
#define FW_RESETTODR	(*firmwaresw->fw_resettodr)
#define FW_WDTINIT	(*firmwaresw->fw_wdtinit)
#define FW_WDTRESET	(*firmwaresw->fw_wdtreset)

#define	_SYS_CONF_H_
#endif	/* _SYS_CONF_H_ */
