/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident		"$Header: hwparam.h 1.5 89/08/07 $"

#ifndef	_SYS_HWPARAM_H_

/*
 * hwparam.h
 *	Define physical addresses and other parameters of the hardware.
 */

/* $Log:	hwparam.h,v $
 */

/*
 * Physical addresses in processor board address space.
 */

#include "sys/SGSproc.h"		/* SGS processor specific definitions */

/*
 * Define addressibility of Multi-bus interface.
 */

#define	VIRT_MBAD	PHYS_MBAD	/* MBAd base address (virt) */
#define	MBAD_ADDR_SPACE	(1024*1024)	/* 1M address space */

#define	VA_MBAd(i)	(VIRT_MBAD + (i) * MBAD_ADDR_SPACE)
#define	PA_MBAd(i)	(PHYS_MBAD + (i) * MBAD_ADDR_SPACE)

/*
 * For backwards compatibility -- MBAds started at fixed address.
 */

#define	OLD_VIRT_MBAD	0x0800000	/* MBAd base address (virt) */

/*
 * Define addressibility of SSM/VME bus interface.
 */

#define	VIRT_SSMVME	PHYS_SSMVME	/* SSM/VME memory base address (virt) */
#define	SSMVME_ADDR_SPACE	(32*1024*1024)	/* 32M address space */
#define	NPTE_SSMVME	howmany(SSMVME_ADDR_SPACE, NBPG)

#define	VA_SSMVME(i)	(VIRT_SSMVME + (i) * SSMVME_ADDR_SPACE)
#define	PA_SSMVME(i)	(PHYS_SSMVME + (i) * SSMVME_ADDR_SPACE)

#define	_SYS_HWPARAM_H_
#endif	/* _SYS_HWPARAM_H_ */
