/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident		"$Header: procstats.h 1.6 89/08/07 $"

#ifndef	_SYS_PROCSTATS_H_

/* $Log:	procstats.h,v $
 */


/*
 * Per-process statistics.
 */

struct process_stats {
	timeval_t ps_utime;	/* user time */
	timeval_t ps_stime;	/* system time */
	ulong ps_maxrss;	/* maximum resident set size (in HW pages) */

#define ps_first	ps_pagein

	ulong ps_pagein;	/* page faults that resulted in I/O */
	ulong ps_reclaim;	/* pages reclaimed from free or dirty list */
	ulong ps_zerofill;	/* pages zero filled on demand */
	ulong ps_pffincr;	/* times PFF increased process's RSS */
	ulong ps_pffdecr;	/* times PFF decreased process's RSS */
	ulong ps_swap;		/* times process was swapped */
	ulong ps_syscall;	/* number of system calls */
	ulong ps_volcsw;	/* voluntary context switches */
	ulong ps_involcsw;	/* involuntary context switches */
	ulong ps_signal;	/* signals received */
	ulong ps_lread;		/* filesystem "logical" reads */
	ulong ps_lwrite;	/* filesystem "logical" writes */
	ulong ps_bread;		/* filesystem disk reads */
	ulong ps_bwrite;	/* filesystem disk writes */
	ulong ps_phread;	/* raw device reads */
	ulong ps_phwrite;	/* raw device writes */

#define ps_last		ps_phwrite
};

/*
 * passing this as pid argument to get_process_stats() will return
 * staticstics on the calling process.
 */
#define PS_SELF	-1

#define	_SYS_PROCSTATS_H_
#endif	/* _SYS_PROCSTATS_H_ */
