/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: var.h 1.9 90/04/27 $"

#ifndef	_SYS_VAR_H_

/* $Log:	var.h,v $
*/


/*
 * System Configuration Information
 */
struct var {
	int	v_buf;		/* Nbr of I/O buffers.			*/
	int	v_call;		/* Nbr of callout (timeout) entries.	*/
	int	v_inode;	/* Size of incore inode table.		*/
#ifdef INKERNEL
	struct inode *ve_inode;	/* Ptr to end of incore inodes.		*/
#else
	char *	ve_inode;
#endif
	int	v_file;		/* Size of file table.			*/
#ifdef INKERNEL
	struct file *ve_file;	/* Ptr to end of file table.		*/
#else
	char *	ve_file;
#endif
	int	v_mount;	/* Size of mount table.			*/
#ifdef INKERNEL
	struct mount *ve_mount;	/* Ptr to end of mount table.		*/
#else
	char *	ve_mount;
#endif
	int	v_proc;		/* Size of proc table.			*/
#ifdef INKERNEL
	struct proc *ve_proc;	/* Ptr to next available proc entry	*/
				/* following the last one used.		*/
#else
	char *	ve_proc;
#endif
	int	v_region;	/* Nbr of regions allocated. (Not Used)	*/
	int	v_clist;	/* Nbr of clists allocated. (NU)	*/
	int	v_maxup;	/* Max number of processes per user.	*/
	int	v_hbuf;		/* Nbr of hash buffers to allocate.	*/
	int	v_hmask;	/* Hash mask for buffers. (NU)		*/
	int	v_pbuf;		/* Nbr of physical I/O buffers.		*/
	int	v_sptmap;	/* Size of system virtual space		*/
				/* allocation map. (NU)			*/
	int	v_vhndfrac;	/* Fraction of maxmem to set as limit	*/
				/* for running vhand. (NU)		*/
	int	v_maxpmem;	/* The maximum physical memory to use.	*/
				/* (NU)					*/
	int	v_autoup;	/* The age a delayed-write buffer must	*/
				/* be in seconds before bdflush will	*/
				/* write it out. (NU)			*/
	int	v_nofiles;	/* Maximum number of open files per	*/
				/* process.				*/

	int	v_nqueue;	/* Nbr of streams queues.		*/
	int	v_nstream;	/* Number of stream head structures.	*/
	int	v_nblkpriv;	/* Number of private stream buffers.	*/
	int	v_nblk4096;	/* Number of 4096 bytes stream buffers.	*/
	int	v_nblk2048;	/* Number of 2048 bytes stream buffers.	*/
	int	v_nblk1024;	/* Number of 1024 bytes stream buffers.	*/
	int	v_nblk512;	/* Number of 512 bytes stream buffers.	*/
	int	v_nblk256;	/* Number of 256 bytes stream buffers.	*/
	int	v_nblk128;	/* Number of 128 bytes stream buffers.	*/
	int	v_nblk64;	/* Number of 64 bytes stream buffers.	*/
	int	v_nblk16;	/* Number of 16 bytes stream buffers.	*/
	int	v_nblk4;	/* Number of 4 bytes stream buffers.	*/
	int	v_s5inode;	/* Size of s5inode table (NU)		*/
	daddr_t	v_ulimit;	/* system default max write address.    */
};

extern struct var v;

#define	_SYS_VAR_H_
#endif	/* _SYS_VAR_H_ */
