/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident "$Header: zd_device.h 1.3 89/08/07 $"

#ifndef	_SYS_ZD_DEVICE_H_

/*
 * zd_device.c
 *	Configuration include file for the ZDC SMD-E Disk Driver
 */

/* $Log:	zd_device.h,v $
 */

/* Define the zd device structure */

struct zd_device {
    int         busnum;                    /* index into system bus table. */
    int         unit;                     /* Unit #, index into config table */
    int 	segsize;		  /* Size of a DMA segment */
    int		segalign;		  /* driver promises this alignment */
    int		nsegs;			  /* this device need this many segs */
    struct      driver_module   *driver;  /* pointer into "drivers[]" */
    struct      dev_on_bus      *on_bus;  /* points into drivers[].on_busses */
    struct      bus             *bus;
    struct      device_config   *config;
    struct      gen_device      *next;    /* Chain of devices on same bus */
    char       *map_origin;               /* sequent addr of map regs. */
    char       *bus_map_addr;             /* start of dma map, bus side. */
    long        map_extent;               /* # of bytes covered by map. */
    int         n_maps;                   /* Number of maps */
    int         nspaces;                  /* length of devreg, below */
    /* Devreg is really variable length, but the compiler wants a size... */
    long       *devreg;                 /* points to CB */
    /*
     * zd_device specific portion
     */
    struct zdc_dev *zd_dev;		  /* The zd device structure */
};


extern struct dev_on_bus zd_on_busses[];

#define	_SYS_ZD_DEVICE_H_
#endif	/* _SYS_ZD_DEVICE_H_ */
