/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*----------------------------------------------------------------------*
 * This file must meet the requirements in volume 2 of the X/Open	*
 * Portability Guide, Issue 3, which should be consulted before any	*
 * changes are made.							*
 *----------------------------------------------------------------------*/

#ifndef	_TIME_H_
#ident	"$Header: time.h 1.8 90/06/24 $"

/*____________________________________________________________________*
 * This file forms part of the POSIX requirement described in section *
 * 4.5.1 & 8.3.2 of 1003.1-1988 which should be refered to before     *
 * making any changes.						      *
 *____________________________________________________________________*/

#include <sys/types.h>
#include <sys/time.h>

/*	3.0 SID #	1.2	*/

struct	tm {	/* see ctime(3) */
	int	tm_sec;
	int	tm_min;
	int	tm_hour;
	int	tm_mday;
	int	tm_mon;
	int	tm_year;
	int	tm_wday;
	int	tm_yday;
	int	tm_isdst;
};
extern struct tm *gmtime(), *localtime();
extern char *ctime(), *asctime();
int  cftime(),  ascftime();
#ifndef NO_XPG3_HDR
extern size_t strftime();
#endif	/* NO_XPG3_HDR */
extern void tzset();
extern long timezone, altzone;
extern int daylight;
extern char *tzname[2];
extern time_t	time();
extern time_t	mktime();

/* POSIX 1003.1-1988 2.8.1 */
/* The value of the NULL symbol must always agree with that defined by the
 * C language standard.
 *
 * ANSI C May 13, 1988 requires NULL to be defined here (among other places).
 */
#ifndef NULL
#define NULL    0
#endif

#define	_TIME_H_
#endif	/*_TIME_H_*/
