/	Copyright (c) 1984, 1986, 1987, 1988 AT&T
/	  All Rights Reserved

/	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
/	The copyright notice above does not evidence any
/	actual or intended publication of such source code.
	.file	"mcount.s"

	.ident	"@(#)libc-i386:libc-i386/crt/mcount.s	1.2"

	.text
/
/ This routine is called at the entry to each subroutine compiled with
/ the -p option to cc(1).
/
/ struct counter {
/	void	(*addr)();	/* address of calling routine */
/	long	count;		/* # of times called by caller */
/ } *_countbase, **%edx;
/ Assume can destroy %eax and %edx.
/

	.globl	_mcount
	.globl	_countbase

_mcount:

/ Is there a counter struct addr in *%edx?
	movl	(%edx),%eax	/ %eax = ptr to counter
	testl	%eax,%eax	/ if not 0, have called before:
	jnz     .add1           /      skip initialization

/ No. Allocate new counter
	movl	_countbase,%eax	/ get address of next counter structure
	testl	%eax,%eax	/ if NULL, counting has been disabled:
	jz	.ret		/	get out
	addl	$8,_countbase	/ reset ptr to next counter structure
	addl	$4,%eax
	movl	%eax,(%edx)	/	and store it in caller's ptr
	movl    0(%esp),%edx
	movl	%edx,-4(%eax)	/ set proc addr in counter structure
.add1:
	incl	(%eax)		/ increment counter
.ret:
	ret
