/*	Copyright (c) 1984, 1986, 1987, 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libc-i386:libc-i386/gen/ldexp.c	1.4.1.1"
/*LINTLIBRARY*/
/*
 *	double ldexp (value, exp)
 *		double value;
 *		int exp;
 *
 *	Ldexp returns value * 2**exp, if that result is in range.
 *	If underflow occurs, it returns zero.  If overflow occurs,
 *	it returns a value of appropriate sign and largest single-
 *	precision magnitude.  In case of underflow or overflow,
 *	the external int "errno" is set to ERANGE.  Note that errno is
 *	not modified if no error occurs, so if you intend to test it
 *	after you use ldexp, you had better set it to something
 *	other than ERANGE first (zero is a reasonable value to use).
 */

/*
#include "shlib.h"
*/
#include <values.h>
#include <errno.h>
/* Largest signed long int power of 2 */
#define MAXSHIFT	(BITSPERBYTE * sizeof(long) - 2)

asm	double
xldexp(x,n)
{
%mem	x,n;
	fildl	n
	fldl	x
	/ test for unnormal or denormal
	fxam
	fstsw	%ax
	/ if ((flags&(C0|C2|C3)) ||
	/    ((flags&C0)==0 && (flags&(CW|C3))==(C2|C3))) un/denormal
	andw	$0x4500,%ax
	je	.notnorm
	cmpw	$0x4400,%ax
	jne	.norm
.notnorm:
	fxtract / mantissa->ST0, exp->ST1
	fld1	/ get a 1.0
	fadd	%st,%st(1) / add it to de/unnormal
	fsubrp	%st,%st(1) / subtract 1 from 1.xxx
	/ now get additional exponent and sum with saved part
	fxtract
	fxch
	faddp	%st,%st(2)
	/ we now have x * 2^n, with x in st0 and n in st1
	fscale
	fxch
	fstp	%st(0)
.norm:
	fscale
	fstp	%st(1)
}

extern double frexp();

double
ldexp(value, exp)
double value;
int exp;
{
	int old_exp;

	if (exp == 0 || value == 0.0) /* nothing to do for zero */
		return (value);
	(void) frexp(value, &old_exp);
	if (exp > 0) {
		if ( (exp > (MAXINT-MAXBEXP))
		/* guard against integer overflow in next addition */
	    	|| ((exp + old_exp) > MAXBEXP) ) {
		/* we have floating point overflow condition */

			errno = ERANGE;
			return (value < 0 ? -MAXFLOAT : MAXFLOAT);
		}
	}
	else if ( (exp < -(MAXINT-MAXBEXP)) ||
		/* guard against integer overflow in next addition */
		(exp + old_exp < MINBEXP) ) { /* underflow */
		errno = ERANGE;
		return (0.0);
	}
	return (xldexp(value,exp));
}
