# $Copyright:	$
#Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
#Sequent Computer Systems, Inc.   All rights reserved.
# 
#This software is furnished under a license and may be used
#only in accordance with the terms of that license and with the
#inclusion of the above copyright notice.   This software may not
#be provided or otherwise made available to, or used by, any
#other person.  No title to or ownership of the software is
#hereby transferred.

#	Copyright (c) 1984, 1986, 1987, 1988 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)libm:libm.mk	1.17.4.1"

# makefile for libm

INC=$(ROOT)/usr/include/bcs
LIB=$(ROOT)/lib/bcs
LIBP=$(ROOT)/usr/lib/bcs/libp
USRLIB=$(ROOT)/usr/lib/bcs
VARIANT =
LIBNAME = lib$(VARIANT)m.a
LORDER = lorder
AR=ar
MAKE=make
CFLAGS=-Wc,-Og -Wc,-bcs
FILES =\
	asin.o\
	atan.o\
	erf.o\
	fabs.o\
	floor.o\
	fmod.o\
	gamma.o\
	hypot.o\
	jn.o\
	j0.o\
	j1.o\
	pow.o\
	log.o\
	sin.o\
	sinh.o\
	sqrt.o\
	tan.o\
	tanh.o\
	exp.o\
	matherr.o

PFILES = $(FILES:.o=.p)

.SUFFIXES: .p

.c.o:
	$(CC) $(CFLAGS) $(CROSS) -c $<

.c.p:
	$(CC) $(CFLAGS) $(CROSS) -c -p $< && mv $*.o $*.p

all: 
	if \[ ! -f /unix ]; \
	then \
	    CROSS_FLAG="-DSEQUENT_CROSS_COMPILE"; export CROSS_FLAG; \
	fi; \
	$(MAKE) -e -f libm.mk machine files $(LIBNAME) \
	"CFLAGS=-Wc,-Og -Wc,-bcs" CROSS=$$CROSS_FLAG

machine:
	cd i386 ; $(MAKE) -e "PROF=@#" "NONPROF=" "CFLAGS=-Wc,-Og -Wc,-bcs" \
		CROSS=$$CROSS_FLAG

files: $& $(FILES)

$(FILES) $(PFILES): $(INC)/math.h $(INC)/values.h $(INC)/errno.h \
		$(INC)/sys/errno.h

$(LIBNAME):
	rm -rf object
	mkdir object
	cp *.o object
	cp i386/*.o object
	cd object ; $(AR) rv ../$(LIBNAME) `$(LORDER) *.o | tsort`

nonprof: all
	rm -f $(LIB)/$(LIBNAME)
	cp $(LIBNAME) $(LIB)/$(LIBNAME)
	chmod 444 $(LIB)/$(LIBNAME)
	chown bin $(LIB)/$(LIBNAME)
	chgrp bin $(LIB)/$(LIBNAME)

prof:
	if \[ ! -f /unix ]; \
	then \
	    CROSS_FLAG="-DSEQUENT_CROSS_COMPILE"; export CROSS_FLAG; \
	fi; \
	cd i386; $(MAKE) -e "PROF=" "NONPROF=@#" "CFLAGS=-Wc,-Og -Wc,-bcs" \
		CROSS=$$CROSS_FLAG; cd ..; \
	$(MAKE) -f libm.mk -e $(PFILES) "CFLAGS=-Wc,-Og -Wc,-bcs" \
		CROSS=$$CROSS_FLAG
	rm -rf object
	mkdir object
	cp *.p object
	cp i386/*.p object
	cd object ; \
	for i in `ls *.p | sed 's|\.p$$||'` ; \
	   do mv $$i.p $$i.o ; \
	done ; \
	$(AR) rv ../libp.$(LIBNAME) `$(LORDER) *.o | tsort`
	rm -f $(LIBP)/$(LIBNAME)
	cp libp.$(LIBNAME) $(LIBP)/$(LIBNAME)
	chmod 444 $(LIBP)/$(LIBNAME)
	chown bin $(LIBP)/$(LIBNAME)
	chgrp bin $(LIBP)/$(LIBNAME)
	

install: prof nonprof

clean:
	rm -f *.o */*.o *.p */*.p

clobber:	clean
	rm -f $(LIBNAME) libp.$(LIBNAME)
	rm -rf object
