#
# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.
#
#	@(#)Makefile	5.3 (Berkeley) 2/18/86
#
#
#	$Header: config.mk 1.11 89/10/25 $
#
CFILES=	y.tab.c allocate.c depend.c devcon.c expression.c main.c \
	makemk.c parameters.c products.c rdmodules.c symbols.c util.c
OBJS=	y.tab.o allocate.o depend.o devcon.o expression.o main.o \
	makemk.o parameters.o products.o rdmodules.o symbols.o util.o

CFLAGS=-O $(CCS) $(DEF)
LFLAGS=
LINT=lint
LDFLAGS=-lmalloc -lPW -ll
CMD	= config
TARGET	= $P$N$(CMD)
M	= $(MAKE) -f $(CMD).mk
C	= CCS=-DCCS=1 N=ccs
X	= P=x CC=cc "`cat DEFS`"

native		:; $M clean all
nativeccs	:; $M $C clean all
cross		:; $M $X clean all
crossccs	:; $M $X $C clean all
cross crossccs	:  DEFS
everything	:  native nativeccs cross crossccs clean
#################################################################
#  we have to be real careful to not undef something to		#
#  cpp that we may want to define again since it is "sticky"	#
#################################################################
DEFS		:FRC
		  -if [ -f /dynix ]; then \
			  if [ "$(NATIVE)" != "$(MACHINE)" ]; then \
				echo "DEF=-U$$(NATIVE) -D$$(MACHINE) -Dsequent -DSVAE" >DEFS; \
			  else \
				echo "DEF=-DSVAE" >DEFS ; \
			  fi \
		else \
			  if [ "$(NATIVE)" != "$(MACHINE)" ]; then \
				echo "DEF=-U$$(NATIVE) -D$$(MACHINE) -Dsequent" >DEFS; \
			  else \
				echo "DEF=" >DEFS ; \
			  fi \
		fi

all: $(TARGET) 

$(TARGET):$& ${OBJS}
	${CC} ${OBJS} -o $@ ${LDFLAGS}

lex.yy.c: config.l symbols.h
	lex config.l

y.tab.h y.tab.c: config.y lex.yy.c
	yacc -d config.y

clean:
	rm -f ${OBJS} lex.yy.c y.tab.c y.tab.h

clobber: clean
	rm -f config DEFS

install: clean all
	install -u root -g sys -f $(ROOT)/etc config

lint: config.lint

config.lint: ${CFILES}
	$(LINT) $(LFLAGS) ${CFILES} >config.lint

allocate.o: allocate.c config.h
devcon.o: devcon.c config.h
expression.o: expression.c config.h
main.o: main.c config.h
makemk.o: makemk.c config.h
parameters.o: parameters.c config.h symbols.h
product.o: product.c config.h symbols.h
rdmodules.o: rdmodules.c config.h
symbols.o: symbols.c config.h symbols.h
util.o: util.c config.h
FRC:
