/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: def_rules.h 1.7 90/04/20 $"

/* The rules directives can appear in the "system.std" and overide these
 * default settings.
 * %T is the target.
 * %S is the source file dependent.
 * %D is all the dependencies.
 * %t is basename of the target.
 * %d is the target directory.
 * %m is the current module name.
 * %(<name>) is conditionally replaced by a 
 * 	[<module>]/<name>=<string> 
 * suboption (or null)
 * Rules are define using 
 *   %RULES <letter>
 * where letter is one of c = .o to .c
 *                        gh
 */


/*______________________________________________________________________________
 * %RULES c {
 * %(T): $(&) %(D)
 *	$(CC) -c $(CFLAGS) %(COPT) %(DEBUG) %(S)
 * }
 *______________________________________________________________________________
 */

static char *def_crule =
"%(T): $(&) %(D)\n\t$(CC) -c $(CFLAGS) %(COPT) %(DEBUG) %(S)\n";

/*______________________________________________________________________________
 * %RULES g {
 * %(T): $(&) %(D)
 *	$(CC) -c $(CFLAGS) %(SPACE_OPT) -I. %(DEBUG) %(S)
 * }
 *______________________________________________________________________________
 */

static char *def_grule =
"%(T): $(&) %(D)\n\t$(CC) -c $(CFLAGS) %(SPACE_OPT) -I. %(DEBUG) %(S)\n";

/*______________________________________________________________________________
 * %RULES h { 
 * %(T): %(D)
 * 	rm -f $@;\\
 * 	cp $? $@;\\
 * 	chmod 444 $@;chown bin $@;chgrp bin $@
 * }
 *______________________________________________________________________________
 */

static char *def_hrule = 
"%(T): %(D)\n\trm -f $@;\\\n\tcp $? $@;\\\n\tchmod 444 $@;chown bin $@;chgrp bin $@\n";

/*______________________________________________________________________________
 * %RULES s { 
 * %(T): $(&) %(D) assym.h
 * 	$(CPP) \\
 * 	 $(IINC) -I. $(INCLUDE) $(DFLAGS) %(AOPT) %(DEBUG) %(S) | $(SEDCMD) | $(AS) -o %(t)
 * }
 *______________________________________________________________________________
 */

static char *def_srule =
"%(T): $(&) %(D) assym.h\n\t$(CPP) \\\n\t $(IINC) -I. $(INCLUDE) $(DFLAGS) %(AOPT) %(DEBUG) %(S) | $(SEDCMD) | $(AS) -o %(t)\n";

/*______________________________________________________________________________
 * %RULES n {
 * %(t): %(D)
 * 	$(LLINT) $(LMOPT) $(IINC) -I. \\
 * 		-c $(CFLAGS) -Dvolatile="" %(D) > $(LL)%(m)lintout; \\
 * 	touch %(t); \\
 * 	for i in %(D); \\
 * 	do \\
 * 		cat `basename $$i .c `.ln >> %(t); \\
 * 	done
 * }
 *______________________________________________________________________________
 */

static char *def_lnrule =
"%(t): %(D)\n\t$(LLINT) $(LMOPT) $(IINC) -I. \\\n\t\t-c $(CFLAGS) -Dvolatile=\"\" %(D) > $(LL)%(m)lintout; \\\n\ttouch %(t); \\\n\tfor i in %(D); \\\n\tdo \\\n\t\tcat `basename $$i .c `.ln >> %(t); \\\n\tdone\n\n";
