#ident "$Header: main.c 1.17 89/08/07 $"

/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*
 * $Log:	main.c,v $
 */

#ifndef lint
static char rcsid[] = "$Header: main.c 1.17 89/08/07 $";
#endif

#include "crash.h"
#include "define.h"

#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#ifdef CROSS
#include "/usr/include/sys/stat.h"
#include "/usr/include/setjmp.h"
#else
#include <sys/stat.h>
#include <setjmp.h>
#endif /* CROSS */

/* #include <errno.h> */

char	*dynixV = NULL;
int	unixfd;
char	*vmcore = NULL;
int	vmcorefd;
char	*swap = NULL;
int	swapfd;
int	live = 0;
int	end_locore;
int	start_locore;
int	debug[MAX_DEBUG];
char *name_buf[MAX_CHECK];
int	To=0;
int	Eve=0;

jmp_buf jmp;
struct pte *Sysmap;
#define MAXNEST 3
FILE *filter[MAXNEST];
FILE *input[MAXNEST];
FILE *output;
FILE *popen();
int	nest = 0;

int tok = 0;		/* no token queue'd in token() */
int source = FALSE;

main(argc, argv)
int	argc;
char	**argv;
{
	int	sigint(), exit(), ouch(), onpipe(), Disread();
	int	sigalrm();
	register  struct  tsw	*tp;
	register  char *c;
	struct initfuns *ip;
	struct stat sbuf;
	struct sigaction act;
	sigset_t set;
	int bin_type;

	output = stdout;
	signal(SIGINT, exit);

	if (strcmp(argv[1], "-d") == 0)	
		xdebug = 10, ++argv, --argc;

	if (strncmp(argv[1], "-D", 2) == 0) {
		set_debug(argv[1]);
		++argv;
		--argc;
	}

	if (strncmp(argv[1], "-X", 2) == 0) {
		debug[18] = 1;
		++argv;
		--argc;
	}

	switch(argc) {
	default:
		fatal("usage: crash [ unix vmcore ]");
	case 4:
		/* assume dmesg is include *dmesg* *unix* *vmcore* */
		++argv;
		--argc;
		/* fall through */
	case 3:
		bin_type = coff_bin(argv[2]);
		if (bin_type == -1) {
			printf("crash: Cannot open file '%s'\n", argv[2]);
			fflush(stderr); fflush(stdout);
			exit(1);
		} else if (bin_type == 1)
			dynixV = argv[2];
		else
			vmcore = argv[2];
		/* fall through */
	case 2:
		bin_type = coff_bin(argv[1]);
		if (bin_type == -1) {
			printf("crash: Cannot open file '%s'\n", argv[1]);
			fflush(stderr); fflush(stdout);
			exit(1);
		} else if (bin_type == 1) {
			if (dynixV) 
				fatal("unix specified twice!");
			dynixV = argv[1];
		} else {
			if (vmcore) 
				fatal("vmcore specified twice!");
			vmcore = argv[1];
		}
		/* fall through */
	case 1:
		if (dynixV == NULL)
			dynixV = "/unix";
		if (vmcore == NULL)
			vmcore = "/dev/kmem";
		bin_type =  coff_bin(dynixV);
		if (bin_type == -1) {
			printf("crash: cannot open file '%s'\n", dynixV);
			fflush(stderr); fflush(stdout);
			exit(1);
		} else if (bin_type == 0) {
			printf("unix file '%s' is not COFF file?\n", dynixV);
			fflush(stderr); fflush(stdout);
			exit(1);
		}
	}

	printf("Version %s of %s\n", Version, Date); 
	fflush(stdout);

	if ((unixfd = open(dynixV, 0)) < 0) {
		printf("crash: cannot open unix file '%s'\n", dynixV);
		fflush(stderr); fflush(stdout);
		exit(1);
	}
	if ((vmcorefd = open(vmcore, 0)) < 0) {
		printf("crash: cannot open vmcore file '%s'\n", vmcore);
		fflush(stderr); fflush(stdout);
		exit(1);
	}

	/* Is it live or Memorex? */
	if (strcmp(vmcore, "/dev/mem") == 0 ||
	    fstat(vmcorefd, &sbuf) == 0 && (sbuf.st_mode & S_IFMT) == S_IFCHR) {
		printf("Warning: running on a LIVE system.\n");
		if (swap == NULL)
			swap = "/dev/swap";
		if ((swapfd = open(swap, 0)) < 0) {
			printf("crash: cannot open swap file '%s'\n", swap);
			fflush(stderr); fflush(stdout);
			exit(1);
		}
		live = 1;
	} else {
	}

	for(ip = initfuns; ip->i_fun ; ip++) (*ip->i_fun)();
	input[0] = stdin;
	filter[0] = NULL;
	nest = 0;

	if (Etext == 0 || (unsigned)Etext > 600*1024)
		printf("Warning: etext == %#x, must be HUGE.\n", Etext);

	/*
	 * Signals set up with "signal()" are not reset after a signal
	 * so we use POSIX implementation.
	 */

	(void) sigemptyset(&act.sa_mask);
	(void) sigaddset(&act.sa_mask, SIGINT);
	act.sa_flags = 0;
	act.sa_handler = (void(*)()) sigint;
	if (sigaction(SIGINT, &act, NULL) != 0)
		fatal("main(): sigaction(SIGINT,) failed");

	(void) sigemptyset(&act.sa_mask);
	(void) sigaddset(&act.sa_mask, SIGSEGV);
	act.sa_flags = 0;
	act.sa_handler = (void(*)()) ouch;
	if (sigaction(SIGSEGV, &act, NULL) != 0)
		fatal("main(): sigaction(SIGSEGV,) failed");

	(void) sigemptyset(&act.sa_mask);
	(void) sigaddset(&act.sa_mask, SIGPIPE);
	act.sa_flags = 0;
	act.sa_handler = (void(*)()) onpipe;
	if (sigaction(SIGPIPE, &act, NULL) != 0)
		fatal("main(): sigaction(SIGPIPE,) failed");

	(void) sigemptyset(&act.sa_mask);
	(void) sigaddset(&act.sa_mask, SIGALRM);
	act.sa_flags = 0;
	act.sa_handler = (void(*)()) sigalrm;
	if (sigaction(SIGALRM, &act, NULL) != 0)
		fatal("main(): sigaction(SIGALRM,) failed");

/*	signal(SIGINT, sigint);		*/
/*	signal(SIGSEGV, ouch);		*/
/*	signal(SIGPIPE, onpipe);	*/

#ifdef	ns32000
	dis32000_init(0, Disread, addr_str, 1);
#endif
#ifdef	i386
#ifdef CROSS
	dis386_init(0, Disread, addr_str, 1);
#else
	dis386_init(Disread, 0, 0, addr_str, 0, 0, 0, 1);
#endif
#endif

	if (!live) {
		time_t t;
		readv(search("time"), &t, sizeof (time_t));
		printf("System crashed at: %.24s\n", ctime(&t));
	}

	(void) sigemptyset(&set);
	(void) sigaddset(&set, SIGINT);
	(void) sigaddset(&set, SIGSEGV);
	(void) sigaddset(&set, SIGPIPE);

	(void) setjmp(jmp);

	/*
	 * Presently missing routines "sigsetjmp()" and "siglongjmp()" so
	 * now have to unblock the signals after a longjmp.
	 */

	if (sigprocmask(SIG_UNBLOCK, &set, NULL) != 0)
		fatal("main: sigprocmask() failed");

	for(;;) {
		c = token();
		if (c == NULL)
			continue;
		if (debug[17])
			printf("c = token() = '%s'\n", c);
		for (tp = t; tp->t_snm; tp++) {
			if (debug[17])
				printf("tp->t_snm = '%s', c = '%s', strlen = %d\n",
				  tp->t_snm, c, strlen(tp->t_snm));
			if (strncmp(tp->t_snm, c, strlen(tp->t_snm)) == 0)
				break;
		}
		if ( tp->t_snm && tp->t_fun )
			(*tp->t_fun)();
		else
			printf("Huh?\n");
		tok = 0;
	}
}

sigint()
{
	tok = 0;
	printf("\nInterrupt!\n");
	fflush(stdout);
	if (source == TRUE) {
		unwind();
	}
	longjmp(jmp, 1);
}

	
unwind()
{
	int	i;

	for (i=1; i<nest; i++){
		if (xdebug)
			fprintf(stderr,"uwind form %d\n",nest);
		if (input[nest])
			fclose(input[nest]);
		input[nest] = NULL;
		if (filter[nest])
			pclose(filter[nest]);
		input[nest] = NULL;
	};
	if (filter[0])
		pclose(filter[0]);
	filter[0] = NULL;
	output = stdout;
	nest = 0;
	source = FALSE;
}

sigalrm()
{
	To = 1;
}

ouch()
{
	int	fltaddr;

	tok = 0;
	sigcontext(SF_SEGVCODE,&fltaddr);
	printf("Ouch!, take off hoser. 0x%x\n",fltaddr);
	fflush(stdout);
	longjmp(jmp, 1);
}

onpipe()
{
	tok = 0;
	longjmp(jmp, 1);
}

char pline[512];

char *
token()
{
	char  *cp;
	static char line[512];
	static char askline[512];
	static char *p;
	char 	    *pp;
	int	    n;

	while( tok == 0 ) {
		if (filter[nest] != NULL) {
			if (xdebug)
				fprintf(stderr,"filer[%d] closes\n",nest);
			(void) pclose(filter[nest]);
			filter[nest] = NULL;
			if (nest)
				output = filter[nest-1];
			else
				output = stdout;
		}
		if (source == FALSE) {
			printf("> "); 
			fflush(stdout);
		}
		if ( Eve && (To==0) ) {
			alarm(Eve);
		}
		if(fgets(p = line, sizeof line, input[nest]) == NULL) {
			if ( Eve && To ) {
				strcpy(p, pline);
				fprintf(stderr, "%s", p);
				To=0;
			} else {
				if (source == TRUE) {
					fclose(input[nest]);
					if (filter[nest]) {
						pclose(filter[nest]);
						filter[nest] = NULL;
						if (nest)
							output = filter[nest-1];
						else
							output = stdout;
					}
					if (--nest == 0) {
						source = FALSE;
					}
					if (xdebug)
						fprintf(stderr,"nest=%d\n",nest);
					continue;
				}
				return("quit");
			}
		}
		alarm(0);
		if (xdebug && source == TRUE)
			fprintf(stderr, "+ %s", p);
		if (strncmp(p, "!!", 2) == 0) {
			if (strlen(p)+strlen(pline) >= sizeof line) {
				printf("line too long\n");
				continue;
			}
			strcpy(pline+strlen(pline)-1, p+2);
			strcpy(p, pline);
			fprintf(stderr, "%s", p);
		} else 
			if (p[0] != '\n')
				strcpy(pline, p);	/* salt away current command */
		
		if (*p == '!') {		/* shell escape */
			system(&line[1]);
			continue;
		}
		if (*p == '\033') { /* local esacpe sequence */
			continue;
		}
		/*
		 * Check for "|" into a shell command line
		 */
		pp = p;
		while ((pp = strchr(pp, '|')) != NULL) {
			if (!isspace(pp[-1])) {
				++pp; continue;
			}
			*pp = 0;
			if (xdebug)
				fprintf(stderr,"filt[%d]=%s\n",nest,pp+1);
			filter[nest] = popen(pp+1, "w");
			if (filter[nest] == NULL) {
				printf("crash: can't pipe to %s\n", pp+1);
				fflush(stdout);
				tok = 0;
			} else {
				output = filter[nest];
			}
		}
		if (*p == '"') {
			pp = p;
			while (*p != '\n') {
				++p;
				if (*p == '"')
					break;
			}
			if ((*p == '\n') || (*(p+1) == '\n')) {
				*p++ = '\0';
				printf("%s\n",pp+1);
			} else {
				*p++ = '\0';
				printf("%s\" ",pp);
			}
		}
		if (*p == '.') {	/* source file */
			p++;
			if (!isspace(*p)) {
				fprintf(stderr,"'.' command must be followed by white space\n");
				continue;
			}
			while (*p != '\n' && isspace(*p)) ++p;
			if (*p == '\n') {
				fprintf(stderr, "source what?\n");
				continue;
			}
			pp = p;
			while (*p != '\n' && !isspace(*p)) ++p;
			if (*p != '\n') {
				*p = '\0';
				p++;
			} else
				*p = '\0';
			if (nest >= MAXNEST) {
				fprintf(stderr, "source nesting too deep\n");
				unwind();
				continue;
			}
			source = TRUE;
			nest++;
			if (xdebug)
				fprintf(stderr,"open nest=%d = %s\n",nest,pp);
			if ((input[nest] = fopen(pp, "r")) == NULL) {
				fprintf(stderr, "can't source %s\n", pp);
				unwind();
			}
			continue;
		} 
		tok = 1;
	}
	cp = NULL;
	for(;;) {
		switch(*p) {
		case '\n':
			*p = '\0';
		case '\0':
			if (cp == NULL)
				tok = 0;
			break;

		case ' ':
		case '\t':
			*p++ = '\0';
			if (cp == NULL)
				continue;
			break;

		case '@':
			pp = p+1;
			if (cp != NULL) {
				n = p-cp;
				cp = strncpy(askline, cp, n); 
			} else 
				n = 0;
			p = &askline[n];
			(void)fgets(p, 512-n, stdin);
			strcpy(strchr(p,'\n'), pp);
			strcat(p, "\n");
			continue;

		default:
			if (cp == NULL)
				cp = p;
			++p;
			continue;
		}
		return(cp);
	}
}

fatal(str)
{
	printf("crash: %s\n", str);
	fflush(stderr); fflush(stdout);
	exit(1);
}

int paniced;
char *panicstr;
char *version;

heuristics()
{
	char buf1[512];
	char buf2[512];
	register i,j;
	register char *p;
	char c;
	long loc;

	/*
	 * Locate kernel version in kernel
	 */
	memset(buf1, 0, sizeof buf1);
	memset(buf2, 0, sizeof buf2);
	version = (char *)search("version");
	if (version == NULL)
		printf("Warning: No 'version' symbol in symbol table!\n");
	else {
		loc = (long) version - data_start + data_offset;
		lseek(unixfd, loc, 0);
		if (read(unixfd, buf1, sizeof (buf1)-1) != sizeof (buf1)-1)
			printf("Warning: read error on unix version string\n");
		lseek(vmcorefd, (long) version, 0);
		if (read(vmcorefd, buf2, sizeof (buf2)-1) != sizeof (buf2)-1) 
			printf("Warning: read error on vmcore version string\n");
		buf1[strlen(buf1)-1] = '\0';
		buf2[strlen(buf2)-1] = '\0';
		if (buf1[0] == '\0' || buf2[0] == '\0')
			printf("Warning: version string NULL, memory probably zero'ed or dump taken incorrectly\n");
		else if (strcmp(buf1, buf2) != 0) {
			printf("Warning: version string mismatch:\n");
			printf("\t unix: %s\n", buf1);
			printf("\tvmcore: %s\n", buf2);
		} else
			printf("Version: %s\n", buf1);
	}

	/*
	 * Locate panic string in kernel
	 */
	memset(buf1, 0, sizeof buf1);
	if (!live && readv(search("panicstr"), &panicstr, sizeof panicstr) == sizeof panicstr) {
		if (panicstr == NULL)
			printf("Warning: panicstr is NULL\n");
		else {
			paniced = 1;
			for (j=i=0; j < sizeof buf1; i++,j += strlen(p)) {
				if (readv(panicstr+i, &c, 1) != 1 || c == 0)
					break;
				strcat(&buf1[j], p = nice_char(c));
			}
			if (j < sizeof buf1)
				printf("Panicstr: %s\n", buf1);
		}
	}

	get_locore();
}

/* Suppport for extended debugging. */

set_debug(p)
	char *p;
{
	char buf[512];

	p += 2;			/* skip "-D" */

	if (*p && *p >= '0' && *p <= '9') {
		scan_debug(p);
		if (debug[13])
			add_names();
		return;
	}

loop:
	printf("\ndebug on? (y/n/h/#) [n]: ");
	(void) gets(buf);
	if (buf[0] == 'n' || buf[0] == 'N' || buf[0] == '\0') {
		return;
	} else if (buf[0] == 'h'|| buf[0] == 'H') {
		show_debug_list();
		goto loop;
	} else if (buf[0] == 'y' || buf[0] == 'Y') {
		buf[0] = '\0';
		printf("Enter debug list: ");
		(void) gets(buf);
		if (buf[0] > '0' && buf[0] < '9') {
			scan_debug(buf);
			if (debug[13])
				add_names();
			return;
		} else
			goto loop;
	} else if (buf[0] >= '0' && buf[0] <= '9') {
		scan_debug(buf);
		if (debug[13])
			add_names();
		return;
	} else
		goto loop;
}

/*
 * Lifted from existing code, this parses a string for numbers.
 * Strings may contain blank or comma separated numbers, and
 * an inclusive list to be indicated with a dash.
 *
 *    0 1 2 3 5 6
 *    0-3 5 6
 *    0-3,5,6
 */

scan_debug(s)
	char *s;
{
	register char *p;
	char *q;
	register int n;
	register int i;
	int f;

	p = s;
	for (;;) {
		n = f = 0;
		/* check for '0' to '9' */
		if (*p < '0' || *p > '9') {
			printf("Don't understand: %s\n", s);
			printf("                  ");
			q = s;
			while (*q != *p) {
				putchar(' ');
				q++;
			}
			printf("^\n");
			return;
		}
		/* decode number */
		while (*p >= '0' && *p <= '9') {
			n = (n * 10) + ((int) (*p - '0')) ;
			p++;
		}
		/* make sure legal range */
		if (n >= MAX_DEBUG) {
			printf("Debug range is 0 to %d\n", MAX_DEBUG - 1);
			return;
		}
		/* terminate if done */
		if (!*p) {
			debug[n] = ( debug[n] ? 0 : 1 );
			return;
		}
		/* loop if separator */
		if (*p == ' ' || *p == ',') {
			debug[n] = ( debug[n] ? 0 : 1 );
			p++;
			while(*p == ' ')
				p++;
			continue;
		}
		/* must be '-' for inclusive range */
		if (*p != '-') {
			printf("Don't understand: %s\n",s);
			printf("                  ");
			q = s;
			while (*q != *p) {
				putchar(' ');
				q++;
			}
			printf("^\n");
			return;
		}
		f = n;
		n = 0;
		p++;
		/* check for '0' to '9' */
		if (*p < '0' || *p > '9') {
			printf("Expeced number: %s\n", s);
			printf("                ");
			q = s;
			while (*q != *p) {
				putchar(' ');
				q++;
			}
			printf("^\n");
			return;
		}
		/* decode number */
		while (*p >= '0' && *p <= '9') {
			n = (n * 10) + ((int) (*p - '0')) ;
			p++;
		}
		/* make sure legal range */
		if (n >= MAX_DEBUG) {
			printf("Debug range is 0 to %d\n", MAX_DEBUG - 1);
			return;
		}
		for (i = f; i <= n; i++)
			debug[i] = ( debug[i] ? 0 : 1 );
		/* see if done */
		if (!*p)
			return;
	}
}

char *dbg_msg[] = {
"0  - informative messages",
"1  - process() - unsorted ptr list of globals - by name",
"2  - process() - unsorted ptr list of dbg",
"3  - process() - sorted ptr list of globals - by name",
"4  - process() - sorted ptr list of dbg",
"5  - cmpsymbyval() - show value comparisons",
"6  - cmpsymbynam() - show name comparisons",
"7  - cmpsdbbynam() - show sdb name comparisons",
"8  - sym_add() - show name/val added",
"9  - sym_add_dbg() - show sdb name/val added",
"10 - mallocs - show mallocs and reallocs",
"11 - look_dupname() - show searches",
"12 - look_dupsdb() - show searches",
"13 - search for names read from symbol table",
"14 - display duplicate symbol names",
"15 - trace expression parsing",
"16 - trace proc table",
"17 - trace token parsing",
"18 - display warnings for failed symbol search",
"19 - trace stack trace code (printstacktrace)\n",
0
};

show_debug_list()
{
	char **p;
	int i = 0;

	p = dbg_msg;
	while (*p) {
		if (debug[i++])
			printf("+ ");
		else
			printf("  ");
		printf("%s\n", *p);
		p++;
	}
}

add_names()
{
	int i;
	char *save_name();
	char buf[512];

	printf("Enter symbol names for debug, return only to stop.\n");
	for (i=0 ;i < MAX_CHECK; i++)
		name_buf[i] = "";

	for (i=0 ; i < MAX_CHECK; i++) {
		printf("Name %d: ", i);
		gets(buf);
		if (buf[0] == '\0')
			return;
		name_buf[i] = save_name(buf);
	}

}

#ifdef CROSS
char *
index(sp, c)
register char *sp, c;
{
	do {
		if (*sp == c)
			return(sp);
	} while (*sp++);
	return(0);
}
#endif
