# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: cron.mk 1.9 89/11/08 $@(#)cron:cron.mk	1.24"

INS=cpset

ROOT=
OL=$(ROOT)/
ETC=$(OL)etc
USR=$(OL)usr
INSDIR=$(OL)usr/bin
SPL=$(USR)/spool
SPOOL=$(USR)/spool/cron
LIB=$(USR)/lib

CRONLIB=$(LIB)/cron
CRONSPOOL=$(SPOOL)/crontabs
ATSPOOL=$(SPOOL)/atjobs

XDIRS= $(ROOT) $(ETC) $(USR) $(INSDIR) $(LIB) $(SPL) $(SPOOL)\
      $(CRONLIB) $(CRONSPOOL) $(ATSPOOL)

DIRS= $(SPL) $(SPOOL) $(CRONLIB) $(CRONSPOOL) $(ATSPOOL)

LINKOBS= libelm.a funcs.o permit.o
CMDS= cron at crontab batch logchecker

CFLAGS= -O
LDFLAGS= -s -lseq -lgen
LDLIBS=
DEFS=

.c.o:
	$(CC) $(CFLAGS) $(DEFS) -c $<

all:	linkobs cmds

install:	all install_cron install_at install_crontab install_batch install_logchecker

# removed dirs from install rule

linkobs: $&	$(LINKOBS)
 
cmds: $&	$(CMDS)

#	$(MAKE) -f cron.mk INS="install -f" $(ARGS)

install_cron:	cron
	$(INS) -o cron $(ETC) 500 root sys

install_at:	at
	$(INS) at $(INSDIR) 4555 root bin

install_crontab:	crontab
	$(INS) crontab $(INSDIR) 4555 root bin

install_batch:	batch
	$(INS) batch $(INSDIR) 555 bin bin

install_logchecker:	logchecker
	$(INS) logchecker $(CRONLIB) 544 root sys

libelm.a: elm.o
	$(AR) cr libelm.a elm.o

cron:	cron.o funcs.o libelm.a
	$(CC) $(CFLAGS) cron.o funcs.o libelm.a -o cron $(LDFLAGS)

crontab:	crontab.o permit.o funcs.o
	$(CC) $(CFLAGS) crontab.o permit.o funcs.o -o crontab $(LDFLAGS)

at:	at.o att1.o att2.o funcs.o permit.o
	$(CC) $(CFLAGS) at.o att1.o att2.o funcs.o permit.o -o at $(LDFLAGS)

batch:	batch.sh
	cp batch.sh batch

logchecker:	logchecker.sh
	cp logchecker.sh logchecker

att1.c att1.h:	att1.y
	yacc -d att1.y
	mv y.tab.c att1.c
	mv y.tab.h att1.h

att2.c:	att2.l
	lex att2.l
	ed - lex.yy.c < att2.ed
	mv lex.yy.c att2.c

att2.o:	att1.h

cron.o:	cron.c cron.h
crontab.o:	crontab.c cron.h
at.o:	at.c cron.h

dirs:	$(DIRS)

$(DIRS):
	-if [ "$(OL)" = "/" ]; \
		then mkdir $@; chmod 755 $@; chgrp sys $@; chown root $@; \
	fi

clean:
	rm -f *.o libelm.a att1.h att1.c att2.c

clobber:	clean
	rm -f $(LINKOBJS) $(CMDS)
