
#
# $Copyright:	$
#Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
#Sequent Computer Systems, Inc.   All rights reserved.
# 
#This software is furnished under a license and may be used
#only in accordance with the terms of that license and with the
#inclusion of the above copyright notice.   This software may not
#be provided or otherwise made available to, or used by, any
#other person.  No title to or ownership of the software is
#hereby transferred.

#
#ident	$Header: csh.mk 1.13 90/03/06 $
#

ROOT =

DIR = $(CCS_ROOT)/bin

INC = $(CCS_HDRS)/usr/include

LDFLAGS = -s $(LDLIBS)

STRIP = strip

SIZE = size

#
# Copyright (c) 1980 Regents of the University of California.
# All rights reserved.  The Berkeley Software License Agreement
# specifies the terms and conditions for redistribution.
#
#	@(#)Makefile	5.10 (Berkeley) 5/19/88
#
# C Shell with process control; VM/UNIX VAX Makefile
# Bill Joy UC Berkeley; Jim Kulp IIASA, Austria
#
# To profile, put -DPROF in DEFS and -pg in CFLAGS, and recompile.

DEFS=	-DTELL -DVFORK 
#DEFS=	-DTELL -DVFORK -DFILEC
#DEFS=	-DTELL         -DFILEC
CFLAGS=	${DEFS} -O
#CFLAGS=	${DEFS} -g
XSTR=	./misc/xstr

SRCS=	alloc.c doprnt.c sh.c sh.char.c sh.dir.c sh.dol.c sh.err.c \
	sh.exec.c sh.exp.c sh.file.c sh.func.c sh.glob.c sh.hist.c \
	sh.init.c sh.lex.c sh.misc.c sh.parse.c sh.print.c sh.proc.c \
	sh.sem.c sh.set.c sh.time.c support.c
OBJS=	alloc.o doprnt.o sh.o sh.char.o sh.dir.o sh.dol.o sh.err.o \
	sh.exec.o sh.exp.o sh.file.o sh.func.o sh.glob.o sh.hist.o \
	sh.init.o sh.lex.o sh.misc.o sh.parse.o sh.print.o sh.proc.o \
	sh.sem.o sh.set.o sh.time.o support.o

# Special massaging of C files for sharing of strings
.c.o:
	${CC} -E ${CFLAGS} $*.c | ${XSTR} -c -
	${CC} -c ${CFLAGS} x.c 
	mv -f x.o $*.o
	rm -f x.c

# strings.o must be last since it can change when previous files compile
csh: ${XSTR} ${OBJS} strings.o
	${CC} ${CFLAGS} ${OBJS} strings.o -o $@ -s -lseq

# strings.o, sh.init.o, and sh.char.o are specially processed to be shared
strings.o: strings
	${XSTR}
	${CC} -Wc,-seq -c  xs.c
	mv -f xs.o strings.o
	rm -f xs.c

sh.char.o sh.init.o:
	${CC} -E ${CFLAGS} $*.c | ${XSTR} -c -
	${CC} ${CFLAGS} -c x.c
	mv -f x.o $*.o
	rm -f x.c

./misc/xstr:	./misc/xstr.c
	/bin/cc -o ./misc/xstr ./misc/xstr.c

clean:
	rm -f a.out strings strings.o x.c xs.c csh errs
	rm -f ${OBJS}
	rm -f ./misc/xstr

clobber:
	rm -f a.out strings strings.o x.c xs.c csh errs
	rm -f ${OBJS}
	rm -f ./misc/xstr

depend:
	mkdep ${CFLAGS} ${SRCS}

lint:
	lint ${CFLAGS} ${SRCS}

install: csh
	install -u bin -g root -m 555 -f ${DIR} csh

tags:
	ctags ${SRCS}

print:
	@pr READ_ME
	@pr Makefile Makefile.*
	@(size -l a.out; size *.o) | pr -h SIZES
	@${CXREF} sh*.c | pr -h XREF
	@ls -l | pr 
	@pr sh*.h [a-rt-z]*.h sh*.c alloc.c

vprint:
	@pr -l84 READ_ME TODO
	@pr -l84 Makefile Makefile.*
	@(size -l a.out; size *.o) | pr -l84 -h SIZES
	@${CXREF} sh*.c | pr -l84 -h XREF
	@ls -l | pr -l84
	@${CXREF} sh*.c | pr -l84 -h XREF
	@pr -l84 sh*.h [a-rt-z]*.h sh*.c alloc.c

FRC:

#vgrind:
#	@cp /dev/null index
#	@-mkdir grind
#	for i in *.h; do ${VGRIND} -t -h "C Shell" $$i >grind/$$i.t; done
#	for i in *.c; do ${VGRIND} -t -h "C Shell" $$i >grind/$$i.t; done
#	${VGRIND} -t -x -h Index index >grind/index.t

# DO NOT DELETE THIS LINE -- mkdep uses it.
# DO NOT PUT ANYTHING AFTER THIS LINE, IT WILL GO AWAY.

