# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#ident "$Header: devbuild.mk 1.3 89/03/29 $"

# devbuild makefile

INS = install
INSDIR = $(ROOT)/etc 
BUILDDIR = $(ROOT)/etc/devbuild.d
LDFLAGS = -O -s
LIBS = -lmalloc -lseq

SRCS = devbuild.c devdestroy.c cmpt.c vtoc.c

# programs which do the actual building
BUILDERS = cmpt vtoc

all:$& devbuild devdestroy $(BUILDERS)

devbuild: devbuild.c
	$(CC) $(LDFLAGS) -o devbuild devbuild.c $(LIBS)

devdestroy: devdestroy.c
	$(CC) $(LDFLAGS) -o devdestroy devdestroy.c $(LIBS)

cmpt: cmpt.c
	$(CC) $(LDFLAGS) -o cmpt cmpt.c

vtoc: vtoc.c
	$(CC) $(LDFLAGS) -o vtoc vtoc.c

install: all
	$(INS) -u root -g sys -f $(INSDIR) -o devbuild $(INSDIR)
	$(INS) -u root -g sys -f $(INSDIR) -o devdestroy $(INSDIR)
	$(INS) -u root -g sys -m 444 -f $(BUILDDIR) -o cmpt.types $(BUILDDIR)
	-for  f in $(BUILDERS) ;\
	 do \
		 $(INS) -u root -g sys -f $(BUILDDIR) -o $$f $(BUILDDIR) ; \
	 done

lint:
	-for f in $(SRCS) ;\
	 do $(LINT) $(INCLUDE) $$f ;\
	 done

clean:
	-rm -f *.o

clobber: clean
	-rm -f devbuild devdestroy $(BUILDERS)
