# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: macros.mk 1.3 89/10/10 $@(#)macros:macros.mk	1.58"
#	text Development Support Library (DSL) macros make file
#
# DSL 2

OL = $(ROOT)/
LIST = lp
INS = :
MINSLIB = $(OL)usr/lib/macros
TINSLIB = $(OL)usr/lib/tmac
TMACFILES = tmac.an tmac.m tmac.ptx tmac.v
MAKE = make

compile all: $&	mmn mmt vmca ptx tmac man

mmn: $&	mmn.src strings.mm
	sh ./macrunch mmn ;\
	$(INS) mmn $(MINSLIB) ;\
	cd $(MINSLIB); chmod 444 mmn; $(CH) chgrp bin mmn; chown bin mmn

strings.mm: $&	strings.mm.src
	sh ./macrunch strings.mm ;\
	$(INS) strings.mm $(MINSLIB) ;\
	cd $(MINSLIB); chmod 444 strings.mm; $(CH) chgrp bin strings.mm; chown bin strings.mm

mmt: $&	mmt.src strings.mm
	sh ./macrunch mmt ;\
	$(INS) mmt $(MINSLIB) ;\
	cd $(MINSLIB); chmod 444 mmt; $(CH) chgrp bin mmt; chown bin mmt

vmca: $&	vmca.src
	sh ./macrunch vmca ;\
	$(INS) vmca $(MINSLIB) ;\
	cd $(MINSLIB); chmod 444 vmca; $(CH) chgrp bin vmca; chown bin vmca

man: $&	an.src
	sh ./macrunch an ;\
	$(INS) an $(MINSLIB) ;\
	cd $(MINSLIB); chmod 444 an; $(CH) chgrp bin an; chown bin an

ptx: $&	ptx.src
	sh ./macrunch ptx ;\
	$(INS) ptx $(MINSLIB) ;\
	cd $(MINSLIB); chmod 444 ptx; $(CH) chgrp bin ptx; chown bin ptx

tmac:	$(TMACFILES)
	$(INS) $(TMACFILES) $(TINSLIB); \
	cd $(TINSLIB); chmod 444 $(TMACFILES); $(CH) chgrp bin $(TMACFILES); chown bin $(TMACFILES)

listing:    listmmn listmmt listvmca listman listptx

listmmn: ;  nl -ba mmn.src | pr -h "mmn.src" | $(LIST)
	    macref -s -t mmn.src | pr -h "macref of mmn.src" | $(LIST)
listmmt: ;  nl -ba mmt.src | pr -h "mmt.src" | $(LIST)
	    macref -s -t mmt.src | pr -h "macref of mmt.src" | $(LIST)
listvmca: ; nl -ba vmca.src | pr -h "vmca.src" | $(LIST)
	    macref -s -t vmca.src | pr -h "macref of vmca.src" | $(LIST)
listman: ;  nl -ba an.src | pr -h "an.src" | $(LIST)
	    macref -s -t an.src | pr -h "macref of an.src" | $(LIST)
listptx: ;  nl -ba ptx.src | pr -h "ptx.src" | $(LIST)
	    macref -s -t ptx.src | pr -h "macref of ptx.src" | $(LIST)

install:
	$(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH)

insmmn:  ;  $(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH) mmn
insmmt:  ;  $(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH) mmt
insvmca: ;  $(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH) vmca
insman: ;  $(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH) man
insptx:  ;  $(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH) ptx
insstrings.mm:	;  $(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH) strings.mm
instmac: ;  $(MAKE) -f macros.mk INS=cp ROOT=$(ROOT) CH=$(CH) tmac

clean mmnclean mmtclean vmcaclean ptxclean stringsclean:

clobber:  clean mmnclobber mmtclobber vmcaclobber \
		ptxclobber stringsclobber manclobber

mmnclobber:  ;  rm -f mmn
mmtclobber:  ;  rm -f mmt
vmcaclobber: ;  rm -f vmca
ptxclobber:  ;  rm -f ptx
manclobber:  ;  rm -f an
stringsclobber:	;  rm -f strings.mm
