# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: ed.mk 1.8 90/03/19 $@(#)ed:ed.mk	1.19"

#	Makefile for ed

ROOT =

DIR = $(ROOT)/bin
DESDIR = $(CRYPT_ROOT)/bin

INC = $(CCS_HDRS)/usr/include

IFLAG = -n
LDFLAGS = -s -lw -lgen $(IFLAG) $(LDLIBS) 
DESLDFLAGS = -s -lcrypt -lw -lgen $(IFLAG) $(LDLIBS) 

B10 =
CFLAGS = -O $(B10)

STRIP = strip

SIZE = size

MAKEFILE = ed.mk

MAINS = ed DESed

OBJECTS =  ed.o 

SOURCES =  ed.c

ALL:		$(MAINS)
	-if [ "$(EXPORT)" != "" ]; then \
		cp ed.c export$$;\
		unifdef -UCRYPT export$$ > ed.c;\
		rm -f export$$;\
	else \
		:; \
	fi

ed:		ed.c \
		$(INC)/regexp.h $(INC)/stdio.h \
		 $(INC)/signal.h $(INC)/sys/signal.h \
		 $(INC)/sys/types.h $(INC)/sys/stat.h \
		 $(INC)/termio.h $(INC)/sys/termio.h \
		 $(INC)/ustat.h $(INC)/setjmp.h 
	$(CC) $(CFLAGS)  -o ed  ed.c   $(LDFLAGS)

DESed:
	-if [ "$(DES)" != "" ]; then \
		$(CRYPT_CC) $(CFLAGS)  -DCRYPT -o DESed  ed.c   $(DESLDFLAGS);\
	fi

GLOBALINCS = $(INC)/regexp.h $(INC)/setjmp.h \
	$(INC)/signal.h $(INC)/stdio.h $(INC)/sys/signal.h \
	$(INC)/sys/stat.h $(INC)/sys/termio.h \
	$(INC)/sys/types.h $(INC)/termio.h $(INC)/ustat.h 


clean:
	rm -f $(OBJECTS)

clobber:
	rm -f $(OBJECTS) $(MAINS)


all : ALL

install: ALL
	cpset ed $(DIR)
	rm -f $(DIR)/red
	ln $(DIR)/ed $(DIR)/red
	-if [ "$(DES)" != "" ]; then \
		cpset DESed $(DESDIR)/ed;\
		rm -f $(DESDIR)/red;\
		ln $(DESDIR)/ed $(DESDIR)/red;\
	fi

size: ALL
	$(SIZE) $(MAINS)

strip: ALL
	$(STRIP) $(MAINS)

#	These targets are useful but optional

partslist:
	@echo $(MAKEFILE) $(SOURCES) $(LOCALINCS)  |  tr ' ' '\012'  |  sort

productdir:
	@echo $(DIR) | tr ' ' '\012' | sort

product:
	@echo $(MAINS)  |  tr ' ' '\012'  | \
	sed 's;^;$(DIR)/;'

srcaudit:
	@fileaudit $(MAKEFILE) $(LOCALINCS) $(SOURCES) -o $(OBJECTS) $(MAINS)
