# $Copyright:	$
# Copyright (c) 1984, 1985 Sequent Computer Systems, Inc.
# All rights reserved
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

# $Header: fsck.mk 1.3 89/07/06 $
#
INS = install
INSDIR = $(ROOT)/etc
OBJS=	dir.o inode.o main.o pass1.o pass1b.o pass2.o pass3.o \
	pass4.o pass5.o setup.o utilities.o preen.o ufs_subr.o \
	ufs_tables.o

CFILES=	dir.c inode.c main.c pass1.c pass1b.c pass2.c pass3.c \
	pass4.c pass5.c setup.c utilities.c preen.c ufs_subr.c \
	ufs_tables.c

INC = $(CCS_HDRS)/usr/include
CFLAGS = -O -Wc,-seq
LDFLAGS = -s

ALL:	fsck

fsck:&	${OBJS}
	${CC} ${CFLAGS} ${LDFLAGS} -o fsck ${OBJS} -lseq

dir.o:		$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/sys/ufsdir.h $(INC)/memory.h fsck.h

inode.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/sys/ufsdir.h $(INC)/pwd.h $(INC)/memory.h fsck.h

main.o:		$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/sys/uadmin.h $(INC)/sys/boot.h \
		$(INC)/sys/stat.h $(INC)/sys/wait.h $(INC)/mntent.h \
		$(INC)/signal.h $(INC)/string.h fsck.h

pass1.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/memory.h fsck.h

pass1b.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/memory.h fsck.h

pass2.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/sys/ufsdir.h $(INC)/string.h $(INC)/memory.h fsck.h

pass3.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h  \
		$(INC)/memory.h fsck.h

pass4.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/memory.h fsck.h

pass5.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/memory.h fsck.h

setup.o:	$(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/ufsinode.h $(INC)/sys/ufsfilsys.h \
		$(INC)/sys/stat.h $(INC)/sys/ioctl.h \
		$(INC)/sys/vtoc.h $(INC)/sys/fcntl.h \
		$(INC)/ctype.h $(INC)/memory.h $(INC)/memory.h fsck.h

utilities.o:	$(INC)/sys/types.h $(INC)/sys/param.h $(INC)/sys/ufsinode.h \
		$(INC)/sys/ufsfilsys.h $(INC)/sys/ufsdir.h $(INC)/stdio.h \
		$(INC)/ctype.h $(INC)/memory.h $(INC)/memory.h $(INC)/signal.h \
		fsck.h

preen.o:	$(INC)/stdio.h $(INC)/sys/types.h $(INC)/sys/param.h \
		$(INC)/sys/stat.h $(INC)/ctype.h $(INC)/errno.h \
		$(INC)/fcntl.h $(INC)/string.h

ufs_subr.o:	$(INC)/sys/param.h $(INC)/sys/systm.h $(INC)/sys/vfs.h \
		$(INC)/sys/mount.h $(INC)/sys/ufsfilsys.h $(INC)/sys/conf.h \
		$(INC)/sys/buf.h $(INC)/sys/ufsinode.h $(INC)/sys/ufsdir.h \
		$(INC)/sys/user.h

ufs_tables.o:	$(INC)/sys/param.h

install:	ALL
	$(INS) -m 555 -u root -g sys -f $(INSDIR) -o fsck $(INSDIR)

clean:
	rm -f ${OBJS}

clobber:
	rm -f fsck ${OBJS} errs core

lint:
	$(LINT) $(CFILES) -lseq
