# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984, 1987 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: help.mk 1.7 90/05/02 $@(#)help:help.mk	1.13"
#       help makefile

ROOT	= 
BIN	= $(ROOT)/usr/bin
ADM	= $(ROOT)/etc
LIB	= $(ROOT)/usr/lib/help
DB	= $(LIB)/db
TMP	= /usr/tmp
CFLAGS	= -O -s
INS	= install -f

all: $&		help interact keysrch fetch helpadm admstart admgloss \
		editcmd defnlen checklen locking glossary

interact:	interact.c switch.h
	$(CC) $(CFLAGS) -o interact interact.c -lcurses

fetch:		fetch.c fetch.h
	cc $(CFLAGS) -o replace fetch.c $(TOOLS)/lib/libld.a ;\
	$(CC) $(CFLAGS) -o fetch fetch.c -lld

db: 	install_fetch
	for file in descriptions examples options glossary screens screensfoot;\
	do						 \
		(					 \
		rm -rf $(TMP)/$$file			;\
		mkdir $(TMP)/$$file			;\
		cp db/$$file/* $(TMP)/$$file		;\
		$(CH)chmod 444 $(TMP)/$$file/*		;\
		$(CH)chgrp bin $(TMP)/$$file/*		;\
		$(CH)chown root $(TMP)/$$file/*		;\
		./replace $(TMP)/$$file.a $(TMP)/$$file/*	;\
		rm -rf $(TMP)/$$file			;\
		)					&\
	done; wait


install: $&	all install_interact install_fetch install_help \
		install_keysrch install_helpadm install_db log install_glossary

install_fetch:	fetch lib
	@rm -f $(LIB)/fetch $(LIB)/list $(LIB)/extract \
		$(LIB)/delete $(LIB)/replace		;\
	$(INS) $(LIB) fetch				;\
	ln $(LIB)/fetch $(LIB)/list			;\
	ln $(LIB)/fetch $(LIB)/extract			;\
	ln $(LIB)/fetch $(LIB)/delete			;\
	ln $(LIB)/fetch $(LIB)/replace

install_interact:	interact lib
	@rm -f $(LIB)/interact				;\
	$(INS) $(LIB) interact

install_help:	help
	@rm -f $(BIN)/help $(BIN)/glossary $(BIN)/locate \
		$(BIN)/starter $(BIN)/usage		;\
	$(INS) $(BIN) help				;\
	ln $(BIN)/help $(BIN)/glossary			;\
	ln $(BIN)/help $(BIN)/locate			;\
	ln $(BIN)/help $(BIN)/starter			;\
	ln $(BIN)/help $(BIN)/usage

install_keysrch:	keysrch lib
	@rm -f $(LIB)/keysrch				;\
	$(INS) $(LIB) keysrch

install_glossary:	glossary lib
	@rm -f $(LIB)/glossary				;\
	$(INS) $(LIB) glossary

install_helpadm:	helpadm admgloss admstart \
			checklen defnlen editcmd locking lib
	@rm -f $(ADM)/helpadm $(LIB)/admstart $(LIB)/admgloss \
		$(LIB)/editcmd $(LIB)/defnlen $(LIB)/checklen $(LIB)/locking ;\
	$(INS) $(ADM) -m 554 helpadm			;\
	$(INS) $(LIB) -m 554 admstart			;\
	$(INS) $(LIB) -m 554 admgloss			;\
	$(INS) $(LIB) -m 554 editcmd			;\
	$(INS) $(LIB) -m 554 defnlen			;\
	$(INS) $(LIB) -m 554 checklen			;\
	$(INS) $(LIB) -m 554 locking

install_db:	db lib daba tables install_tables install_dot_a

install_tables:
	for file in display keywords responses; do \
		(					 \
		rm -f $(DB)/tables/$$file		;\
		cp db/tables/$$file $(DB)/tables/$$file	;\
		$(CH)chmod 444 $(DB)/tables/$$file	;\
		$(CH)chgrp bin $(DB)/tables/$$file	;\
		$(CH)chown root $(DB)/tables/$$file	;\
		)					&\
	done; wait

install_dot_a:
	for file in descriptions examples options glossary screens screensfoot;\
	do						 \
		(					 \
		rm -f $(DB)/$$file			;\
		mv $(TMP)/$$file.a $(DB)/$$file.a	;\
		$(CH)chmod 444 $(DB)/$$file.a		;\
		$(CH)chgrp bin $(DB)/$$file.a		;\
		$(CH)chown root $(DB)/$$file.a		;\
		)					&\
	done; wait

log:
	> $(LIB)/HELPLOG				;\
	$(CH)chmod 555 $(LIB)/HELPLOG			;\
	$(CH)chgrp bin $(LIB)/HELPLOG			;\
	$(CH)chown bin $(LIB)/HELPLOG			;\
	$(INS) $(LIB) -u bin -g bin helpclean

lib:
	-[ -d $(LIB) ] || mkdir $(LIB)			;\
	$(CH)chgrp sys $(LIB)				;\
	$(CH)chown root $(LIB)

daba:
	-[ -d $(DB) ] || mkdir $(DB)			;\
	$(CH)chmod 775 $(DB)				;\
	$(CH)chgrp bin $(DB)				;\
	$(CH)chown root $(DB)

tables:
	-[ -d $(DB)/tables ] || mkdir $(DB)/tables	;\
	$(CH)chmod 775 $(DB)/tables			;\
	$(CH)chgrp bin $(DB)/tables			;\
	$(CH)chown root $(DB)/tables

clobber:	clean
		-rm -f *.o ./replace

clean:
	rm -f help display fetch interact keysrch helpadm glossary \
		admgloss admstart checklen defnlen editcmd locking

.PRECIOUS:	help.sh keysrch.sh interact.c fetch.c helpadm.sh glossary.sh


