# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident  "$Header: adm.mk 1.21 90/02/13 $@(#).adm.mk	1.16 - 87/04/18"

ROOT =
LIB = $(ROOT)/usr/lib
CRONTABS = $(ROOT)/usr/spool/cron/crontabs
LIBCRON = $(LIB)/cron
INSDIR = $(ROOT)/etc
DEVDIR = $(ROOT)/dev
TOUCH=/bin/touch

CRON_ENT= adm root sys sysadm lp

CRON_LIB= proto at.allow at.deny cron.allow cron.deny queuedefs

ETC_SCRIPTS= checklist cleanup dumpdates gettydefs \
	issue motd shadow profile csh.login TIMEZONE nodename passwd group

DEV_SCRIPTS= MAKEDEV

all:$&	etc_scripts crontab cronlib devscripts

crontab:$& $(CRON_ENT)

cronlib:$& $(CRON_LIB)

etc_scripts:$& $(ETC_SCRIPTS)

devscripts:$& $(DEV_SCRIPTS)

clean:

clobber: clean

install:
	make -f adm.mk $(ARGS)

adm::
	cp adm $(CRONTABS)/adm;\
	$(CH)chmod 644 $(CRONTABS)/adm;\
	$(CH)chgrp sys $(CRONTABS)/adm;\
	$(TOUCH) 0101000070 $(CRONTABS)/adm;\
	$(CH)chown root $(CRONTABS)/adm

root::
	cp root $(CRONTABS)/root;\
	$(CH)chmod 644 $(CRONTABS)/root;\
	$(CH)chgrp sys $(CRONTABS)/root;\
	$(TOUCH) 0101000070 $(CRONTABS)/root;\
	$(CH)chown root $(CRONTABS)/root

sys::
	cp sys $(CRONTABS)/sys;\
	$(CH)chmod 644 $(CRONTABS)/sys;\
	$(CH)chgrp sys $(CRONTABS)/sys;\
	$(TOUCH) 0101000070 $(CRONTABS)/sys;\
	$(CH)chown root $(CRONTABS)/sys

sysadm::
	cp sysadm $(CRONTABS)/sysadm;\
	$(CH)chmod 644 $(CRONTABS)/sysadm;\
	$(CH)chgrp sys $(CRONTABS)/sysadm;\
	$(TOUCH) 0101000070 $(CRONTABS)/sysadm;\
	$(CH)chown root $(CRONTABS)/sysadm

lp::
	cp lp $(CRONTABS)/lp;\
	$(CH)chmod 644 $(CRONTABS)/lp;\
	$(CH)chgrp sys $(CRONTABS)/lp;\
	$(TOUCH) 0101000070 $(CRONTABS)/lp;\
	$(CH)chown root $(CRONTABS)/lp

proto::
	cp proto $(LIBCRON)/.proto;\
	$(CH)chmod 744 $(LIBCRON)/.proto;\
	$(CH)chgrp sys $(LIBCRON)/.proto;\
	$(TOUCH) 0101000070 $(LIBCRON)/.proto;\
	$(CH)chown root $(LIBCRON)/.proto

at.allow::
	cp at.allow $(LIBCRON)/at.allow;\
	$(CH)chmod 644 $(LIBCRON)/at.allow;\
	$(CH)chgrp sys $(LIBCRON)/at.allow;\
	$(TOUCH) 0101000070 $(LIBCRON)/at.allow;\
	$(CH)chown root $(LIBCRON)/at.allow

at.deny::
	cp at.deny $(LIBCRON)/at.deny;\
	$(CH)chmod 644 $(LIBCRON)/at.deny;\
	$(CH)chgrp sys $(LIBCRON)/at.deny;\
	$(TOUCH) 0101000070 $(LIBCRON)/at.deny;\
	$(CH)chown root $(LIBCRON)/at.deny

cron.allow::
	cp cron.allow $(LIBCRON)/cron.allow;\
	$(CH)chmod 644 $(LIBCRON)/cron.allow;\
	$(CH)chgrp sys $(LIBCRON)/cron.allow;\
	$(TOUCH) 0101000070 $(LIBCRON)/cron.allow;\
	$(CH)chown root $(LIBCRON)/cron.allow

cron.deny::
	cp cron.deny $(LIBCRON)/cron.deny;\
	$(CH)chmod 644 $(LIBCRON)/cron.deny;\
	$(CH)chgrp sys $(LIBCRON)/cron.deny;\
	$(TOUCH) 0101000070 $(LIBCRON)/cron.deny;\
	$(CH)chown root $(LIBCRON)/cron.deny

queuedefs::
	cp queuedefs $(LIBCRON)/queuedefs;\
	$(CH)chmod 644 $(LIBCRON)/queuedefs;\
	$(CH)chgrp sys $(LIBCRON)/queuedefs;\
	$(TOUCH) 0101000070 $(LIBCRON)/queuedefs;\
	$(CH)chown root $(LIBCRON)/queuedefs

checklist::
	cp checklist $(INSDIR)/checklist;\
	$(CH)chmod 664 $(INSDIR)/checklist;\
	$(CH)chgrp sys $(INSDIR)/checklist;\
	$(TOUCH) 0101000070 $(INSDIR)/checklist;\
	$(CH)chown root $(INSDIR)/checklist

cleanup::
	cp cleanup $(INSDIR)/cleanup;\
	$(CH)chmod 555 $(INSDIR)/cleanup;\
	$(CH)chgrp sys $(INSDIR)/cleanup;\
	$(CH)chown root $(INSDIR)/cleanup

dumpdates::
	cp dumpdates $(INSDIR)/dumpdates;\
	$(CH)chmod 664 $(INSDIR)/dumpdates;\
	$(CH)chgrp sys $(INSDIR)/dumpdates;\
	$(TOUCH) 0101000070 $(INSDIR)/dumpdates;\
	$(CH)chown root $(INSDIR)/dumpdates

gettydefs::
	cp gettydefs $(INSDIR)/gettydefs;\
	$(CH)chmod 644 $(INSDIR)/gettydefs;\
	$(CH)chgrp sys $(INSDIR)/gettydefs;\
	$(TOUCH) 0101000070 $(INSDIR)/gettydefs;\
	$(CH)chown root $(INSDIR)/gettydefs

group::
	cp group $(INSDIR)/group;\
	$(CH)chmod 644 $(INSDIR)/group;\
	$(CH)chgrp 3 $(INSDIR)/group;\
	$(TOUCH) 0101000070 $(INSDIR)/group;\
	$(CH)chown 0 $(INSDIR)/group

issue::
	cp issue $(INSDIR)/issue;\
	$(CH)chmod 444 $(INSDIR)/issue;\
	$(CH)chgrp sys $(INSDIR)/issue;\
	$(TOUCH) 0101000070 $(INSDIR)/issue;\
	$(CH)chown root $(INSDIR)/issue

motd::
	cp motd $(INSDIR)/motd;\
	$(CH)chmod 644 $(INSDIR)/motd;\
	$(CH)chgrp sys $(INSDIR)/motd;\
	$(TOUCH) 0101000070 $(INSDIR)/motd;\
	$(CH)chown root $(INSDIR)/motd

passwd::
	cp passwd $(INSDIR)/passwd;\
	$(CH)chmod 644 $(INSDIR)/passwd;\
	$(CH)chgrp 3 $(INSDIR)/passwd;\
	$(TOUCH) 0101000070 $(INSDIR)/passwd;\
	$(CH)chown 0 $(INSDIR)/passwd

shadow::
	cp shadow $(INSDIR)/shadow;\
	$(CH)chmod 400 $(INSDIR)/shadow;\
	$(CH)chgrp sys $(INSDIR)/shadow;\
	$(TOUCH) 0101000070 $(INSDIR)/shadow;\
	$(CH)chown root $(INSDIR)/shadow

profile::
	cp profile $(INSDIR)/profile;\
	$(CH)chmod 444 $(INSDIR)/profile;\
	$(CH)chgrp sys $(INSDIR)/profile;\
	$(CH)chown root $(INSDIR)/profile

csh.login::
	cp csh.login $(INSDIR)/csh.login;\
	$(CH)chmod 444 $(INSDIR)/csh.login;\
	$(CH)chgrp sys $(INSDIR)/csh.login;\
	$(CH)chown root $(INSDIR)/csh.login

TIMEZONE::
	cp TIMEZONE $(INSDIR)/TIMEZONE;\
	$(CH)chmod 444 $(INSDIR)/TIMEZONE;\
	$(CH)chgrp sys $(INSDIR)/TIMEZONE;\
	$(CH)chown root $(INSDIR)/TIMEZONE

nodename::
	cp nodename $(INSDIR)/nodename;\
	$(CH)chmod 644 $(INSDIR)/nodename;\
	$(CH)chgrp sys $(INSDIR)/nodename;\
	$(CH)chown root $(INSDIR)/nodename

MAKEDEV::
	cp MAKEDEV $(DEVDIR)/MAKEDEV;\
	$(CH)chmod 755 $(DEVDIR)/MAKEDEV;\
	$(CH)chgrp sys $(DEVDIR)/MAKEDEV;\
	$(CH)chown root $(DEVDIR)/MAKEDEV
