# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: initpkg.mk 1.10 89/10/10 $@(#)initpkg:./initpkg.mk	1.11"

ROOT =
INSDIR = $(ROOT)/etc
TOUCH=$(CH)/bin/touch
MAKE=make

SCRIPTS= bcheckrc devtab inittab fstab powerfail mountall rc0 rc1 rc2 rc3 \
	shutdown umountall
DIRECTORIES= rc0.d rc2.d rc3.d adm

all:	init.d scripts $& directories
	echo "**** initpkg.mk complete ****"

scripts:$& $(SCRIPTS)

directories:$& $(DIRECTORIES)

clean:

clobber: clean
	rm -f $(SCRIPTS)

install:
	$(MAKE) -f initpkg.mk $(ARGS)

bcheckrc::
	
	sh bcheckrc.sh $(ROOT);\
	cp bcheckrc $(INSDIR)/bcheckrc;\
	$(CH)chmod 744 $(INSDIR)/bcheckrc;\
	$(CH)chgrp sys $(INSDIR)/bcheckrc;\
	$(TOUCH) 0101000070 $(INSDIR)/bcheckrc;\
	$(CH)chown root $(INSDIR)/bcheckrc

# This entry has been removed from SCRIPTS
brc::
	sh brc.sh $(ROOT);\
	cp brc $(INSDIR)/brc;\
	$(CH)chmod 744 $(INSDIR)/brc;\
	$(CH)chgrp sys $(INSDIR)/brc;\
	$(TOUCH) 0101000070 $(INSDIR)/brc;\
	$(CH)chown root $(INSDIR)/brc

fstab::
	sh fstab.sh  $(ROOT);\
	cp fstab $(INSDIR)/fstab;\
	$(CH)chmod 664 $(INSDIR)/fstab;\
	$(CH)chgrp sys $(INSDIR)/fstab;\
	$(TOUCH) 0101000070 $(INSDIR)/fstab;\
	$(CH)chown root $(INSDIR)/fstab

devtab::
	sh devtab.sh $(ROOT);\
	cp devtab $(INSDIR)/devtab;\
	$(CH)chmod 644 $(INSDIR)/devtab;\
	$(CH)chgrp sys $(INSDIR)/devtab;\
	$(TOUCH) 0101000070 $(INSDIR)/devtab;\
	$(CH)chown root $(INSDIR)/devtab

inittab::
	sh inittab.sh $(ROOT);\
	cp inittab $(INSDIR)/inittab;\
	$(CH)chmod 444 $(INSDIR)/inittab;\
	$(CH)chgrp bin $(INSDIR)/inittab;\
	$(TOUCH) 0101000070 $(INSDIR)/inittab;\
	$(CH)chown bin $(INSDIR)/inittab

powerfail::
	sh powerfail.sh $(ROOT);\
	cp powerfail $(INSDIR)/powerfail;\
	$(CH)chmod 555 $(INSDIR)/powerfail;\
	$(CH)chgrp sys $(INSDIR)/powerfail;\
	$(TOUCH) 0101000070 $(INSDIR)/powerfail;\
	$(CH)chown root $(INSDIR)/powerfail

mountall::
	sh mountall.sh $(ROOT);\
	cp mountall $(INSDIR)/mountall;\
	$(CH)chmod 555 $(INSDIR)/mountall;\
	$(CH)chgrp sys $(INSDIR)/mountall;\
	$(TOUCH) 0101000070 $(INSDIR)/mountall;\
	$(CH)chown root $(INSDIR)/mountall

rc0::
	sh rc0.sh $(ROOT);\
	cp rc0 $(INSDIR)/rc0;\
	$(CH)chmod 744 $(INSDIR)/rc0;\
	$(CH)chgrp sys $(INSDIR)/rc0;\
	$(TOUCH) 0101000070 $(INSDIR)/rc0;\
	$(CH)chown root $(INSDIR)/rc0

rc1::
	sh rc1.sh $(ROOT);\
	cp rc1 $(INSDIR)/rc1;\
	$(CH)chmod 744 $(INSDIR)/rc1;\
	$(CH)chgrp sys $(INSDIR)/rc1;\
	$(TOUCH) 0101000070 $(INSDIR)/rc1;\
	$(CH)chown root $(INSDIR)/rc1

rc2::
	sh rc2.sh $(ROOT);\
	cp rc2 $(INSDIR)/rc2;\
	$(CH)chmod 744 $(INSDIR)/rc2;\
	$(CH)chgrp sys $(INSDIR)/rc2;\
	$(TOUCH) 0101000070 $(INSDIR)/rc2;\
	$(CH)chown root $(INSDIR)/rc2

rc3::
	sh rc3.sh $(ROOT);\
	cp rc3 $(INSDIR)/rc3;\
	$(CH)chmod 744 $(INSDIR)/rc3;\
	$(CH)chgrp sys $(INSDIR)/rc3;\
	$(TOUCH) 0101000070 $(INSDIR)/rc3;\
	$(CH)chown root $(INSDIR)/rc3

shutdown::
	sh shutdown.sh $(ROOT);\
	cp shutdown $(INSDIR)/shutdown;\
	$(CH)chmod 755 $(INSDIR)/shutdown;\
	$(CH)chgrp sys $(INSDIR)/shutdown;\
	$(TOUCH) 0101000070 $(INSDIR)/shutdown;\
	$(CH)chown root $(INSDIR)/shutdown

umountall::
	sh umountall.sh $(ROOT);\
	cp umountall $(INSDIR)/umountall;\
	$(CH)chmod 555 $(INSDIR)/umountall;\
	$(CH)chgrp sys $(INSDIR)/umountall;\
	$(TOUCH) 0101000070 $(INSDIR)/umountall;\
	$(CH)chown root $(INSDIR)/umountall

init.d::
	cd ./init.d; \
	ROOT=$(ROOT) $(SH) :mk.init.d.sh

rc0.d::	
	cd ./rc0.d; \
	ROOT=$(ROOT) $(SH) :mk.rc0.d.sh

rc2.d::	
	cd ./rc2.d; \
	ROOT=$(ROOT) $(SH) :mk.rc2.d.sh

rc3.d::	
	cd ./rc3.d; \
	ROOT=$(ROOT) $(SH) :mk.rc3.d.sh

adm::	
	cd ./adm; \
	$(MAKE) -f adm.mk all
