#! /bin/sh

# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: rc0.sh 1.16 90/04/25 $@(#)initpkg:./rc0.sh	1.15"

if u3b2 || i386
then
cat > rc0 <<'ENDRC0'
#! /bin/sh
#	"Run Commands" for init state 0
#	Leaves the system in a state where it is safe to turn off the power
#	or go to firmware.


echo 'The system is coming down.  Please wait.'

#	The following segment is for historical purposes.
#	There should be nothing in /etc/shutdown.d.
if [ -d /etc/shutdown.d ]
then
	for f in /etc/shutdown.d/*
	{
		if [ -s $f ]
		then
			/bin/sh ${f}
		fi
	}
fi
#	End of historical section

if [ -d /etc/rc0.d ]
then
	for f in /etc/rc0.d/K*
	{
		if [ -s ${f} ]
		then
			/bin/sh ${f} stop
		fi
	}

#	system cleanup functions ONLY (things that end fast!)	

	for f in /etc/rc0.d/S*
	{
		if [ -s ${f} ]
		then
			/bin/sh ${f} start
		fi
	}
fi

trap "" 15
# send SIGTERM to ALL processes
kill -15 -1
sleep 5
/etc/killall 9

#
# Install a new kernel if one has been created and queued.
#
MADEUNIX=/etc/.madeunix
if [ -f $MADEUNIX ]; then
	unix_tbi=`cat $MADEUNIX`
	if [ -x "$unix_tbi" ]; then
		echo "\nInstalling $unix_tbi as /unix"

		#
		# If the file is not on the root filesystem already,
		# make sure there is enough space to copy it in.
		# 
		unixdev=`/etc/devnm $unix_tbi | cut -f1 -d' '`
		rootdev=`/etc/devnm / | cut -f1 -d' '`

		spaceok=true
		if [ $unixdev != $rootdev ]; then

			unixsz=`/bin/ls -s $unix_tbi |
				sed 's/\([0-9]*\).*/\1/`
			free=`df -S / |
				sed 's/.*:[ 	]*\([0-9]*\).*/\1/'`
			# remember /unix.prev will be overwritten
			if [ -f /unix.prev ]; then
				prevsz=`/bin/ls -s /unix.prev |
					sed 's/\([0-9]*\).*/\1/`
				free=`expr $free + $prevsz`
			fi
			if [ $unixsz -le $free ]; then
				rm -f /unix.prev
				newname=/unix.`uname`.TBI
				cp $unix_tbi $newname
				if [ $? -ne 0 ]; then
					spaceok=false
				else
					unix_tbi=$newname
				fi
			else
				spaceok=false
			fi
		fi

		#
		# save the current /unix file and install
		# locally created kernel as /unix
		#
		if [ $spaceok = true ]; then
			mv /unix /unix.prev
			mv $unix_tbi /unix
			rm -f $MADEUNIX
			echo "\tprevious /unix saved as /unix.prev"
		else
			echo "\tNOT ENOUGH SPACE TO INSTALL '`cat $MADEUNIX`'."
			need=`expr $unixsz - $free`
			echo "\t$need \c"
			echo "blocks must be free in / to succeed."
		fi
	else
		echo "\tFILE ($unix_tbi) NOT FOUND, NOT INSTALLED AS /unix."
	fi
fi
sync;sync;sync
/etc/umountall -f 4.2

# Now remove the partitioning drivers, but be aware
# that some swap devices may be busy.
/etc/devdestroy -a 2>&1 | grep -v 'some partition is currently in use'

sync;  sync
echo "\nThe system is down."
sync
ENDRC0
fi
