# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: lint.mk 1.18 90/10/22 $@(#)lint:lint.mk	1.22"
ROOT=
FLG =
ULIB = $(ROOT)/usr/lib
INS = install
LINT1=$(TOOLS)/lib/lint/lint1
TMPDIR = /usr/tmp
LFLAGS = $(LDFLAGS)
FRC =
#lint libraries
LNLIBS =  llib-lc.ln llib-port.ln llib-lm.ln llib-lseq.ln llib-lpps.ln llib-lnsl.ln
#object files for the first and second passes
OFILES1 = trees.o pftn.o scan.o comm1.o messages.o optim.o xdefs.o cgram.o\
	lerror.o msgbuf.o lint.o inline.o
OFILES2 = lpass2.o lerror2.o messages2 msgbuf2.o
CMD	= lint
TARGET1	= $P$N$(CMD)1
TARGET2	= $P$N$(CMD)2
M	= $(MAKE) -f $(CMD).mk
C	= CCS=-DCCS=1 N=ccs
X	= P=x CC=cc "`cat DEFS`" 

native		:; $M clean all
nativeccs	:; $M $C clean all
cross		:; $M $X clean all
crossccs	:; $M $X $C clean all
cross crossccs	:  DEFS
everything	:  native nativeccs cross crossccs clean
#################################################################
#  we have to be real careful to not undef something to		#
#  cpp that we may want to define again since it is "sticky"	#
#################################################################
DEFS		:FRC
		  -if [ "$(NATIVE)" != "$(MACHINE)" ]; then \
			echo "DEF=-U$$(NATIVE) -D$$(MACHINE) -Dsequent" >DEFS; \
		  else \
			echo "DEF=" >DEFS ; \
		  fi


all:$&	$(LNLIBS)

#makes for the lint libraries
llib-lc.ln:  llib-lc $(LINT1) $(FRC)
	$(CC) $(INCLUDE) -E -C -Dlint llib-lc | $(LINT1) -vx -H$(TMPDIR)/hlint.c >llib-lc.ln 
	rm $(TMPDIR)/hlint.c
llib-port.ln:  llib-port $(LINT1) $(FRC)
	$(CC) $(INCLUDE) -E -C -Dlint llib-port | $(LINT1) -vxp -H$(TMPDIR)/hlint.port  >llib-port.ln
	rm $(TMPDIR)/hlint.port  
llib-lm.ln:  llib-lm $(LINT1) $(FRC)
	$(CC) $(INCLUDE) -E -C -Dlint llib-lm | $(LINT1) -vx -H$(TMPDIR)/hlint.m >llib-lm.ln
	rm $(TMPDIR)/hlint.m
llib-lseq.ln:  llib-lseq $(LINT1) $(FRC)
	$(CC) $(INCLUDE) -E -C -Dlint llib-lseq | $(LINT1) -vx -H$(TMPDIR)/hlint.seq  >llib-lseq.ln
	rm $(TMPDIR)/hlint.seq  
llib-lpps.ln:  llib-lpps $(LINT1) $(FRC)
	$(CC) $(INCLUDE) -E -C -Dlint llib-lpps | $(LINT1) -vx -H$(TMPDIR)/hlint.pps  >llib-lpps.ln
	rm $(TMPDIR)/hlint.pps  
llib-lnsl.ln:  llib-lnsl $(LINT1) $(FRC)
	$(CC) $(INCLUDE) -E -C -Dlint llib-lnsl | $(LINT1) -vx -H$(TMPDIR)/hlint.nsl  >llib-lnsl.ln
	rm $(TMPDIR)/hlint.nsl  

#miscellaneous utilities

# to reinstall libraries after clobber has been used, try :
#	make inslibs LINT1=/usr/lib/lint1
#  (this uses the installed version of lint pass 1)
inslibs:$& $(LNLIBS)
	$(INS) -m 444 -n $(ULIB) llib-lc
	$(INS) -m 444 -n $(ULIB) llib-lc.ln
	$(INS) -m 444 -n $(ULIB) llib-port
	$(INS) -m 444 -n $(ULIB) llib-port.ln
	$(INS) -m 444 -n $(ULIB) llib-lm
	$(INS) -m 444 -n $(ULIB) llib-lm.ln
	$(INS) -m 444 -n $(ULIB) llib-lnsl
	$(INS) -m 444 -n $(ULIB) llib-lnsl.ln
	$(INS) -m 444 -n $(ULIB) llib-lseq
	$(INS) -m 444 -n $(ULIB) llib-lseq.ln
	$(INS) -m 444 -n $(ULIB) llib-lpps
	$(INS) -m 444 -n $(ULIB) llib-lpps.ln
install:clean all inslibs

clean:
	rm -f $(LNLIBS) DEFS
clobber:
	rm -f $(LNLIBS) DEFS
FRC:
