/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: mclose_fifo.c 1.2 89/10/10 $@(#)nlp:lib/msgs/mclose_fifo.c	1.3"

#include "errno.h"

#include "lp.h"
#include "msgs.h"

extern int		Sched_fifo,
			My_fifo;

extern char		*My_fifo_path;

extern char		*malloc();

extern void		free();

int			mclose_is_running	= 0;

/*
** mclose() - CLOSE A MESSAGE PATH THAT USES FIFOS
*/

int
mclose ()
{
    char	*msgbuf = 0;
    int		size;


    mclose_is_running = 1;

    if (Sched_fifo != -1)
    {
	size = putmessage((char *)0, S_GOODBYE);
	if ((msgbuf = malloc((unsigned)size)))
	{
	    (void)putmessage (msgbuf, S_GOODBYE);
	    (void)msend (msgbuf);
	    free (msgbuf);
	}

	(void) Close (Sched_fifo);
	Sched_fifo = -1;
    }

    if (My_fifo != -1)
    {
	(void) _Close (My_fifo);
	My_fifo = -1;
    }

    if (My_fifo_path)
    {
	(void) _Unlink (My_fifo_path);
	free (My_fifo_path);
	My_fifo_path = 0;
    }	

    mclose_is_running = 0;
    return (0);
}
