# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984, 1986, 1987, 1988 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#	Copyright (c) 1987, 1988 Microsoft Corporation
#	  All Rights Reserved

#	This Module contains Proprietary Information of Microsoft 
#	Corporation and should be treated as Confidential.

#ident	"$Header: more.mk 1.2 89/10/10 $@(#)more:more.mk	1.2"

ROOT =

#	Where MAINS are to be installed.
INSDIR = $(ROOT)/usr/bin
LIBDIR	= $(ROOT)/usr/lib

INC = $(CCS_HDRS)/usr/include

CFLAGS = -O -I$(INC)

#	Common Libraries and -l<lib> flags.
LDFLAGS = -s -lgen -lcurses -lPW $(LDLIBS)

STRIP = strip

#top#

MAKEFILE = more.mk


MAINS = more

OBJECTS =  more.o

SOURCES =  more.c

DATA = more.help

ALL:		$(MAINS)

more:		more.o	
	$(CC) $(CFLAGS)  -o more  more.o   $(LDFLAGS)


more.o:	 $(INC)/sys/types.h $(INC)/utmp.h	\
		 $(INC)/signal.h	$(INC)/sys/signal.h \
		 $(INC)/pwd.h $(INC)/stdio.h \
		 $(INC)/sys/stat.h $(INC)/dirent.h $(INC)/sys/dirent.h \
		 $(INC)/sys/utsname.h $(INC)/sys/param.h \
		 $(INC)/errno.h $(INC)/sys/errno.h \
		 $(INC)/fcntl.h 

clean:
	rm -f $(OBJECTS)
	
clobber:	
	rm -f $(OBJECTS) $(MAINS)

newmakefile:
	makefile -m -f $(MAKEFILE) -s INC $(INC)
#bottom#

save:
	cd $(INSDIR); set -x; for m in $(MAINS); do  cp $$m OLD$$m; done
	cd $(LIBDIR); set -x; for m in $(DATA); do  cp $$m OLD$$m; done

restore:
	cd $(INSDIR); set -x; for m in $(MAINS); do; cp OLD$$m $$m; done
	cd $(LIBDIR); set -x; for m in $(DATA); do; cp OLD$$m $$m; done

install:	$(MAINS) $(INSDIR)
	cpset $(MAINS) $(INSDIR) 0555 bin bin
	cpset $(DATA) $(LIBDIR) 0444 bin bin

strip:
	$(STRIP) $(MAINS)

remove:
	cd $(INSDIR);  rm -f $(MAINS)
	cd $(LIBDIR);  rm -f $(DATA)

$(INSDIR):
	mkdir $(INSDIR);  chmod 755 $(INSDIR);  chown bin $(INSDIR)
	mkdir $(LIBDIR);  chmod 755 $(LIBDIR);  chown bin $(LIBDIR)

partslist:
	@echo $(MAKEFILE) $(LOCALINCS) $(SOURCES)  |  tr ' ' '\012'  |  sort

product:
	@echo $(MAINS)  |  tr ' ' '\012'  | \
		sed -e 's;^;$(INSDIR)/;' -e 's;//*;/;g'

productdir:
	@echo $(INSDIR)
