# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.
#

#ident	"$Header: quota.mk 1.4 89/03/28 $"

# quotas make file

ROOT =
INC = $(CCS_HDRS)/usr/include
BINDIR = $(ROOT)/bin
ETCDIR = $(ROOT)/etc
LIST = lp
CFLAGS = -s -O
LIBS = -lseq
INS = install
FRC =
MAINS = quota edquota quotacheck quotaon repquota

all: $&	$(MAINS)

install:	all
	$(INS) -f $(BINDIR) -m 555 quota
	$(INS) -f $(ETCDIR) -m 555 -u root -g sys edquota
	$(INS) -f $(ETCDIR) -m 555 -u root -g sys quotacheck
	$(INS) -f $(ETCDIR) -m 555 -u root -g sys quotaon
	ln $(ETCDIR)/quotaon $(ETCDIR)/quotaoff
	$(INS) -f $(ETCDIR) -m 555 -u root -g sys repquota


edquota:	$(INC)/stdio.h\
	$(INC)/signal.h\
	$(INC)/errno.h\
	$(INC)/pwd.h\
	$(INC)/ctype.h\
	$(INC)/mntent.h\
	$(INC)/sys/types.h\
	$(INC)/sys/param.h\
	$(INC)/sys/stat.h\
	$(INC)/sys/fcntl.h\
	$(INC)/sys/file.h\
	$(INC)/sys/ufsquota.h\
	edquota.c
	$(CC) $(CFLAGS) -o edquota edquota.c $(LIBS)

quota:	$(INC)/stdio.h\
	$(INC)/mntent.h\
	$(INC)/ctype.h\
	$(INC)/pwd.h\
	$(INC)/errno.h\
	$(INC)/fcntl.h\
	$(INC)/sys/types.h\
	$(INC)/sys/param.h\
	$(INC)/sys/file.h\
	$(INC)/sys/stat.h\
	$(INC)/sys/ufsquota.h\
 \
	quota.c
	$(CC) $(CFLAGS) -o quota quota.c $(LIBS)
#	$(INC)/rpc/rpc.h\
#	$(INC)/rpc/pmap_prot.h\
#	$(INC)/sys/socket.h\
#	$(INC)/netdb.h\
#	$(INC)/rpcsvc/rquota.h

quotacheck:	$(INC)/stdio.h\
	$(INC)/ctype.h\
	$(INC)/signal.h\
	$(INC)/errno.h\
	$(INC)/sys/types.h\
	$(INC)/sys/param.h\
	$(INC)/sys/vnode.h\
	$(INC)/sys/ufsinode.h\
	$(INC)/sys/ufsfilsys.h\
	$(INC)/sys/ufsquota.h\
	$(INC)/sys/stat.h\
	$(INC)/sys/wait.h\
	$(INC)/mntent.h\
	$(INC)/pwd.h\
	quotacheck.c
	$(CC) $(CFLAGS) -o quotacheck quotacheck.c $(LIBS)

quotaon:	$(INC)/sys/types.h\
	$(INC)/sys/param.h\
	$(INC)/sys/file.h\
	$(INC)/sys/ufsquota.h\
	$(INC)/stdio.h\
	$(INC)/mntent.h\
	$(INC)/string.h\
	quotaon.c
	$(CC) $(CFLAGS) -o quotaon quotaon.c $(LIBS)

repquota:	$(INC)/stdio.h\
	$(INC)/errno.h\
	$(INC)/sys/types.h\
	$(INC)/sys/param.h\
	$(INC)/sys/ufsquota.h\
	$(INC)/sys/stat.h\
	$(INC)/mntent.h\
	$(INC)/pwd.h\
	repquota.c
	$(CC) $(CFLAGS) -o repquota repquota.c $(LIBS)

rpc.rquotad:	$(INC)/stdio.h\
	$(INC)/mntent.h\
	$(INC)/sys/param.h\
	$(INC)/sys/time.h\
	$(INC)/sys/socket.h\
	$(INC)/sys/stat.h\
	$(INC)/sys/file.h\
	$(INC)/ufs/quota.h\
	$(INC)/rpc/rpc.h\
	$(INC)/rpcsvc/rquota.h\
	$(INC)/syslog.h\
	rpc.rquotad.c
	$(CC) $(CFLAGS) -o rpc.rquotad rpc.rquotad.c $(LIBS)
	
lintall:
	$(LINT) $(LIBS)	edquota.c
	$(LINT) $(LIBS) quota.c
	$(LINT) $(LIBS) quotacheck.c
	$(LINT) $(LIBS) quotaon.c
	$(LINT) $(LIBS) repquota.c
listing:
	pr quota.mk quota.c edquota.c quotacheck.c quotaon.c repquota.c \
		| $(LIST)

clean:
	-rm -f *.o

clobber: clean
	rm -f $(MAINS)

