# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: sa.mk 1.2 89/10/10 $"

# 	Makefile for sar and friends

# how to use this makefile
# to make sure all files  are up to date: make -f sa.mk all
#
# to force recompilation of all files: make -f sa.mk all FRC=FRC 
#
# The sadc module must be able to read /dev/kmem,
# which standardly has restricted read permission.
# It must have set-group-ID mode
# and have the same group as /dev/kmem.
# The chmod and chgrp commmands below ensure this.
#

INC = $(CCS_HDRS)/usr/include

ROOT =
TESTDIR = .
FRC =
INS = install
INSDIR = $(ROOT)/usr/lib/sa
CRONDIR= $(ROOT)/usr/spool/cron/crontabs
CRONTAB= $(ROOT)/usr/spool/cron/crontabs/sys
ENTRY1= '0 * * * 0-6 /usr/lib/sa/sa1'
ENTRY2= '20,40 8-17 * * 1-5 /usr/lib/sa/sa1'
ENTRY3= '5 18 * * 1-5 /usr/lib/sa/sa2 -s 8:00 -e 18:01 -i 1200 -A'

COMMANDS= sadc sar sa1 sa2 perf timex sag

CFLAGS = -O

FFLAG =
LDFLAGS = -s

all:	$& $(COMMANDS)


sadc:	sadc.c sa.h 
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/sadc sadc.c -lseq

sar:	sar.c sa.h
	$(CC) $(FFLAG) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/sar sar.c

sa2:	sa2.sh
	cp sa2.sh sa2

sa1:	sa1.sh
	cp sa1.sh sa1

 
perf:	perf.sh
	cp perf.sh perf

timex:	timex.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/timex timex.c 

sag:	$& saga.o sagb.o
	$(CC) $(FFLAG) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/sag saga.o sagb.o 

saga.o:	saga.c saghdr.h
	$(CC) -c $(CFLAGS) saga.c

sagb.o:	sagb.c saghdr.h
	$(CC) -c $(CFLAGS) sagb.c

$(INSDIR):

$(CRONDIR):

$(CRONTAB):

lint:
	$(LINT) $(CFLAGS) sadc.c -lseq
	$(LINT) $(CFLAGS) sar.c
	$(LINT) $(CFLAGS) saga.c sagb.c
	$(LINT) $(CFLAGS) timex.c

install: all $(INSDIR) $(CRONDIR) $(CRONTAB)
	$(INS) -o -f $(INSDIR) -m 2555 -g sys $(TESTDIR)/sadc
	$(INS) -f $(ROOT)/usr/bin $(TESTDIR)/sar 
	$(INS) -f $(INSDIR) $(TESTDIR)/sa2
	$(INS) -f $(INSDIR) $(TESTDIR)/sa1
	$(INS) -f $(ROOT)/etc/init.d -u root -g sys -m 444 $(TESTDIR)/perf
	$(INS) -f $(ROOT)/usr/bin -g sys $(TESTDIR)/timex
	$(INS) -f $(ROOT)/usr/bin $(TESTDIR)/sag
	rm -rf $(ROOT)/etc/rc2.d/S21perf
	ln $(ROOT)/etc/init.d/perf $(ROOT)/etc/rc2.d/S21perf
	$(CH)if [ -f $(CRONTAB) ];\
	$(CH)	then  if grep "sa1" $(CRONTAB) >/dev/null 2>&1 ; then :;\
	$(CH)	else\
	$(CH)		echo $(ENTRY1) >> $(CRONTAB);\
	$(CH)		echo $(ENTRY2) >> $(CRONTAB);\
	$(CH)	fi;\
	$(CH)	if grep "sa2" $(CRONTAB) >/dev/null 2>&1 ; then :;\
	$(CH)	else\
	$(CH)		echo $(ENTRY3) >> $(CRONTAB);\
	$(CH)	fi;\
	$(CH)fi;

clean:
	-rm -f *.o

clobber:	clean
		-rm -f $(COMMANDS)

FRC:
