/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/* 	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: timex.c 1.3 89/10/10 $"

/* 
 * timex.c
 *	time a command with report of system activity and/or process data
 */

/* $Log:	timex.c,v $
 */

#include <sys/types.h>
#include <sys/times.h>
#include <sys/param.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <pwd.h>

time_t	times();
long	atol();
extern	time_t time();
int	isatty();
char	*ttyname();
char	*strcat();
char	*strncpy();
int	getuid();
struct	passwd *getpwuid();

extern int errno;
extern char *sys_errlist[];
char	fname[MAXPATHLEN];
char	cmd[MAXPATHLEN+80];	/* file name plus space for the cmd */


main(argc, argv)
int argc;
char **argv;
{
	struct	tms buffer, obuffer;
	int	status;
	register	p;
	int	c;
	time_t	before, after;
	char	stime[9], etime[9];
	extern	char	*optarg;
	extern	int	optind;
	int	pflg = 0, sflg = 0, oflg = 0;
	char	aopt[25];
	FILE	*popen(), *pipin;
	char	ttyid[12], line[150];
	char	eol;
	char	fld[20][12];
	int	iline = 0, i, nfld;
	int	ichar, iblok;
	long	chars = 0, bloks = 0;

	/* check options; */
	while((c = getopt(argc, argv, "sopfhkmrt")) != EOF)
		switch(c)  {
		case 's':  sflg++;  break;
		case 'o':  oflg++;  break;
		case 'p':  pflg++;  break;

		case 'f':  (void) strcat(aopt, "-f ");  break;
		case 'h':  (void) strcat(aopt, "-h ");  break;
		case 'k':  (void) strcat(aopt, "-k ");  break;
		case 'm':  (void) strcat(aopt, "-m ");  break;
		case 'r':  (void) strcat(aopt, "-r ");  break;
		case 't':  (void) strcat(aopt, "-t ");  break;

		case '?':  diag("Usage: timex [-s][-o][-p[-fhkmrt]] cmd");
				break;
		}
	if(optind >= argc)	diag("Missing command");

#ifdef u3b2
	/* check to see if accounting is installed and print a somewhat
	   meaninful message if not  */
	if (((oflg+pflg) != 0) && (access("/bin/acctcom", 01) == -1) ) {
		oflg = 0;
		pflg = 0;
		(void) fprintf(stderr, "Information from -p and -o options not available\n");
		(void) fprintf(stderr, " because process accounting is not operational.\n");
	}
#endif

	if (sflg) {
		(void) sprintf(fname,"/tmp/tmx%d",getpid());
		(void) sprintf(cmd,"/usr/lib/sa/sadc 1 1 %s",fname);
		system(cmd);
	}
	if (pflg + oflg) hmstime(stime);
	before = times(&obuffer);
	if ((p = fork()) == -1) diag("Try again.\n");
	if(p == 0) {
		setgid(getgid());
		execvp(*(argv+optind),(argv+optind));
		(void) fprintf(stderr, "%s: %s\n", *(argv+optind), sys_errlist[errno]);
		exit(1);
	}
	signal(SIGINT, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	while(wait(&status) != p);
	if((status&0377) != 0)
		(void) fprintf(stderr,"Command terminated abnormally.\n");
	signal(SIGINT, SIG_DFL);
	signal(SIGQUIT, SIG_DFL);
	after = times(&buffer);
	if (pflg + oflg) hmstime(etime);
	if (sflg) system(cmd);

	(void) fprintf(stderr,"\n");
	printt("real", (after-before));
	printt("user", buffer.tms_cutime - obuffer.tms_cutime);
	printt("sys ", buffer.tms_cstime - obuffer.tms_cstime);
	(void) fprintf(stderr,"\n");

	if (oflg+pflg) {
		if(isatty(0))
			(void) sprintf(ttyid, "-l %s", ttyname(0)+5);
		(void) sprintf(cmd, "acctcom -S %s -E %s -u %s %s -i %s",
			stime, etime, getpwuid(getuid())->pw_name, ttyid, aopt);
		pipin = popen(cmd, "r");
		while(fscanf(pipin, "%[^\n]%1c", line, &eol) > 1) {
			if(pflg)
				(void) fprintf(stderr, "%s\n", line);
			if(oflg)  {
				nfld=sscanf(line,
				"%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
				fld[0], fld[1], fld[2], fld[3], fld[4],
				fld[5], fld[6], fld[7], fld[8], fld[9],
				fld[10], fld[11], fld[12], fld[13], fld[14],
				fld[15], fld[16], fld[17], fld[18], fld[19]);
				if(++iline == 3)
					for(i=0; i<nfld; i++)  {
						if(strcmp(fld[i], "CHARS") == 0)
							ichar = i+2;
						if(strcmp(fld[i],"BLOCKS") == 0)
							iblok = i+2;
					}
				if (iline > 4)  {
					chars += atol(fld[ichar]);
					bloks += atol(fld[iblok]);
				}
			}
		}
		pclose(pipin);

		if(oflg)
			if(iline > 4)
				(void) fprintf(stderr,
				"\nCHARS TRNSFD = %ld\nBLOCKS READ  = %ld\n",
				chars, bloks);
			else
				(void) fprintf(stderr,
					"\nNo process records found!\n");
	}

	if (sflg)  {
#ifdef	RFS_SUPPORT
		(void) sprintf(cmd,"/usr/bin/sar -ubdycwaqvmprCDS -f %s 1>&2",
			fname);
#else
		(void) sprintf(cmd,"/usr/bin/sar -ubdycwaqvmpr -f %s 1>&2",
			fname);
#endif	/* RFS_SUPPORT */
		system(cmd);
		unlink(fname);
	}
	exit(status>>8);
}

char quant[] = { HZ/10, 10, 10, 6, 10, 6, 10, 10, 10 };
char *pad  = "000      ";
char *sep  = "\0\0.\0:\0:\0\0";
char *nsep = "\0\0.\0 \0 \0\0";

printt(s, a)
char	*s;
time_t	a;
{
	char	digit[9];
	register	i;
	char	c;
	int	nonzero;

	for(i=0; i<9; i++) {
		digit[i] = a % quant[i];
		a /= quant[i];
	}
	(void) fprintf(stderr,s);
	nonzero = 0;
	while(--i>0) {
		c = digit[i]!=0 ? digit[i]+'0':
		    nonzero ? '0':
		    pad[i];
		if (c != '\0') putc(c,stderr);
		nonzero |= digit[i];
		c = nonzero?sep[i]:nsep[i];
		if (c != '\0') putc(c,stderr);
	}
	(void) fprintf(stderr,"%c",digit[0]*100/HZ+'0');
	(void) fprintf(stderr,"\n");
}

/*
** hmstime() sets current time in hh:mm:ss string format in stime;
*/

hmstime(stime)
char	stime[];
{
	char	*ltime, *ctime();
	long tme;

	tme = time((long *)0);
	ltime = ctime(&tme);
	strncpy(stime, ltime+11, 8);
}
 
diag(s)
char *s;
{
	(void) fprintf(stderr,"%s\n",s);
	unlink(fname);
	exit(1);
}
