/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: sed0.c 1.6 89/11/27 $@(#)sed:sed0.c	1.10"



extern char *gettxt();
#include <stdio.h>
#include <sys/types.h>		/* needed for <dirent.h> */
#include <dirent.h>		/* to get MAXNAMLEN */
#include "sed.h"
FILE	*fin;
FILE    *fcode[12];
char    *lastre;
wchar_t   sseof;
char    *reend;
char    *hend;
union reptr     *ptrend;
int     eflag;
char    linebuf[LBSIZE+1];
int     gflag;
int     nlno;
char    fname[12][MAXNAMLEN];
int     nfiles;
union reptr ptrspace[PTRSIZE];
union reptr *rep;
char    *cp;
char    respace[RESIZE];
struct label ltab[LABSIZE];
struct label    *lab;
struct label    *labend;
int     depth;
int     eargc;
char    **eargv;
union reptr     **cmpend[DEPTH];
char    *badp;
char    bad;

#define CCEOF	22

struct label    *labtab = ltab;

char    CGMES[]		= "sed: command garbled: %s\n";
char    TMMES[]		= "Too much text: %s\n";
char    LTL[]  		= "Label too long: %s\n";
char    AD0MES[]	= "No addresses allowed: %s\n";
char    AD1MES[]	= "Only one address allowed: %s\n";
char	TOOBIG[]	= "Suffix too large - 512 max: %s\n";

extern char *comple();
extern int optind;
extern char *optarg;

main(argc, argv)
char    *argv[];
{
	int c;

	badp = &bad;
	aptr = abuf;
	lab = labtab + 1;       /* 0 reserved for end-pointer */
	rep = ptrspace;
	rep->r1.ad1 = respace;
	lbend = &linebuf[LBSIZE];
	hend = &holdsp[LBSIZE];
	lcomend = &genbuf[71];
	ptrend = &ptrspace[PTRSIZE];
	reend = &respace[RESIZE-1];
	labend = &labtab[LABSIZE];
	lnum = 0;
	pending = 0;
	depth = 0;
	spend = linebuf;
	hspend = holdsp;	/* Avoid "bus error" under "H" cmd. */
	fcode[0] = stdout;
	nfiles = 1;

	if(argc == 1)
		exit(0);


	while ((c = getopt(argc, argv, "gne:f:")) != -1)
		switch (c) {

		case 'n':
			nflag++;
			continue;

		case 'f':

			if((fin = fopen(optarg, "r")) == NULL) {
				fprintf(stderr, gettxt("sed:7", "Cannot open pattern-file: %s\n"), optarg);
				exit(2);
			}

			fcomp();
			fclose(fin);
			continue;

		case 'e':
			eflag++;
			fcomp();
			eflag = 0;
			continue;

		case 'g':
			gflag++;
			continue;

		default:
			exit(2);
		}


	eargv = argv + optind;
	eargc = argc - optind;
	if(rep == ptrspace) {
		eflag++;
		optarg = *eargv++;
		fcomp();
		eargc--;
		eflag = 0;
	}

	if(depth) {
		fprintf(stderr, gettxt("sed:8", "Too many {'s\n"));
		exit(2);
	}

	labtab->address = rep;

	dechain();

	if(eargc <= 0)
		execute((char *)NULL);
	else while(--eargc >= 0) {
		execute(*eargv++);
	}
	fclose(stdout);
	exit(0);
	/* NOTREACHED */
}

fcomp()
{

	register char   *p, *op, *tp;
	char    *address();
	union reptr     *pt, *pt1;
	int     i, ii;
	struct label    *lpt;
	register int n;
	op = lastre;

	if(rline(linebuf) < 0)  return;
	if(*linebuf == '#') {
		if(linebuf[1] == 'n')
			nflag = 1;
	}
	else {
		cp = linebuf;
		goto comploop;
	}

	for(;;) {
		if(rline(linebuf) < 0)  break;

		cp = linebuf;

comploop:
/*      fprintf(stderr, "cp: %s\n", cp);	/*DEBUG*/
		while(*cp == ' ' || *cp == '\t')	cp++;
		if(*cp == '\0')	 continue;
		if(*cp == ';') {
			cp++;
			goto comploop;
		}

		p = address(rep->r1.ad1);
		if(p == badp) {
			fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
			exit(2);
		}

		if(p == rep->r1.ad1) {
			if(op)
				rep->r1.ad1 = op;
			else {
				fprintf(stderr, gettxt("sed:9", "First RE may not be null\n"));
				exit(2);
			}
		} else if(p == 0) {
			p = rep->r1.ad1;
			rep->r1.ad1 = 0;
		} else {
			op = rep->r1.ad1;
			if(*cp == ',' || *cp == ';') {
				cp++;
				if((rep->r1.ad2 = p) > reend) {
					fprintf(stderr, gettxt("sed:2", TMMES), linebuf);
					exit(2);
				}
				p = address(rep->r1.ad2);
				if(p == badp || p == 0) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				if(p == rep->r1.ad2)
					rep->r1.ad2 = op;
				else
					op = rep->r1.ad2;

			} else
				rep->r1.ad2 = 0;
		}

		if(p > reend) {
			fprintf(stderr, gettxt("sed:2", "Too much text: %s\n"), linebuf);
			exit(2);
		}

		while(*cp == ' ' || *cp == '\t')	cp++;

swit:
		switch(*cp++) {

			default:
				fprintf(stderr, gettxt("sed:10", "Unrecognized command: %s\n"), linebuf);
				exit(2);

			case '!':
				rep->r1.negfl = 1;
				goto swit;

			case '{':
				rep->r1.command = BCOM;
				rep->r1.negfl = !(rep->r1.negfl);
				cmpend[depth++] = &rep->r2.lb1;
				if(++rep >= ptrend) {
					fprintf(stderr, gettxt("sed:11", "Too many commands: %s\n"), linebuf);
					exit(2);
				}
				rep->r1.ad1 = p;
				if(*cp == '\0') continue;

				goto comploop;

			case '}':
				if(rep->r1.ad1) {
					fprintf(stderr, gettxt("sed:4", AD0MES), linebuf);
					exit(2);
				}

				if(--depth < 0) {
					fprintf(stderr, gettxt("sed:12", "Too many }'s\n"));
					exit(2);
				}
				*cmpend[depth] = rep;

				rep->r1.ad1 = p;
				continue;

			case '=':
				rep->r1.command = EQCOM;
				if(rep->r1.ad2) {
					fprintf(stderr, gettxt("sed:5", AD1MES), linebuf);
					exit(2);
				}
				break;

			case ':':
				if(rep->r1.ad1) {
					fprintf(stderr, gettxt("sed:4", AD0MES), linebuf);
					exit(2);
				}

				while(*cp++ == ' ');
				cp--;


				tp = lab->asc;
				while((*tp++ = *cp++))
					if(tp >= &(lab->asc[8])) {
						fprintf(stderr, gettxt("sed:3", LTL), linebuf);	
						exit(2);
					}
				*--tp = '\0';

				if(lpt = search(lab)) {
					if(lpt->address) {
						fprintf(stderr, gettxt("sed:13", "Duplicate labels: %s\n"), linebuf);
						exit(2);
					}
				} else {
					lab->chain = 0;
					lpt = lab;
					if(++lab >= labend) {
						fprintf(stderr, gettxt("sed:14", "Too many labels: %s\n"), linebuf);
						exit(2);
					}
				}
				lpt->address = rep;
				rep->r1.ad1 = p;

				continue;

			case 'a':
				rep->r1.command = ACOM;
				if(rep->r1.ad2) {
					fprintf(stderr, gettxt("sed:5", AD1MES), linebuf);
					exit(2);
				}
				if(*cp == '\\') cp++;
				if(*cp++ != '\n') {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				rep->r1.re1 = p;
				p = text(rep->r1.re1);
				break;
			case 'c':
				rep->r1.command = CCOM;
				if(*cp == '\\') cp++;
				if(*cp++ != ('\n')) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				rep->r1.re1 = p;
				p = text(rep->r1.re1);
				break;
			case 'i':
				rep->r1.command = ICOM;
				if(rep->r1.ad2) {
					fprintf(stderr, gettxt("sed:5", AD1MES), linebuf);
					exit(2);
				}
				if(*cp == '\\') cp++;
				if(*cp++ != ('\n')) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				rep->r1.re1 = p;
				p = text(rep->r1.re1);
				break;

			case 'g':
				rep->r1.command = GCOM;
				break;

			case 'G':
				rep->r1.command = CGCOM;
				break;

			case 'h':
				rep->r1.command = HCOM;
				break;

			case 'H':
				rep->r1.command = CHCOM;
				break;

			case 't':
				rep->r1.command = TCOM;
				goto jtcommon;

			case 'b':
				rep->r1.command = BCOM;
jtcommon:
				while(*cp++ == ' ');
				cp--;

				if(*cp == '\0') {
					if(pt = labtab->chain) {
						while(pt1 = pt->r2.lb1)
							pt = pt1;
						pt->r2.lb1 = rep;
					} else
						labtab->chain = rep;
					break;
				}
				tp = lab->asc;
				while((*tp++ = *cp++))
					if(tp >= &(lab->asc[8])) {
						fprintf(stderr, gettxt("sed:3", LTL), linebuf);
						exit(2);
					}
				cp--;
				*--tp = '\0';

				if(lpt = search(lab)) {
					if(lpt->address) {
						rep->r2.lb1 = lpt->address;
					} else {
						pt = lpt->chain;
						while(pt1 = pt->r2.lb1)
							pt = pt1;
						pt->r2.lb1 = rep;
					}
				} else {
					lab->chain = rep;
					lab->address = 0;
					if(++lab >= labend) {
						fprintf(stderr, gettxt("sed:14", "Too many labels: %s\n"), linebuf);
						exit(2);
					}
				}
				break;

			case 'n':
				rep->r1.command = NCOM;
				break;

			case 'N':
				rep->r1.command = CNCOM;
				break;

			case 'p':
				rep->r1.command = PCOM;
				break;

			case 'P':
				rep->r1.command = CPCOM;
				break;

			case 'r':
				rep->r1.command = RCOM;
				if(rep->r1.ad2) {
					fprintf(stderr, gettxt("sed:5", AD1MES), linebuf);
					exit(2);
				}
				if(*cp++ != ' ') {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				rep->r1.re1 = p;
				p = text(rep->r1.re1);
				break;

			case 'd':
				rep->r1.command = DCOM;
				break;

			case 'D':
				rep->r1.command = CDCOM;
				rep->r2.lb1 = ptrspace;
				break;

			case 'q':
				rep->r1.command = QCOM;
				if(rep->r1.ad2) {
					fprintf(stderr, gettxt("sed:5", AD1MES), linebuf);
					exit(2);
				}
				break;

			case 'l':
				rep->r1.command = LCOM;
				break;

			case 's':
				rep->r1.command = SCOM;
				if((n = mbtowc(&sseof, cp, MULTI_BYTE_MAX)) < 0) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				if(n== 0) {
					rep--;
					goto done;
				}
				cp += n;
				rep->r1.re1 = p;
				p = comple(rep->r1.re1, reend, sseof);
				if(p == badp) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				if(p == rep->r1.re1) {
					rep->r1.re1 = op;
				} else 
					op = rep->r1.re1;
				rep->r1.rhs = p;

				if((p = compsub(rep->r1.rhs)) == badp) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}

				if(*cp == 'g') {
					cp++;
					rep->r1.gfl = 999;
				} else if(gflag)
					rep->r1.gfl = 999;

				if(*cp >= '1' && *cp <= '9')
					{i = *cp - '0';
					cp++;
					while(1)
						{ii = *cp;
						if(ii < '0' || ii > '9') break;
						i = i*10 + ii - '0';
						if(i > 512)
							{fprintf(stderr, gettxt("sed:6", TOOBIG), linebuf);
							exit(2);
							}
						cp++;
						}
					rep->r1.gfl = i;
					}

				if(*cp == 'p') {
					cp++;
					rep->r1.pfl = 1;
				}

				if(*cp == 'P') {
					cp++;
					rep->r1.pfl = 2;
				}

				if(*cp == 'w') {
					cp++;
					if(*cp++ !=  ' ') {
						fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
						exit(2);
					}
					if(nfiles >= 10) {
						fprintf(stderr, gettxt("sed:15", "Too many files in w commands\n"));
						exit(2);
					}

					text(fname[nfiles]);
					for(i = nfiles - 1; i >= 0; i--)
						if(cmp(fname[nfiles],fname[i]) == 0) {
							rep->r1.fcode = fcode[i];
							goto done;
						}
					if((rep->r1.fcode = fopen(fname[nfiles], "w")) == NULL) {
						fprintf(stderr, gettxt("sed:16", "cannot open %s\n"), fname[nfiles]);
						exit(2);
					}
					fcode[nfiles++] = rep->r1.fcode;
				}
				break;

			case 'w':
				rep->r1.command = WCOM;
				if(*cp++ != ' ') {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
					exit(2);
				}
				if(nfiles >= 10){
					fprintf(stderr, gettxt("sed:15", "Too many files in w commands\n"));
					exit(2);
				}

				text(fname[nfiles]);
				for(i = nfiles - 1; i >= 0; i--)
					if(cmp(fname[nfiles], fname[i]) == 0) {
						rep->r1.fcode = fcode[i];
						goto done;
					}

				if((rep->r1.fcode = fopen(fname[nfiles], "w")) == NULL) {
					fprintf(stderr, gettxt("sed:17", "Cannot create %s\n"), fname[nfiles]);
					exit(2);
				}
				fcode[nfiles++] = rep->r1.fcode;
				break;

			case 'x':
				rep->r1.command = XCOM;
				break;

			case 'y':
				rep->r1.command = YCOM;
				if((n = mbtowc(&sseof, cp, MULTI_BYTE_MAX)) < 0) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);							
					exit(2);
				}
				if(n== 0) {
					rep--;
					goto done;
				}
				cp += n; 
				rep->r1.re1 = p;
				p = ycomp(rep->r1.re1);
				if(p == badp) {
					fprintf(stderr, gettxt("sed:1", CGMES), linebuf);						
					exit(2);
				}
				break;

		}
done:
		if(++rep >= ptrend) {
			fprintf(stderr, gettxt("sed:18", "Too many commands, last: %s\n"), linebuf);
			exit(2);
		}

		rep->r1.ad1 = p;

		if(*cp++ != '\0') {
			if(cp[-1] == ';')
				goto comploop;
			fprintf(stderr, gettxt("sed:1", CGMES), linebuf);
			exit(2);
		}

	}
	rep->r1.command = 0;
	lastre = op;
}

char    *compsub(rhsbuf)
char    *rhsbuf;
{
	register char   *p, *q;
	register c;
	int length;
	
	p = rhsbuf;
	q = cp;
	for(;;) {
		wchar_t nextc;
		if(p > reend) {
			fprintf(stderr, gettxt("sed:2", TMMES), linebuf);
			exit(2);
		}
		if((length = mbtowc(&nextc, q, MULTI_BYTE_MAX)) <= 0)
			return(badp);
		if(nextc == '\\') {
			q++;
			*p++ = '\\';
			if((length = mbtowc(&nextc, q, MULTI_BYTE_MAX)) <= 0)
				return(badp);
			if(p + length > reend) {
				fprintf(stderr, gettxt("sed:2", TMMES), linebuf);
				exit(2);
			}
			if(nextc > nbra + '0' && nextc <= '9')
				return(badp);
			(void)strcpy(p, q, length);
			p += length;
			q += length;
			continue;
		}
		if(nextc == sseof) {
			*p++ = '\0';
			q += length;
			cp = q;
			return(p);
		}
		if(p + length > reend) {
			fprintf(stderr, gettxt("sed:2", TMMES), linebuf);
			exit(2);
		}
		(void)strcpy(p, q, length);
		p += length;
		q += length;
	}
}

rline(lbuf)
char    *lbuf;
{
	register char   *p, *q;
	register	t;
	static char     *saveq;

	p = lbuf - 1;

	if(eflag) {
		if(eflag > 0) {
			eflag = -1;
			q = optarg;
			while(*++p = *q++) {
				if(*p == '\\') {
					if((*++p = *q++) == '\0') {
						saveq = 0;
						return(-1);
					} else
						continue;
				}
				if(*p == '\n') {
					*p = '\0';
					saveq = q;
					return(1);
				}
			}
			saveq = 0;
			return(1);
		}
		if((q = saveq) == 0)    return(-1);

		while(*++p = *q++) {
			if(*p == '\\') {
				if((*++p = *q++) == '\0') {
					saveq = 0;
					return(-1);
				} else
					continue;
			}
			if(*p == '\n') {
				*p = '\0';
				saveq = q;
				return(1);
			}
		}
		saveq = 0;
		return(1);
	}

	while((t = getc(fin)) != EOF) {
		*++p = t;
		if(*p == '\\') {
			if((t = getc(fin)) == EOF)
				return(-1);
			*++p = t;
		}
		else if(*p == '\n') {
			*p = '\0';
			return(1);
		}
	}
	return(-1);
}

char    *address(expbuf)
char    *expbuf;
{
	register char   *rcp;
	int length;
	long    lno;

	if(*cp == '$') {
		cp++;
		*expbuf++ = CEND;
		*expbuf++ = CCEOF;
		return(expbuf);
	}
	if (*cp == '/' || *cp == '\\' ) {
		if ( *cp == '\\' )
			cp++;
		if((length = mbtowc(&sseof, cp, MULTI_BYTE_MAX)) <= 0) {
			fprintf(stderr, gettxt("sed:1", CGMES));
			exit(2);
		}
		cp += length;
		return(comple(expbuf, reend, sseof));
	}

	rcp = cp;
	lno = 0;

	while(*rcp >= '0' && *rcp <= '9')
		lno = lno*10 + *rcp++ - '0';

	if(rcp > cp) {
		*expbuf++ = CLNUM;
		*expbuf++ = nlno;
		tlno[nlno++] = lno;
		if(nlno >= NLINES) {
			fprintf(stderr, gettxt("sed:19", "Too many line numbers\n"));
			exit(2);
		}
		*expbuf++ = CCEOF;
		cp = rcp;
		return(expbuf);
	}
	return(0);
}
cmp(a, b)
char    *a,*b;
{
	register char   *ra, *rb;

	ra = a - 1;
	rb = b - 1;

	while(*++ra == *++rb)
		if(*ra == '\0') return(0);
	return(1);
}

char    *text(textbuf)
char    *textbuf;
{
	register char   *p, *q;

	p = textbuf;
	q = cp;
	for(;;) {

		if((*p = *q++) == '\\')
			*p = *q++;
		if(*p == '\0') {
			cp = --q;
			return(++p);
		}
		p++;
	}
}


struct label    *search(ptr)
struct label    *ptr;
{
	struct label    *rp;

	rp = labtab;
	while(rp < ptr) {
		if(cmp(rp->asc, ptr->asc) == 0)
			return(rp);
		rp++;
	}

	return(0);
}


dechain()
{
	struct label    *lptr;
	union reptr     *rptr, *trptr;

	for(lptr = labtab; lptr < lab; lptr++) {

		if(lptr->address == 0) {
			fprintf(stderr, gettxt("sed:20", "Undefined label: %s\n"), lptr->asc);
			exit(2);
		}

		if(lptr->chain) {
			rptr = lptr->chain;
			while(trptr = rptr->r2.lb1) {
				rptr->r2.lb1 = lptr->address;
				rptr = trptr;
			}
			rptr->r2.lb1 = lptr->address;
		}
	}
}

char *ycomp(expbuf)
char    *expbuf;
{
	wchar_t   c, d; 
	int length;
	register char *ep, *tsp;
	char    *sp, *endptr;

	ep = expbuf;
	endptr = ep + 0400;
	if(endptr > reend) {
		fprintf(stderr, gettxt("sed:2", TMMES), linebuf);
		exit(2);
	}
	for(sp = ep; sp < endptr; sp++)
		*sp = sp - ep;
	sp = cp;
	tsp = cp;
	while(1) {
		if((length = mbtowc(&c, tsp, MULTI_BYTE_MAX)) <= 0)
			return(badp);
		tsp += length;
		if(c == sseof)
			break;
		if(c == '\\') {
			if((length = mbtowc(&c, tsp, MULTI_BYTE_MAX)) <= 0)
				return(badp);
			tsp += length;
		}
		if(c == '\n')
			return(badp);
	}

	while(1) {
		int length2;
		length = mbtowc(&c, sp, MULTI_BYTE_MAX);
		sp += length;
		if(c == sseof)
			break;
		if(c == '\\') {
			length = mbtowc(&c, sp, MULTI_BYTE_MAX);
			sp += length;
			if(c == 'n')
				c = '\n';
		}
		if((length2 = mbtowc(&d, tsp, MULTI_BYTE_MAX)) <= 0)
			return(badp);
		tsp += length2;

		if(d == '\\') {
			if((length2 = mbtowc(&d, tsp, MULTI_BYTE_MAX)) <= 0)
				return(badp);
			tsp += length2;
			if(d == 'n')
				d = '\n';
		}
		if(d > 0377 || c > 0377) {
			if(endptr + length > reend) {
				fprintf(stderr, gettxt("sed:2", TMMES), linebuf);
				exit(2);
			}
			if(c < 0400) 
				ep[c] = 0;
			endptr += wctomb(endptr, c);
			if(endptr + length2 > reend) {
				fprintf(stderr, gettxt("sed:2", TMMES), linebuf);
				exit(2);
			}
			endptr += wctomb(endptr, d);
		}
		else
			ep[c] = d;
	}
	if((length = mbtowc(&d, tsp, MULTI_BYTE_MAX)) <= 0 || d != sseof)
		return(badp);
	cp = tsp + length;
	*endptr++ = '\0';
	return(endptr);
}
