# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: spell.mk 1.10 89/10/10 $@(#)spell:spell.mk	1.12"
#	spell make file

#	Note:  In using the -f flag it is assumed that either
#	both the host and the target machines need the -f, or
#	neither needs it.  If one needs it and the other does
#	not, it is assumed that the machine that does not need
#	it will treat it appropriately.

# _SH_ is used by 3B15 View-path environment

ROOT =
OL = $(ROOT)/
SL = $(LOCALVIEW)/usr/src/cmd
RDIR = ${SL}/spell
INS = :
REL = current
CSID = -r`gsid spellcode ${REL}`
DSID = -r`gsid spelldata ${REL}`
SHSID = -r`gsid spell.sh ${REL}`
CMPRSID = -r`gsid compress.sh ${REL}`
MKSID = -r`gsid spell.mk ${REL}`
BIN = P108
LIST = opr -ttx -b${BIN}
CINSDIR = ${OL}usr/bin
PINSDIR = ${OL}usr/lib/spell
IFLAG = 
IFLAGCC =
SMFLAG =
INC    = $(CCS_HDRS)/usr/include
CFLAGS = -O $(FFLAGS) $(IFLAG) ${SMFLAG}
CFLAGSCC = -O $(FFLAGS) $(IFLAGCC) ${SMFLAG}
SFILES = spellprog.c spellin.c
DFILES = american british local list extra stop
SHIST  = spellhist
MAKE = make
SPOBJS = spellprog.o hash.o hashlook.o huff.o malloc.o
SIOBJS = spellin.o huff.o
HMOBJS = hashmake.o hash.o
HCOBJS = hashcheck.o hash.o huff.o

compile all: mains hlista hlistb hstop

mains:$& spell spellin spellin1 spellprog hashmake hashmk1 hashcheck compress

spell:$&	spellprog spell.sh
	cp spell.sh spell ; \
	$(INS) $(CINSDIR) spell ; \
	touch ${SHIST} ; \
	$(INS) ${PINSDIR} -m 666 ${SHIST}

#spelldir:
#	-mkdir ${PINSDIR}

compress:  compress.sh
	cp compress.sh compress ; \
	${INS} ${PINSDIR} compress

spellprog:$& $(SPOBJS)
	$(CC) $(CFLAGS) -s $(SPOBJS) -o spellprog ; \
	$(INS) $(PINSDIR) spellprog

spellin1:$& spellin1.o huff1.o
	cc $(CFLAGSCC) -s spellin1.o huff1.o -o spellin1

spellin1.o: spellin.c
	cp spellin.c spellin1.c ; \
	cc $(CFLAGSCC) -c spellin1.c ; \
	rm -f spellin1.c

huff1.o: huff.c
	cp huff.c huff1.c ; \
	cc $(CFLAGSCC) -c huff1.c ; \
	rm -f huff1.c
	
spellin:$& $(SIOBJS)
	$(CC) $(CFLAGS) -s $(SIOBJS) -o spellin ; \
	${INS} ${PINSDIR} spellin

hashcheck: $(HCOBJS)
	$(CC) $(CFLAGS) -s $(HCOBJS) -o hashcheck ; \
	${INS} ${PINSDIR} hashcheck

hashmk1: hashmk1.o hash1.o
	cc $(CFLAGSCC) -s hashmk1.o hash1.o -o hashmk1

hashmk1.o: hashmake.c
	cp hashmake.c hashmk1.c ; \
	cc $(CFLAGSCC) -c hashmk1.c ; \
	rm -f hashmk1.c

hash1.o: hash.c
	cp hash.c hash1.c ; \
	cc $(CFLAGSCC) -c hash1.c ; \
	rm -f hash1.c

hashmake:$& $(HMOBJS)
	$(CC) $(CFLAGS) -s $(HMOBJS) -o hashmake ; \
	${INS} ${PINSDIR} hashmake

alldata: hlista hlistb hstop
	rm -f htemp1

htemp1:	list local extra hashmk1
	cat list local extra | $(_SH_) ./hashmk1 >htemp1

hlista: american hashmake hashmk1 spellin spellin1 htemp1
	$(_SH_) ./hashmk1 <american |sort -u - htemp1 >htemp2 ; \
	$(_SH_) ./spellin1 `wc htemp2|sed -n 's/\([^ ]\) .*/\1/p' ` <htemp2 >hlista ; \
	$(INS) $(PINSDIR) -m 644 hlista ; \
	rm -f htemp2

hlistb: british hashmk1 spellin1 htemp1
	$(_SH_) ./hashmk1 <british |sort -u - htemp1 >htemp2 ; \
	$(_SH_) ./spellin1 `wc htemp2|sed -n 's/\([^ ]\) .*/\1/p' ` <htemp2 >hlistb ; \
	$(INS) $(PINSDIR) -m 644 hlistb ; \
	rm -f htemp2


hstop:	stop spellin1 hashmk1
	$(_SH_) ./hashmk1 <stop | sort -u >htemp2 ; \
	$(_SH_) ./spellin1 `wc htemp2|sed -n 's/\([^ ]\) .*/\1/p' ` <htemp2 >hstop ; \
	$(INS) $(PINSDIR) -m 644 hstop ; \
	rm -f htemp2

install:  ;  ${MAKE} -f spell.mk INS="install -f" OL=${OL} all
inssh:    ;  ${MAKE} -f spell.mk INS="install -f" OL=${OL} spell
inscomp:  ;  ${MAKE} -f spell.mk INS="install -f" OL=${OL} compress
inscode:  ;  ${MAKE} -f spell.mk INS="install -f" spell OL=${OL}
insdata:  ;  ${MAKE} -f spell.mk INS="install -f" alldata OL=${OL}

listing:  ;  pr spell.mk spell.sh compress.sh ${SFILES} ${DFILES} | ${LIST}
listmk:   ;  pr spell.mk | ${LIST}
listsh:	  ;  pr spell.sh | ${LIST}
listcomp: ;  pr compress.sh | ${LIST}
listcode: ;  pr ${SFILES} | ${LIST}
listdata: ;  pr ${DFILES} | ${LIST}

build:  bldmk bldsh bldcomp bldcode blddata
	:
bldcode:  ;  get -p ${CSID} s.spell.src ${REWIRE} | ntar -d ${RDIR} -g
blddata:  ;  get -p ${DSID} s.spell.data | ntar -d ${RDIR} -g
bldsh:	  ;  get -p ${SHSID} s.spell.sh ${REWIRE} > ${RDIR}/spell.sh
bldcomp:  ;  get -p ${CMPRSID} s.compress.sh ${REWIRE} > ${RDIR}/compress.sh
bldmk:    ;  get -p ${MKSID} s.spell.mk > ${RDIR}/spell.mk

edit:	sedit dedit mkedit shedit compedit
	:
sedit:	;  get -p -e s.spell.src | ntar -g
dedit:	;  get -p -e s.spell.data | ntar -g
shedit:	;  get -e s.spell.sh
compedit: ; get -e s.compress.sh

delta:	sdelta ddelta mkdelta shdelta compdelta
	:
sdelta:
	ntar -p ${SFILES} > spell.src
	delta s.spell.src
	rm -f ${SFILES}
ddelta:
	ntar -p ${DFILES} > spell.data
	delta s.spell.data
	rm -f ${DFILES}
shdelta:
	delta s.spell.sh
compdelta: ; delta s.compress.sh

mkedit:	;  get -e s.spell.mk
mkdelta: ; delta s.spell.mk

clean:
	rm -f *.o ${SHIST}

clobber: clean shclobber compclobber
	rm -f spell spellprog spellin hashmake hlist* hstop spellin1 hashmk1
	-rm -f htemp1 htemp2 hashcheck
shclobber: ; rm -f spell
compclobber: ; rm -f compress

delete:	clobber shdelete compdelete
	rm -f ${SFILES} ${DFILES}
shdelete: shclobber
	rm -f spell.sh
compdelete: compclobber
	rm -f compress.sh
