# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#
# Copyright  (c) 1985 AT&T
#	All Rights Reserved
#
#ident	"$Header: sys.mk 1.2 89/10/10 $@(#)vm:sys/sys.mk	1.3"
#

INC=$(CCS_HDRS)/usr/include
USRLIB=$(CCS_HDRS)/usr/lib
LIBRARY=libsys.a
HEADER1=../inc
INCLUDEDIR=	-I$(HEADER1) 

AR=		ar
CFLAGS = 	-O

OBJECTS=	backslash.o expand.o exit.o filename.o getaltenv.o getepenv.o \
		memshift.o parent.o spawn.o strCcmp.o strsave.o tempfiles.o \
		terrmess.o terror.o varappend.o varcreate.o vardelete.o \
		vargrow.o

$(LIBRARY): $&	$(OBJECTS)
		rm -f $(LIBRARY)
		$(AR) r $(LIBRARY) $(OBJECTS)

backslash.o:	backslash.c $(HEADER1)/wish.h 

expand.o:	exit.c $(HEADER1)/wish.h $(HEADER1)/moremacros.h

exit.o:	exit.c $(HEADER1)/wish.h $(HEADER1)/var_arrays.h

filename.o:	filename.c

getaltenv.o:	getaltenv.c $(HEADER1)/wish.h $(HEADER1)/var_arrays.h

getepenv.o:	getepenv.c $(HEADER1)/wish.h $(HEADER1)/moremacros.h

memshift.o:	memshift.c $(HEADER1)/wish.h

parent.o:	parent.c $(HEADER1)/wish.h

spawn.o:	spawn.c

strCcmp.o:	strCcmp.c 

strsave.o:	strsave.c $(HEADER1)/wish.h

tempfiles.o:	tempfiles.c $(HEADER1)/wish.h $(HEADER1)/retcodes.h $(HEADER1)/var_arrays.h $(HEADER1)/terror.h $(HEADER1)/moremacros.h

terrmess.o:	terrmess.c $(HEADER1)/wish.h $(HEADER1)/terror.h

terror.o:	terror.c $(HEADER1)/wish.h $(HEADER1)/vtdefs.h $(HEADER1)/terror.h $(HEADER1)/retcodes.h

varappend.o:	varappend.c $(HEADER1)/wish.h $(HEADER1)/var_arrays.h 

varcreate.o:	varcreate.c $(HEADER1)/wish.h $(HEADER1)/var_arrays.h 

vardelete.o:	vardelete.c $(HEADER1)/wish.h $(HEADER1)/var_arrays.h 

vargrow.o:	vargrow.c $(HEADER1)/wish.h $(HEADER1)/var_arrays.h 

.c.o:
	$(CC) -c $(CFLAGS) $(INCLUDEDIR) $<

####### Standard makefile targets ########

all:		$(LIBRARY)

install:	all

clean:
		/bin/rm -f *.o

clobber:	clean
		/bin/rm -f $(LIBRARY)

profile:	libprof.a
#
# PROFILING: ---------------------------------------------
#  method 0: ignore the exit and suffer the conseqences
#
VERDICT = libp0

libp0.a:  libsys.a noeggs.o
	/bin/rm -f $@; cp libsys.a $@;
	ar d $@ exit.o
	ar ruv $@ noeggs.o
noeggs.c: exit.c
	sed 's/^exit/_noeggs/' $? >$@
#	
#  method 1: Rename the profiling and unix exits with
#      one extra leading under-bar.
# the library itself may not be profiled, but it doesnt
#   need the "exit" module; "exit" has to be recrafted
#   from csu/mcrt0.s
#
# VERDICT = libp1
libprof.a:	$(VERDICT).a
	/bin/rm -f $@; ln $? $@
#
# mcrt0 is viewmaster's profiling "crt0" file
# 
libp1.a:	libsys.a mcrt0.o vexit.o
	cp libsys.a $@
	ar ruv $@ vexit.o
#
#  machine, libc, environment tools
#
MACH	= u3b
LIBC	= /usr/src/lib/libc
M_LIB	= ${LIBC}/${MACH}
M4	= m4 ${M_LIB}/m4.def	
MCDEF	= ${M_LIB}/mcount.def
#
# turn exit into _exit and _exit into __exit
#
CRT0	= ${M_LIB}/csu/mcrt0.s
MCOUNT	= ${M_LIB}/crt/mcount.s
mcrt0.s: ${CRT0} 
	sed 's/exit/_exit/g' $?|$(M4) $(MCDEF) ->$@
vexit.s: ${M_LIB}/sys/exit.s
	sed 's/exit/_exit/g' $? |$(M4) $(MCDEF) -> $@

#
#  method 2. define a cleanup routine from the 
#   local exit routine and the unix cleanup (stdio/flsbuf.c)
#
libp2.a:	libsys.a v_clean.o
	/bin/rm -f $@; cp libsys.a $@; ar d libsys.a exit.0
	ar ruv libsys.a v_clean.o
#
#  ONLY when L*PROFiling, 
# FACE Cleanup ={ port/stdio/flsbuf.c exit.c }{ ... }.
# where _cleanup => __cleanup
#  &    exit     => _cleanup
#		
v_clean.c:	exit.c ${LIBC}/port/stdio/flsbuf.c sys.mk
	(echo "void _cleanup();" ;\
	 sed -e 's/^exit.*/cleanup(n)/'\
	     -e '/_exit/d' exit.c;\
	 echo "void";\
	 sed -n '/cleanup/,/}/p' ${LIBC}/port/stdio/flsbuf.c;\
	)|\
	 sed -e 's/cleanup/_&/g' >$@
#

.PRECIOUS:	$(LIBRARY)
