# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#
#ident	"$Header: xx.mk 1.3 89/10/10 $@(#)vm:xx/xx.mk	1.11"
#

INC=$(CCS_HDRS)/usr/include
USR=$(ROOT)/usr
USRLIB=$(CCS_LIBS)/usr/lib
LIBOH	=	../oh/liboh.a
LIBPROC	=	../proc/libproc.a
LIBSYS	=	../sys/libsys.a
LIBOEU	=	../oeu/liboeu.a
LIBBK	=	../bk/libbk.a

MKDIR	=	mkdir
VBIN=$(USR)/vmsys/bin
OABIN = $(USR)/oasys/bin
HEADER1=../inc
INCLUDEDIR=	-I$(HEADER1)

LIBS = $(LIBOH) $(LIBOEU) $(LIBPROC) $(LIBSYS) 
DIRS= $(USR)/vmsys $(USR)/oasys

CFLAGS= -O 

LDFLAGS =  -s

OCMDS =	termtest setenv oeupkg btoa identify

VCMDS = face suspend dir_move dir_copy dir_creat creaserve listserv delserve chexec chkterm basename mnucheck modserv

CMDS = $(VCMDS) $(OCMDS)

face: face.c
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o $@ face.c -lPW

suspend: suspend.c $(LIBPROC) $(HEADER1)/wish.h
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o suspend suspend.c $(LIBPROC)


creaserve: creaserve.c $(HEADER1)/wish.h $(HEADER1)/exception.h
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o creaserve creaserve.c

delserve: delserve.c $(HEADER1)/wish.h $(HEADER1)/exception.h
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o delserve delserve.c

listserv: listserv.c $(HEADER1)/wish.h $(HEADER1)/exception.h
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o listserv listserv.c

modserv: modserv.c $(HEADER1)/wish.h $(HEADER1)/exception.h
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o modserv modserv.c

mnucheck: mnucheck.c $(HEADER1)/wish.h
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o mnucheck mnucheck.c


btoa: btoa.c
	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDEDIR) -o btoa btoa.c


OEUPKG = oeupkg.c $(LIBOEU) $(LIBBK) $(LIBOH) $(LIBSYS) 
oeupkg: $&	$(OEUPKG) $(HEADER1)/tsys.h $(HEADER1)/terror.h $(HEADER1)/retcds.h $(HEADER1)/parse.h
	$(CC) $(CFLAGS) $(INCLUDEDIR) -o oeupkg $(OEUPKG)

termtest:	termtest.c $(HEADER1)/wish.h $(HEADER1)/var_arrays.h $(LIBSYS) $(HEADER1)/moremacros.h
	$(CC) $(CFLAGS) $(LDFLAGS)  $(INCLUDEDIR) -o $@ termtest.c $(LIBSYS) -lPW

.sh:
	/bin/rm -f $@ ; \
	/bin/cp $< $@ ; \
	$(CH)chmod 755 $@

###### Standard Makefile Targets ######

all: $&	$(CMDS)

install: all
	@set +e;\
	for f in $(VCMDS);\
	do\
		install -f $(VBIN) $$f;\
		$(CH) chmod 755 $(VBIN)/$$f;\
	done;\
	$(CH) chmod 755 $(VBIN)/face
	for f in $(OCMDS);\
	do\
		install -f $(OABIN) $$f;\
		$(CH) chmod 755 $(OABIN)/$$f;\
	done

clean: 
	@set +e;\
	for f in $(VCMDS);\
	do\
		/bin/rm -f $$f;\
	done;\
	for f in $(OCMDS);\
	do\
		/bin/rm -f $$f;\
	done;\
	/bin/rm -f *.o

clobber:	clean
