/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */
#ident "$Header: syscall.h 1.6 90/04/20 $"

#ifndef _SYSCALL_H_
/*
 *	Definitions of System Call Entry Point Numbers
 */

#define	SYS_exit	1
#define	SYS_fork	2
#define	SYS_read	3
#define	SYS_write	4
#define	SYS_open	5
#define	SYS_close	6
#define	SYS_wait	7
#define	SYS_creat	8
#define	SYS_link	9
#define	SYS_unlink	10
#define	SYS_exec	11
#define	SYS_chdir	12
#define	SYS_time	13
#define	SYS_mknod	14
#define	SYS_chmod	15
#define	SYS_chown	16
#define	SYS_break	17
#define	SYS_brk		17
#define	SYS_stat	18
#define	SYS_lseek	19
#define	SYS_seek	19
#define	SYS_getpid	20
#define	SYS_mount	21
#define	SYS_umount	22
#define	SYS_setuid	23
#define	SYS_getuid	24
#define	SYS_stime	25
#define	SYS_ptrace	26
#define	SYS_alarm	27
#define	SYS_fstat	28
#define	SYS_pause	29
#define	SYS_utime	30
#define	SYS_stty	31
#define	SYS_gtty	32
#define	SYS_access	33
#define	SYS_nice	34
#define	SYS_statfs	35
#define	SYS_sync	36
#define	SYS_kill	37
#define	SYS_fstatfs	38
#define	SYS_setpgrp	39
#define	SYS_dup		41
#define	SYS_pipe	42
#define	SYS_times	43
#define	SYS_prof	44
#define	SYS_profil	44
#define	SYS_lock	45
#define	SYS_plock	45
#define	SYS_setgid	46
#define	SYS_getgid	47
#define	SYS_signal	48
#define	SYS_msgsys	49
#define	SYS_sysi86	50
#define	SYS_acct	51
#define	SYS_sysacct	51
#define	SYS_shmsys	52
#define	SYS_semsys	53
#define	SYS_ioctl	54
#define	SYS_uadmin	55
#define	SYS_utssys	57
#define	SYS_exece	59
#define	SYS_execve	59
#define	SYS_umask	60
#define	SYS_chroot	61
#define	SYS_fcntl	62
#define	SYS_ulimit	63
#define	SYS_advfs	70
#define	SYS_unadvfs	71
#define	SYS_rmount	72
#define	SYS_rumount	73
#define	SYS_rfstart	74
#define	SYS_rdebug	76
#define	SYS_rfstop	77
#define	SYS_rfsys	78
#define	SYS_rmdir	79
#define	SYS_mkdir	80
#define	SYS_getdents	81
#define	SYS_sysfs	84
#define	SYS_getmsg	85
#define	SYS_putmsg	86
#define	SYS_poll	87
#define	SYS_waitpid	100
#define	SYS_setsid	101
#define	SYS_setpgid	102
#define SYS_sysconf	103
#define SYS_pathconf	104
#define	SYS_fpathconf	105
#define SYS_rename	106
#define SYS_getgroups	107
#define SYS_dup2	108


/*
 * Syscall numbers are treated as a [syscall-table, syscall-index]
 * pair. The high order 16 bits encode the system call handler
 * index, while the low order 16 bits contain the actual system
 * call number (for that handler).
 *
 * SYS_IDX() returns the system call index
 * SYS_TBL() return the system call handler index
 *
 * Current SYS_TBL values are
 *	Reserved for System V binary compatible calls	0.
 *	System V source compatible calls		1.
 *	Sequent specific calls				2.
 */

#define	SYS_IDX(sysnum)		((sysnum) & 0xFFFF)
#define	SYS_TBL(sysnum)		(((sysnum)>>16) & 0xFFFF)

#define	SYS_TYP	1

#define _SYSCALL_H_
#endif /* _SYSCALL_H_ */
