
/* tar.h */

/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident "$Header: tar.h 1.1 89/04/20 $"

#ifndef _TAR_H_

/*____________________________________________________________________*
 * This file forms part of the POSIX requirement described in section *
 * 10.1.1 of 1003.1-1988 which should be refered to before            *
 * making any changes.						      *
 *____________________________________________________________________*/


#define	TMAGIC	"ustar"	/* ustar and a null */
#define	TMAGLEN		6
#define	TVERSION	"00"	/* 00 and no null */
#define	TVERSLEN	2

/* Valuses used in typeflag field */
#define	REGTYPE		'0'		/* Regular file */
#define	AREGTYPE	'\0'		/* Regular file */
#define	LNKTYPE		'1'		/* Link */
#define	SYMTYPE		'2'		/* Reserved */
#define	CHRTYPE		'3'		/* Character special */
#define	BLKTYPE		'4'		/* Block special */
#define	DIRTYPE		'5'		/* Directory */
#define	FIFOTYPE	'6'		/* FIFO special */
#define	CONTTYPE	'7'		/* Reserved */

/* Bits used in the mode field - values in octal */
#define	TSUID		04000		/* Set UID on execution */
#define	TSGID		02000		/* SET GID on execution */
#define	TSVTX		01000		/* Reserved */
					/* File permissions */
#define	TUREAD		00400		/* read by owner */
#define	TUWRITE		00200		/* write by owner */
#define	TUEXEC		00100		/* execute/search by owner */
#define	TGREAD		00040		/* read by group */
#define	TGWRITE		00020		/* write by group */
#define	TGEXEC		00010		/* execute/search by group */
#define	TOREAD		00004		/* read by other */
#define	TOWRITE		00002		/* write by other */
#define	TOEXEC		00001		/* execute/search by other */

#define _TAR_H_
#endif	/* _TAR_H_*/
