# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: libPW.mk 1.8 89/10/10 $@(#)libPW:libPW.mk	1.17"
ROOT=
CC=cc
AR=ar
LIB=$(ROOT)/lib
LIBP=$(ROOT)/usr/lib/libp
CPP = /lib/cpp
CFLAGS=-O 
LIBRARY = libPW.a

OBJECTS =	abspath.o anystr.o bal.o curdir.o fdfopen.o giveup.o \
	imatch.o index.o lockit.o logname.o move.o patoi.o \
	patol.o regcmp.o regex.o rename.o repeat.o repl.o satoi.o \
	setsig.o sname.o strend.o substr.o trnslat.o userdir.o \
	username.o verify.o any.o xalloc.o xcreat.o xlink.o \
	xopen.o xpipe.o xunlink.o xwrite.o xmsg.o alloca.o \
	cat.o dname.o fatal.o clean.o userexit.o zero.o zeropad.o

all:	profiled init objects

profiled:
	mkdir profiled

init:
	@-if vax;\
	then\
		cp vax/move.s move.s;\
		cp vax/alloca.s alloca.s;\
	elif u370;\
	then\
		cp u370/move.c move.c;\
		cp u370/alloca.c alloca.c;\
	elif u3b;\
	then\
		cp u3b/move.c move.c;\
		cp u3b/alloca.s alloca.s;\
	elif u3b5 || u3b15 || u3b2;\
	then\
		cp m32/move.c move.c;\
		cp m32/alloca.s alloca.s;\
	elif i386;\
	then\
		cp i386/move.s move.s;\
		cp i386/alloca.s alloca.s;\
	else\
		cp pdp11/move.c move.c;\
		cp pdp11/alloca.s alloca.s;\
	fi

objects: $&	$(OBJECTS)

.c.o:
	$(CC) -p -DMCOUNT $(CFLAGS) -c $< && \
	mv $*.o profiled/$*.o && \
	$(CC) -UMCOUNT $(CFLAGS) -c $<
.s.o:
	$(CPP) -P -DMCOUNT $(INCLUDE) $< | $(AS) -o profiled/$*.o && \
	$(CPP) -P -UMCOUNT $(INCLUDE) $< | $(AS) -o $*.o 

alloca.o:	alloca.s
move.o:		move.s

$(LIBRARY):	all
	-rm -f $(LIBRARY) profiled/$(LIBRARY)
	$(AR) r $(LIBRARY) $(OBJECTS)
	cd profiled && $(AR) r $(LIBRARY) $(OBJECTS)

install:	$(LIBRARY)
	cpset $(LIBRARY) $(LIB)/$(LIBRARY) 0444
	cpset profiled/$(LIBRARY) $(LIBP)/$(LIBRARY) 0444

clean:
	-rm -f $(OBJECTS)
	-rm -rf profiled
	-rm -f move.c move.s alloca.c alloca.s $(LIBRARY)

clobber:	clean
