	.file	"mcrt0.s"
/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any	*/
/*	actual or intended publication of such source code.	*/

	.ident	"@(#)$Header: mcrt0.s 1.9 90/04/21 $"

/*
 *	C language startup routine with profiling
 *	Assume exec code cleared direction flag
 *	Assume that %esp is set to the addr after the last word pushed.
 *	The stack contains (in order): argc, argv[], envp[], ...
 */

#include "sys.s"

#define	CBUFS		600		/* number of counters allowed */

	/*
	 * Global entities defined in this file
	 */
	.globl	_start
	.globl	exit
	.globl	environ
	.globl	_countbase

	.text
	.align	4
_start:
	/* 
	 * Allocate a NULL return address and a NULL previous %ebp as if
	 * there was a genuine call to _start so debuggers stack trace ok.
	 */
	subl	$8,%esp			/* space for NULL pc and %ebp */
	movl	%esp,%ebp		/* first stack frame begins here */

	/*
	 * The location of the envp array is found by adding the
	 * size of the argv array to the start of the argv array.
	 */
	movl	8(%ebp),%eax		/* argc */
	leal	16(%ebp,%eax,4),%edx	/* envp */
	movl	%edx,environ		/* copy to environ */
	leal	12(%ebp),%edx		/* argv */
	pushl	%edx			/* _ppinit(...,argv) */
	pushl	%eax			/* _ppinit(argc,argv) */
	call	_ppinit			/* _ppinit(argc,argv) */
	addl	$8,%esp			/* clear stack */
	call    _init_locale            /* call _init_locale() */
	movl	8(%ebp),%eax		/* argc */
	pushl	%edx			/* main(...,...,envp) */
	leal	12(%ebp),%edx		/* argv */
	movl	%edx,___Argv		/* save argv away */
	pushl	%edx			/* main(...,argv,envp) */
	pushl	%eax			/* main(argc,argv,envp) */

	/*
	 * Frame for call to main all built.
	 * Now allocate space for profiling buffers
	 * and turn on profiling.
	 */
	movl	$[etext+7],%ebx		/* %ebx = end of text (rounded up) */
	subl	$eprol,%ebx		/* %ebx = user text size */
	shrl	$3,%ebx			/* 	(tally area 1/4 size of text) */
	shll	$1,%ebx
	addl	$[8\*CBUFS+12+3],%ebx	/* add in entry counts and header and */
	andl	$-4,%ebx		/* 	round to word boundry */
	pushl	%ebx
	call	sbrk			/* sbrk(amount) */
	cmpl	$-1,%eax		/* failure ? */
	addl	$4,%esp			/* pop word off stack */
	je	.nospace
	movl	%eax,%ecx
	addl	$12,%ecx
	movl	%ecx,_countbase		/* set up count base for mcount */
	pushl	$CBUFS			/* number of counters (arg5) */
	shrl	$1,%ebx			/* %ebx = number of shorts in buffer */
	pushl	%ebx			/* (arg4) */
	pushl	%eax			/* start of buffer (arg3) */
	pushl	$etext			/* end of text (arg2) */
	pushl	$eprol			/* start of text (arg1) */
	call	monitor			/* monitor(lopc,hipc,buf,bufsz,CBUFS) */
	addl	$20,%esp		/* clear stack */

	/*
	 * Arguments for main are still on the stack.
	 */
	call	main			/* call main(...) */
	addl	$12,%esp		/* clear stack */
	pushl	%eax			/* push exit code for later */
	call	exit

	/*
	 * Exit, but first call monitor to write profile buffer.
	 */
exit:
	pushl	$0			/* (arg5) */
	pushl	$0			/* (arg4) */
	pushl	$0			/* (arg3) */
	pushl	$0			/* (arg2) */
	pushl	$0			/* (arg1) */
	call	monitor			/* turn off monitor*/
	addl	$20,%esp		/* clear stack */
	call	_cleanup		/* flush stdio buffers */
	pushl	SPARG0			/* push exit argument */
	call	_exit			/* and call exit */
	popl	%ecx
	xorl	R1,R1			/* if it returns ... return zero */
	SVC(1,exit)			/* in case user defines own exit() */
	hlt

	/*
	 * Not enough memory for profiling buffer
	 */
.nospace:
	pushl	$MESSL
	pushl	emesg
	pushl	$2
	call	write			/* write(2, emesg, MESSL) */
	addl	$12,%esp		/* clear stack */
	pushl	$-1
	call	exit			/* error exit */
	hlt

emesg:	/* "No space for monitor buffer\n" */
	.byte	78,111,32,115,112,97,99,101,32,102,111,114
	.byte	32,109,111,110,105,116,111,114
	.byte	32,98,117,102,102,101,114,10
	.set	MESSL,.-emesg
	.byte	0

	.data
	.align	4
environ:
	.long	0
_countbase:
	.long	0

	.text
	.align	4		/* generate padding NOP's before eprol */
eprol:				/* beginning of user text */
