	.file	"signal.s"
/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/	Copyright (c) 1984 AT&T
/	  All Rights Reserved

/	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
/	The copyright notice above does not evidence any
/	actual or intended publication of such source code.

	.ident	"@(#)$Header: signal.s 1.9 89/10/10 $"

/   C-library signal() routine recoded for IEEE floating-point
/ REMEMBER: SIGFPE is special in this environment!
/
/   In SVR3, five new system calls are added to this file. They are
/   sigset(), sighold(), sigrelse(), sigignore() and sigpause().	

/ FOR POSIX (IEEE std 1003.1 - Draft 13 ) 6 new signals are added
/ sigaction(), sigprocmask(), sigsuspend(), sigemptyset(), sigfillset(),
/ sigpending().

#include "sys.s"
#include "sysseq.s"
#define INLIBC 1
#include "sys/signal.h"

/ common entry point for signals
/
/ ssig()
/ {
/	register struct a {
/		int	signo;
/		union {
/			struct {
/				void	(*fun)();
/				void	(*sigreturn)();
/			} signal;
/			struct {
/				struct	sigaction	*act;
/				struct	sigaction	*oact;
/				void	(*sigreturn)();
/			} sigaction;
/			struct {
/				sigset_t	*set;
/				sigset_t	*oset;
/			} sigprocmask;
/		} arg;
/	} *uap;


//////////////////////////////////////////////////////////////////////
/This code gets executed on return from the users signal catching routine.

SYSCALL(0,sigclean)
	ret

#undef SYS_TYP
#define SYS_TYP	1

/___________________________________________________________________
/ void	(*signal(int sig, viod (*func)(int)))(int);
/___________________________________________________________________
ENTRY(signal)
	pushl	$sigclean	/ arg2	return address
	pushl	4+SPARG1	/ arg3	(was arg1) void (*func())()
	pushl	8+SPARG0	/ arg0  (was arg0) int signo
	movl	%esp,R1
_12sig:
	SVC(3,signal)
	jnc	_12ok
_12cerror:
	movl	%eax,errno
	movl	$-1,%eax
_12ok:
	addl	$12,%esp	/ adjust stack
	ret

/___________________________________________________________________
/ int	sighold(int sig);
/___________________________________________________________________
ENTRY(sighold)
	orl	$SIGHOLD,SPARG0
	SVC2(signal)
	jc	_cerror
	ret

/___________________________________________________________________
/ int	sigrelse(int sig);
/___________________________________________________________________
ENTRY(sigrelse)
	orl	$SIGRELSE,SPARG0
	SVC2(signal)
	jc	_cerror
	ret

/___________________________________________________________________
/ int	sigignore(int sig);
/___________________________________________________________________
ENTRY(sigignore)
	orl	$SIGIGNORE,SPARG0
	SVC2(signal)
	jc	_cerror
	ret

/___________________________________________________________________
/ int	sigpause(int sigsig);
/___________________________________________________________________
ENTRY(sigpause)
	orl	$SIGPAUSE,SPARG0
	SVC2(signal)
	jc	_cerror
	ret


//////////////////////////////////////////////////////////////////////
/ POSIX signals follow.

/___________________________________________________________________
/ int sigprocmask(int how, sigset_t set, sigset_t oset);
/___________________________________________________________________
ENTRY(sigprocmask)
	orl	$SIGPROCMASK,SPARG0	
	SVC3(signal)
	jc	_cerror
	ret

/___________________________________________________________________
/ int sigsuspend(sigset_t *mask);
/___________________________________________________________________
ENTRY(sigsuspend)
	movl	$SIGSUSPEND,R1	
sigsw1:
	movl	SPARG0,R2
	SVC(2,signal)
	jc	_cerror
	ret
/___________________________________________________________________
/ int sigemptyset(sigset_t *mask);
/___________________________________________________________________
ENTRY(sigemptyset)
	movl	$SIGEMPTYSET,R1
	jmp	sigsw1
/___________________________________________________________________
/ int sigfillset(sigset_t *mask);
/___________________________________________________________________
ENTRY(sigfillset)
	movl	$SIGFILLSET,R1	
	jmp	sigsw1
/___________________________________________________________________
/ int sigaddset(sigset_t *set, int signo);
/___________________________________________________________________
ENTRY(sigaddset)
	orl	$SIGADDSET,SPARG1	
sigsw2:
	movl	SPARG1,R1
	movl	SPARG0,R2
	SVC(2,signal)
	jc	_cerror
	ret
/___________________________________________________________________
/ int sigdelset(sigset_t *set, int signo);
/___________________________________________________________________
ENTRY(sigdelset)
	orl	$SIGDELSET,SPARG1	
	jmp	sigsw2
/___________________________________________________________________
/ int sigismember(sigset_t *set, int signo);
/___________________________________________________________________
ENTRY(sigismember)
	orl	$SIGISMEMBER,SPARG1	
	jmp	sigsw2
/___________________________________________________________________
/ int sigpending(sigset_t *mask);
/___________________________________________________________________
ENTRY(sigpending)
	movl	$SIGPENDING,R1	
	jmp	sigsw1
/___________________________________________________________________
/ int sigaltstack( (struct altstack *) new, (struct altstack *) old );
/___________________________________________________________________
/ENTRY(sigaltstack)
/	pushl	SPARG1		/ arg2	(was arg1) 
/	pushl	4+SPARG0	/ arg1  (was arg0)
/	pushl	$SIGALT
/	movl	%esp,R1
/	jmp	_12sig
/___________________________________________________________________
