# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)libc:libc.mk	1.26"
#
# makefile for libc
#
#
# The variable PROF is null by default, causing both the standard C library
# and a profiled library to be maintained.  If profiled object is not 
# desired, the reassignment PROF=@# should appear in the make command line.
#
# The variable IGN may be set to -i by the assignment IGN=-i in order to
# allow a make to complete even if there are compile errors in individual
# modules.
#
# See also the comments in the lower-level machine-dependent makefiles.
#

FPA=
FPFLAGS=
VARIANT=
SGS=
CFLAGS=-O
PCFLAGS=
PFX=
CC=$(PFX)cc
AR=ar
NM=nm
LORDER=$(PFX)lorder
ROOT=
LIB=$(ROOT)/lib
LIBP=$(ROOT)/usr/lib/libp
DONE=
PROF=
NONPROF=
DEFLIST=
MAKE=$(PFX)make
FP_OBJS= $(MACHINE)/gen/atof.[op] \
	 $(MACHINE)/gen/dtop.[op] \
	 $(MACHINE)/gen/ecvt.[op] \
	 $(MACHINE)/gen/biglitpow.[op] \
	 $(MACHINE)/gen/frexp.[op] \
	 $(MACHINE)/gen/ldexp.[op] \
	 $(MACHINE)/gen/ptod.[op] \
	 $(MACHINE)/gen/strtod.[op] \
	 $(MACHINE)/fp/fpgetmask.[op] \
	 $(MACHINE)/fp/fpgetround.[op] \
	 $(MACHINE)/fp/fpgetsticky.[op] \
	 $(MACHINE)/fp/fpsetmask.[op] \
	 $(MACHINE)/fp/fpsetround.[op] \
	 $(MACHINE)/fp/fpsetsticky.[op] \
	 port/gen/atof.[op] \
	 port/gen/drand48.[op] \
	 port/gen/ecvt.[op] \
	 port/gen/frexp.[op] \
	 port/gen/ldexp.[op] \
	 port/gen/modf.[op] \
	 port/gen/mon.[op] \
	 port/gen/strtod.[op] \
	 port/print/doprnt.[op] \
	 port/stdio/doscan.[op]

all:
	if pdp11 ; then $(MAKE) -e -f libc.mk specific MACHINE=pdp11 ; fi
	if vax ;   then $(MAKE) -e -f libc.mk specific MACHINE=vax ; fi
	if u3b ;   then $(MAKE) -e -f libc.mk specific MACHINE=u3b ; fi
	if u3b15 || u3b5 || u3b2 ;  then $(MAKE) -e -f libc.mk DEFLIST=-DM32 \
				specific MACHINE=m32 ; fi
	if u370 ;  then $(MAKE) -e -f libc.mk specific MACHINE=u370 ; fi
	if i386 ;  then $(MAKE) -e -f libc.mk specific check_387 MACHINE=i386;\
			$(MAKE) -e -f libc.mk specific check_1167 MACHINE=i386 \
			FPA="fpa" FPFLAGS="-Wc,-fpa" ; fi

specific: rm_fp_objs
	#
	# compile portable library modules
	cd port; $(MAKE) -e CC="$(CC)" FPFLAGS=$(FPFLAGS)
	#
	# compile machine-dependent library modules
	cd $(MACHINE); $(MAKE) -e CC="$(CC)" FPFLAGS=$(FPFLAGS)
	#
	# place portable modules in "object" directory, then overlay
	# 	the machine-dependent modules.
	-rm -rf object
	mkdir object
	cp port/*/*.o object
	$(PROF)cp port/*/*.p object
	cp $(MACHINE)/*/*.o object
	$(PROF)cp $(MACHINE)/*/*.p object
	#
	if [ -d m32mau ]; then \
		cd m32mau; \
		$(MAKE) -e CC="$(CC)"; \
		cd .. ;\
		cp m32mau/*/*.o object; \
		$(PROF)cp m32mau/*/*.p object ;\
	fi
	#
	# delete temporary libraries
	-rm -f lib.lib$(FPA)c
	$(PROF)-rm -f libp.lib$(FPA)c
	#
	# set aside run-time modules, which don't go in library archive!
	cd object; for i in *crt?.o; do mv $$i ..; done
	#
	# build archive out of the remaining modules.
	cd object; $(MAKE) -e -f ../$(MACHINE)/makefile archive \
		AR=$(AR)  LORDER=$(LORDER) PROF=$(PROF)
	-rm -rf object
	#
	$(DONE)

move:
	#
	# move the library or libraries into the correct directory
	for i in *crt?.o; do cp $$i $(LIB)/$(SGS)$$i ;\
		chmod 444 $(LIB)/$(SGS)$$i ;\
		chown bin $(LIB)/$(SGS)$$i ;\
		chgrp bin $(LIB)/$(SGS)$$i ;\
		rm -f $$i ; done
	cp lib.libc $(LIB)/lib$(VARIANT)c.a ; rm -f lib.libc
	cp lib.libfpac $(LIB)/lib$(VARIANT)fpac.a ; rm -f lib.libfpac
	chmod 444 $(LIB)/lib$(VARIANT)c.a $(LIB)/lib$(VARIANT)fpac.a
	chown bin $(LIB)/lib$(VARIANT)c.a $(LIB)/lib$(VARIANT)fpac.a
	chgrp bin $(LIB)/lib$(VARIANT)c.a $(LIB)/lib$(VARIANT)fpac.a
	$(PROF)if [ ! -d $(LIBP) ]; then \
	$(PROF)	mkdir $(LIBP); \
	$(PROF)fi
	$(PROF)cp libp.libc $(LIBP)/lib$(VARIANT)c.a ; rm -f libp.libc
	$(PROF)cp libp.libfpac $(LIBP)/lib$(VARIANT)fpac.a ; rm -f libp.libfpac
	$(PROF)chmod 444 $(LIBP)/lib$(VARIANT)c.a $(LIBP)/lib$(VARIANT)fpac.a
	$(PROF)chown bin $(LIBP)/lib$(VARIANT)c.a $(LIBP)/lib$(VARIANT)fpac.a
	$(PROF)chgrp bin $(LIBP)/lib$(VARIANT)c.a $(LIBP)/lib$(VARIANT)fpac.a

install: all move

clean:
	#
	# remove intermediate files except object modules and temp library
	-rm -rf lib*.contents obj*
	cd port ;  $(MAKE) clean
	if pdp11 ; then cd pdp11 ; $(MAKE) clean ; fi
	if vax ;   then cd vax ;   $(MAKE) clean ; fi
	if u3b ;   then cd u3b ;   $(MAKE) clean ; fi
	if u3b15 || u3b5 || u3b2 ;   then cd m32 ;   $(MAKE) clean ; fi
	if u370 ;  then cd u370 ;  $(MAKE) clean ; fi
	if i386 ;  then cd i386 ;  $(MAKE) clean ; fi

clobber:
	#
	# remove intermediate files
	-rm -rf *.o lib*.libc lib*.libfpac lib*.contents obj*
	cd port ;  $(MAKE) clobber
	if pdp11 ; then cd pdp11 ; $(MAKE) clobber ; fi
	if vax ;   then cd vax ;   $(MAKE) clobber ; fi
	if u3b ;   then cd u3b ;   $(MAKE) clobber ; fi
	if u3b15 || u3b5 || u3b2;   then cd m32 ;   $(MAKE) clobber ; fi
	if [ -d m32mau ]; then \
		cd m32mau; \
		$(MAKE) clobber; \
		cd .. ;\
	fi
	if u370 ;  then cd u370 ;  $(MAKE) clobber ; fi
	if i386 ;  then cd i386 ;  $(MAKE) clobber ; fi

rm_fp_objs:
	rm -f $(FP_OBJS)
#
# Check to see the libraries are pure (only 387 or only 1167 code)
#
check_387:
	$(NM) lib.lib$(FPA)c | awk '/_1167_flt/ { print; exit 1 }'
check_1167:
	$(NM) lib.lib$(FPA)c | awk '/_387_flt/ { print; exit 1 }'
