/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libc-port:gen/getpwent.c	1.10"

/*
 * getpwent.c
 *	get password file entry
 */

/*LINTLIBRARY*/
#include <sys/param.h>
#include <stdio.h>
#include <pwd.h>
#include <errno.h>

extern void rewind();
extern long atol();
extern FILE *fopen();
extern int fclose();
extern char *fgets();
extern int errno;
#ifdef	CCS
extern char *getenv();
#endif	/* CCS */

#ifdef	CCS
static char *etc_pass;
static char pass_path[BUFSIZ];
#endif	/* CCS */
static char PASSWD[] = "/etc/passwd";
static char EMPTY[] = "";
static FILE *pwf = NULL;
static char line[BUFSIZ+1];
static struct passwd passwd;

void
setpwent()
{
#ifdef	CCS
	if(pwf == NULL) {
		if ((etc_pass = getenv("TOOLS")) == NULL)
			etc_pass = PASSWD;
		else {
			strcpy(pass_path, etc_pass);
			strcat(pass_path, "/passwd");
			etc_pass = pass_path;
		}
		pwf = fopen(etc_pass, "r");
		if (pwf == NULL) {
			fprintf(stderr,"Can't find %s using %s instead.\n",etc_pass,PASSWD);
			pwf = fopen(PASSWD, "r");
		}
	}
#else	/* CCS */
	if(pwf == NULL)
		pwf = fopen(PASSWD, "r");
#endif	/* CCS */
	else
		rewind(pwf);
}

void
endpwent()
{
	if(pwf != NULL) {
		(void) fclose(pwf);
		pwf = NULL;
	}
}

static char *
pwskip(p)
register char *p;
{
	while(*p && *p != ':' && *p != '\n')
		++p;
	if(*p == '\n')
		*p = '\0';
	else if(*p)
		*p++ = '\0';
	return(p);
}

struct passwd *
getpwent()
{
	extern struct passwd *fgetpwent();

	if(pwf == NULL) {
		if((pwf = fopen(PASSWD, "r")) == NULL)
			return(NULL);
	}
	return (fgetpwent(pwf));
}

struct passwd *
fgetpwent(f)
FILE *f;
{
	register char *p;
	char *end;
	long	x, strtol();
	char *memchr();

	p = fgets(line, BUFSIZ, f);
	if(p == NULL)
		return(NULL);
	passwd.pw_name = p;
	p = pwskip(p);
	passwd.pw_passwd = p;
	p = pwskip(p);
	if (p == NULL || *p == ':') {
		/* check for non-null uid */
		errno = EINVAL;
		return (NULL);
	}
	x = strtol(p, &end, 10);	
	if (end != memchr(p, ':', strlen(p))) {
		/* check for numeric value */
		errno = EINVAL;
		return (NULL);
	}
	p = pwskip(p);
	/*  (Used to require UID <= MAXUID, but NFS needs "nobody" uid, -2)  */
	passwd.pw_uid = (x != (uid_t)x) ? (MAXUID+1) : x;
	if (p == NULL || *p == ':') {
		/* check for non-null uid */
		errno = EINVAL;
		return (NULL);
	}
	x = strtol(p, &end, 10);	
	if (end != memchr(p, ':', strlen(p))) {
		/* check for numeric value */
		errno = EINVAL;
		return (NULL);
	}
	p = pwskip(p);
	/*  (Used to require GID <= MAXUID, but NFS needs "nobody" gid, -2)  */
	passwd.pw_gid = (x != (gid_t)x) ? (MAXUID+1) : x;
	passwd.pw_comment = p;
	passwd.pw_gecos = p;
	p = pwskip(p);
	passwd.pw_dir = p;
	p = pwskip(p);
	passwd.pw_shell = p;
	(void) pwskip(p);

	p = passwd.pw_passwd;
	while(*p && *p != ',')
		p++;
	if(*p)
		*p++ = '\0';
	passwd.pw_age = p;
	return(&passwd);
}
