/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libc-port:gen/modf.c	1.10"
/*LINTLIBRARY*/
/*
 * modf(value, iptr) returns the signed fractional part of value
 * and stores the integer part indirectly through iptr.
 *
 */

#include <nan.h>
#include <values.h>
#include <ieeefp.h>

#ifdef i387
/* Get current fpu control word */
asm
_getcword(cw)
/* struct _cw87 *cw;	*/
{
%reg cw;
	fstcw	(cw)
%mem cw;
	movl	cw,%eax
	fstcw	(%eax)
}

/* Load a new fp control word */
asm
_putcword(cw)
/* struct _cw87 cw;	*/
{
%reg cw;
	fldcw	(cw)
%mem cw;
	movl	cw,%eax
	fldcw	(%eax)
}
#endif	/* i387 */

double
modf(value, iptr)
double value; /* don't declare register, because of KILLNaN! */
register double *iptr;
{
	register double absvalue;
#ifdef	i387
	struct _cw87 cw, old_cw;
#endif	/* i387 */

	KILLNaN(value); /* raise exception on Not-a-Number (3b only) */
	if ((absvalue = (value >= 0.0) ? value : -value) >= MAXPOWTWO)
		*iptr = value; /* it must be an integer */
	else {
#ifdef	i387
		_getcword(&old_cw);
		cw = old_cw;
		cw.prec = 2;			/* put 387 in 53 bit mode */
		_putcword(cw);
#endif	/* i387 */

		*iptr = absvalue + MAXPOWTWO; /* shift fraction off right */
		*iptr -= MAXPOWTWO; /* shift back without fraction */
		while (*iptr > absvalue) /* above arithmetic might round */
			*iptr -= 1.0; /* test again just to be sure */
		if (value < 0.0)
			*iptr = -*iptr;

#ifdef	i387
		_putcword(old_cw);		/* restore 387 to 64 bit mode */
#endif	/* i387 */
	}
	return (value - *iptr); /* signed fractional part */
}
