/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: nlist.c 1.8 90/03/13 $@(#)libc-port:gen/nlist.c	1.16"

/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*
 * This has been modified to greatly decrease the time required to find
 * symbols.  Methods are:
 *   -- use fread instead of read
 *   -- terminate when last symbol is found
 *   -- test first character of strings before calling string compare routien
 *   -- read groups of symbol records.
 */

#include <stdio.h>

/*LINTLIBRARY*/
#if vax
#define ISMAGIC(x)	((((unsigned short)x)==(unsigned short)VAXROMAGIC) || \
			  (((unsigned short)x)==(unsigned short)VAXWRMAGIC))
#endif
#if u3b
#define ISMAGIC(x)	((((unsigned short)x)==(unsigned short)N3BMAGIC) || \
			  (((unsigned short)x)==(unsigned short)NTVMAGIC))
#endif
#if M32
#define ISMAGIC(x)	((x)==FBOMAGIC)
#endif
#if i386
#define ISMAGIC(x)	((((unsigned short)x)==(unsigned short)I386MAGIC) || \
			  (((unsigned short)x)==(unsigned short)SVI386MAGIC))
#endif
#if u3b || vax || M32 || i386
#define BADMAG(x)	(!ISMAGIC(x))
#endif


/*
 *	When a UNIX aout header is to be built in the optional header,
 *	the following magic numbers can appear in that header:
 *
 *		AOUT1MAGIC : default : readonly sharable text segment
 *		AOUT2MAGIC :	     : writable text segment
 *		PAGEMAGIC  :	     : directly paged object file
 */

#define AOUT1MAGIC 0410
#define AOUT2MAGIC 0407
#define PAGEMAGIC  0413

#define	SGSNAME	""
#define SGS ""
#define RELEASE "Release 6.0 6/1/82"
#include <a.out.h>

#if vax || u3b || M32 || i386
#	ifndef FLEXNAMES
#		define FLEXNAMES 1
#	endif
#	undef n_name		/* this patch causes problems here */
#endif

#if !(u3b || vax || M32 || i386)
#define SPACE 100		/* number of symbols read at a time */
#endif

extern long ftell();
extern int fseek();
extern int strncmp(), strcmp();

#define BUF_READ	1	/* to read groups of symbol entries */

#ifdef	BUF_READ
# if SYMSZE != AUXESZ
# undef BUF_READ
# endif
#endif

#ifdef BUF_READ
#define COUNT		((8 * BUFSIZE) / SYMESZ)
#endif

int
nlist(name, list)
	char *name;
	struct nlist *list;
{
#if u3b || vax || M32 || i386
	extern char *malloc();
	extern void free();
	struct	filehdr	buf;
#ifdef BUF_READ
	char sym[COUNT * SYMESZ];
	int need_del = 0;
	int in_array; = 0
	char *xx;
#else
	struct	syment	sym;
#endif
	struct	auxent	aux;
	long n;
	int bufsiz=FILHSZ;
#if FLEXNAMES
	char *strtab = (char *)0;
	long strtablen;
#endif
	register struct nlist *p;
	register struct syment *q;
#else
	struct nlist space[SPACE];
	struct exec buf;
	int	nlen=sizeof(space[0].n_name), bufsiz=(sizeof(buf));
	unsigned n, m; 
	register struct nlist *p, *q;
#endif
	long	sa;
	FILE	*fp;
	long	home;
	int	sym_count = 0;

	for (p = list; p->n_name && p->n_name[0]; p++)	/* n_name can be ptr */
	{
		sym_count++;
		p->n_type = 0;
		p->n_value = 0;
#if u3b || vax || M32 || i386
		p->n_value = 0L;
		p->n_scnum = 0;
		p->n_sclass = 0;
#endif
	}

	if (sym_count == 0)
		return(0);
	
	if ((fp = fopen(name, "r"))  == NULL)
		return(-1);
	(void) fread((char *)&buf, bufsiz, 1, fp);
#if u3b || vax || M32 || i386
	if (BADMAG(buf.f_magic))
#else
	if (BADMAG(buf))
#endif
	{
		(void) fclose(fp);
		return (-1);
	}
#if u3b || vax || M32 || i386
	sa = buf.f_symptr;	/* direct pointer to sym tab */
	fseek(fp, sa, 0);
	q = &sym;
	n = buf.f_nsyms;	/* num. of sym tab entries */
#else
	sa = buf.a_text;
	sa += buf.a_data;
#if u370
	sa += (long)(buf.a_trsize + buf.a_drsize);
#endif
#if pdp11
	if (buf.a_flag != 1)
		sa += sa;
	else if ( buf.a_magic == A_MAGIC5 )
		sa += (long)buf.a_hitext << 16; /* remainder of text size for system overlay a.out */
#endif
	sa += (long)sizeof(buf);
	(void) fseek(fp, sa, 0);
	n = buf.a_syms;
#endif

	while (n)
	{
#if u3b || vax || M32 || i386
#ifdef BUF_READ
		while (in_array == 0) {
			if (n < COUNT)
				in_array = n;
			else
				in_array = COUNT;
			if (fread((char *)sym, SYMESZ, in_array, fp) != in_array) {
				fclose(fp);
				return(-1);
			}
			q = (struct syment *) &sym[0];
			if (need_del) {
				if (need_del > in_array) {
					need_del -= in_array;
					in_array = 0;
				} else {
					in_array -= need_del
					xx = (char *) q;
					xx += (need_del * SYMESZ);
					q = (struct syment *) xx;
					need_del = 0;
				}
			}
		}
#else
		fread((char *)&sym, SYMESZ, 1, fp);
		n -= (q->n_numaux + 1L);
		/* read past aux ent , if there is one */
		if (q->n_numaux != 0)
			fread((char *) &aux, AUXESZ, q->n_numaux, fp);
#endif
#else
		m = (n < sizeof(space))? n: sizeof(space);
		(void) fread((char*)space, m, 1, fp);
		n -= m;
		for (q=space; (int)(m -= sizeof(space[0])) >= 0; ++q)
		{
#endif
			for (p = list; p->n_name && p->n_name[0]; ++p)
			{
#if u3b || vax || M32 || i386
				/*
				* For 6.0, the name in an object file is
				* either stored in the eight long character
				* array, or in a string table at the end
				* of the object file.  If the name is in the
				* string table, the eight characters are
				* thought of as a pair of longs, (n_zeroes
				* and n_offset) the first of which is zero
				* and the second is the offset of the name
				* in the string table.
				*/
#if FLEXNAMES
				if (q->n_zeroes == 0L)	/* in string table */
				{
					if (strtab == (char *)0) /* need it */
					{
						home = ftell(fp);

						if (fseek(fp, buf.f_symptr +
							buf.f_nsyms * SYMESZ,
							0) == -1 || fread(
							(char *)&strtablen,
							sizeof(long), 1, fp)
							!= 1 ||
							(strtab = malloc(
							(unsigned)strtablen))
							== (char *)0 ||
							fread((char *)(strtab +
							sizeof(long)),
							strtablen -
							sizeof(long), 1, fp)
							!= 1 ||
							strtab[strtablen - 1]
							!= '\0' ||
							fseek(fp, home, 0) ==
							-1)
						{
							(void) fclose(fp);
							if (strtab != (char *)0)
								free(strtab);
							return (-1);
						}
					}
					if (q->n_offset < sizeof(long) ||
						q->n_offset >= strtablen)
					{
						(void) fclose(fp);
						if (strtab != (char *)0)
							free(strtab);
						return (-1);
					}
					if (strtab[q->n_offset] != p->n_name[0])
						continue;
					if (strcmp(&strtab[q->n_offset],
						p->n_name))
					{
						continue;
					}
				}
				else
#endif /*FLEXNAMES*/
				{
					if (q->_n._n_name[0] != p->n_name[0])
						continue;
					if (strncmp(q->_n._n_name,
						p->n_name, SYMNMLEN))
					{
						continue;
					}
				}

#else
				if (p->n_name[0] != q->n_name[0])
					continue;
				if (strncmp(p->n_name, q->n_name, nlen))
					continue;
#endif
#if u3b || vax || M32 || i386
				/* got one already */
				if (p->n_value != 0L && p->n_sclass == C_EXT)
					break;
#endif
				p->n_value = q->n_value;
				p->n_type = q->n_type;
				if ((p->n_value != 0L) && (p->n_sclass == C_EXT))
					sym_count--;
#if u3b || vax || M32 || i386
				p->n_scnum = q->n_scnum;
				p->n_sclass = q->n_sclass;
#endif
				if (sym_count == 0) {
					if (strtab != (char *) 0)
						free(strtab);
					fclose(fp);
					return(0);
				}
				break;
			}
#if !(u3b || vax || M32 || i386)
		}
#endif
#ifdef BUF_READ
		need_del = q->n_numaux + 1;
		n -= need_del;
		if (n > 0) { 
			if (in_array > need_del) {
				xx = (char *) q;
				xx += (need_del * SYMSEZ);
				q = (struct syment *) xx;
				in_array -= need_del;
				need_del = 0;
			} else {
				need_del -= in_array;
				in_array = 0;
			}
		}
#endif
	}
	(void) fclose(fp);
#if (vax || u3b || M32 || i386) && FLEXNAMES
	if (strtab != (char *)0)
		free(strtab);
#endif
	return (0);
}
