/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred."
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libc-port:gen/ssignal.c	1.4"
/*LINTLIBRARY*/
/*
 *	ssignal, gsignal: software signals
 */
#include <signal.h>

/* Highest allowable user signal number */
#define MAXSSIG 16

/* Lowest allowable signal number (lowest user number is always 1) */
#define MINSSIG (-4)

/* Table of signal values */
static int (*sigs[MAXSSIG-MINSSIG+1])();

#define SSIG_DFL	(int (*)())0
#define SSIG_IGN	(int (*)())1

int 
(*ssignal(sig, fn))()
register int sig, (*fn)();
{
	register int (*savefn)();

	if(sig >= MINSSIG && sig <= MAXSSIG) {
		savefn = sigs[sig-MINSSIG];
		sigs[sig-MINSSIG] = fn;
	} else
		savefn = SSIG_DFL;

	return(savefn);
}

int
gsignal(sig)
register int sig;
{
	register int (*sigfn)();

	if(sig < MINSSIG || sig > MAXSSIG ||
				(sigfn = sigs[sig-MINSSIG]) == SSIG_DFL)
		return(0);
	else if(sigfn == SSIG_IGN)
		return(1);
	else {
		sigs[sig-MINSSIG] = SSIG_DFL;
		return((*sigfn)(sig));
	}
}
