/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred."
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libc-port:gen/ttyslot.c	1.9"
/*LINTLIBRARY*/
/*
 * Return the number of the slot in the utmp file
 * corresponding to the current user: try for file 0, 1, 2.
 * Returns -1 if slot not found.
 */
#include <sys/types.h>
#include "utmp.h"
#define	NULL	0

extern char *ttyname(), *strrchr();
extern int strncmp(), open(), read(), close();
extern int _utmp_slot_num;

static char utmp_file[] = "/etc/utmp";

int
ttyslot()
{
	struct utmp ubuf, *u;
	struct utmp *getutline();
	register char *tp;
	register int s, fd;
	int slot_num;

	if((tp=ttyname(0)) == NULL && (tp=ttyname(1)) == NULL &&
					(tp=ttyname(2)) == NULL)
		return(-1);

	tp += sizeof("/dev/") - 1;

	(void) memset((char *)&ubuf, '\0', sizeof(ubuf));
	strncpy(ubuf.ut_line, tp, sizeof(ubuf.ut_line));
	u = getutline(&ubuf);
	slot_num = _utmp_slot_num;
	if (u != (struct utmp *) NULL) {
		if (slot_num != -1) {
			endutent();
			return(slot_num);
		}
	}

	endutent();
	if((fd=open(utmp_file, 0)) < 0)
		return(-1);
	s = 0;
	while(read(fd, (char*)&ubuf, sizeof(ubuf)) == sizeof(ubuf)) {
		if(    (ubuf.ut_type == INIT_PROCESS ||
			ubuf.ut_type == LOGIN_PROCESS ||
			ubuf.ut_type == USER_PROCESS ||
			ubuf.ut_type == DEAD_PROCESS ) &&
			strncmp(tp, ubuf.ut_line, sizeof(ubuf.ut_line)) == 0){

			(void) close(fd);
			return(s);
		}
		s++;
	}
	(void) close(fd);
	return(-1);
}
