/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
/*
 * Initital data for Xopen interface.
 * _inmem contains the currently loaded locale and sublocales.
 * _C_inmem contains the default C locale strings.
 * Note that at intialization both point to the same strings.
 */
/* $Log:	_loadlang.h,v $
 *
 */

#ident	"$Header: _loadlang.h 1.7 90/10/23 $"

#ifndef __LOADLANG_H_

#define	DEF_LANGINFO	"/LANGINFO"

char *_inmem[MAXSTRMSG+2] = {
        "                                                                       ",

	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday",
	
	"Sun",
	"Mon",
	"Tue",
	"Wed",
	"Thu",
	"Fri",
	"Sat" ,
	
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December",

	"Jan",
	"Feb",
	"Mar",
	"Apr",
	"May",
	"Jun",
	"Jul",
	"Aug",
	"Sep",
	"Oct",
	"Nov",
	"Dec",

	".",
	"",
	"yes",
	"no",
	"",

	"%a %b %d %H:%M:%S %Y",
	"%m/%d/%y",
	"%H:%M:%S",

	"AM",
	"PM",

	NULL,
};

char *_C_inmem[MAXSTRMSG+2] = { NULL } ;

static int _xo_ctype_entry[] =    { NULL };
static int _xo_numeric_entry[] =  { RADIXCHAR, THOUSEP, NULL };
static int _xo_collate_entry[] =  { NULL };
static int _xo_messages_entry[] = { NULL };
static int _xo_monetary_entry[] = { CRNCYSTR, NULL };
static int _xo_all_entry[] =      { YESSTR, NOSTR, NULL };
static int _xo_time_entry[] = 
	{ DAY_1,   DAY_2,   DAY_3,   DAY_4,   DAY_5,   DAY_6,   DAY_7,
          ABDAY_1, ABDAY_2, ABDAY_3, ABDAY_4, ABDAY_5, ABDAY_6, ABDAY_7,
	  MON_1, MON_2, MON_3, MON_4,  MON_5,  MON_6,
	  MON_7, MON_8, MON_9, MON_10, MON_11, MON_12,
	  ABMON_1, ABMON_2, ABMON_3, ABMON_4,  ABMON_5,  ABMON_6,
	  ABMON_7, ABMON_8, ABMON_9, ABMON_10, ABMON_11, ABMON_12, 
	  D_T_FMT, D_FMT, T_FMT, AM_STR, PM_STR, NULL 
	};

static struct	xo_clang {
	char		*name;
	int		ref_cnt;
	char    	**langfo_ptr;
	struct xo_clang	*forw;
	struct xo_clang	*back;
} xo_langfo = {
	"/usr/lib/locale/C/LANGINFO",
	4,
	_C_inmem,
	NULL,
	NULL
};


static struct xopen_langinfo {
	struct xo_clang	*ctype_loc;
	int 		*ctype_entry;

	struct xo_clang	*numeric_loc;
	int  		*numeric_entry;

	struct xo_clang	*time_loc; 
	int  		*time_entry; 

	struct xo_clang	*collate_loc;
	int  		*collate_entry;

	struct xo_clang	*messages_loc;
	int  		*messages_entry;

	struct xo_clang	*monetary_loc;
	int  		*monetary_entry;

	struct xo_clang	*all_loc;
	int 		*all_entry;

} xo_locale_info =  {
	NULL, NULL,
	&xo_langfo, _xo_numeric_entry,
	&xo_langfo, _xo_time_entry,
	NULL, NULL,
	NULL, NULL,
	&xo_langfo, _xo_monetary_entry,
	&xo_langfo, _xo_all_entry
};

#define __LOADLANG_H_
#endif /* __LOADLANG_H_ */
