/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*	Copyright (c) 1987 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/


#ident "$Header: strxfrm.c 1.11 90/06/27 $@(#)lib-port:strxfrm.c	1.4 88/01/06 AT&T UEL"

#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string.h>
#include <locale.h>
#include <malloc.h>
#include "_locale.h"

/* The following macros are here to avoid the syntax error in
   regexp.h.  since we are only using advance() not compile(),
   these macro do not have any special meaning or use.      */
#define	INIT
#define	GETC()	0
#define	PEEKC()	0
#define	UNGETC(c) 0
#define	RETURN(c) return;
#define	ERROR(c) return
#include <regexp.h>

#define	ushort		unsigned short
#define	uchar		unsigned char
#define	MAX_REG_EXP	1024		/* maximum length of compiled reg exp */
#define	MAX_WEILEN	512		/* maximum number of ushorts
					   that a one-to-many or
					   many-to-many mapping can produce */
#define	DEF_COLL	"/LC_COLLATE"
#define	ONETOMANY	0x8000
#define	TWOTOONE	0x4000
#define	SECONDARY	0x3f00
#define	PRIMARY		0x00ff

static	uchar	*mycoll;
static	ushort	*_colltbl;
static	ushort  *_2_to_1;
static	int	n_2to1_map;	/* number of 2 to 1 entries */
static	ushort	**val_1_to_n;
extern char _cur_locale[][LC_NAMELEN];

static int 	ushort_cmp();
static void 	free_all();
static int	setcollate();
extern char 	*getenv();
#if i386
static void	swapbytes();
#endif

typedef struct subsrec {		/* "substitute" records */
	uchar	*src_str;
	ushort	*subs_values;
	struct subsrec	*link;
} subs_rec;

static	subs_rec *head = 0, *tail = 0;

#define	found( value )	{					\
		if (--n > 0)					\
			*s1++ = value & PRIMARY;		\
		if ((value & SECONDARY) && --n > 0)		\
			*_2ndary-- = (value & SECONDARY) >> 8;	\
	}

/*
 *	ANSI 4.11.4.5 strxfrm function
 */
size_t
strxfrm(s1, s2, maxlen)
uchar *s1, *s2;
int maxlen;
{
	extern int _strxfrm();
	return _strxfrm(s1, s2, maxlen, '\0');
}

int
_strxfrm(s1,  s2,  maxlen, eolc)
register uchar	*s1;
register uchar	*s2;
int	maxlen;
uchar	eolc;
{
	/*  Local Declarations  */
	register uchar *_2ndary;
	uchar	*p;
	uchar	*os1 = s1;
	int	n = maxlen;
	_2ndary = s1 + maxlen - 1;

	setcollate();

	if (!_colltbl) {	/* default collation, weight = ascii value */
		for (--s2; *++s2 != eolc;)
			if (--n > 0)
				*s1++ = *s2;
		if (n > 0)
			*s1 = '\0';
		return maxlen - n;
	}

	for( ; *s2 != eolc; ) {
		if (head) {	/* -r flag */
			subs_rec *srp = head;
			while (srp)
				if (advance(s2,srp->src_str)) {
					s2 = (uchar *)loc2;
					break;
				}
				else
					srp = srp->link;
			if (srp) {
				ushort *usp = srp->subs_values;
				for (; *usp; usp++)
					found(*usp);	/* many to many */
				continue;
			}
		}
		else {	/* no -r flag */
			if (_colltbl[*s2] & ONETOMANY && val_1_to_n) {
				ushort *usp = val_1_to_n[*s2];
				for (; *usp; usp++)
					found(*usp);	/* 1 to many */
				s2++;
				continue;
			}
		}

		/* no 1-to-many or many-to-many found, try 2 to 1 */

		if ((_colltbl[*s2] & TWOTOONE) && *(s2+1) && _2_to_1) {
			ushort tmpc = *s2 << 8 | *(s2+1);
			ushort *res;
			if (res = (ushort *)bsearch(&tmpc, _2_to_1, n_2to1_map,
					2 * sizeof(ushort), ushort_cmp)) {
				found(*(res+1));
				s2 += 2;
				continue;
			}
		}

		/* character not mapped, see if don't care */

		if((_colltbl[*s2] & PRIMARY) != 1)
			found( _colltbl[*s2] );
		s2++;
	}

	if (n > 0) {				/* if we don't get overflow */
		uchar c;			/* put the result in order  */
		uchar *p = os1 + maxlen - 1;
		while (p > s1 && p > _2ndary) {
			c = *s1;
			*s1++ = *p;
			*p-- = c;
		}
		os1[maxlen - n] = '\0';
	}
	return maxlen - n;
}

/*
 *	ANSI 4.11.4.3 strcoll() function
 */

int
strcoll( s1, s2 )
uchar *s1, *s2;
{
	extern int _strcoll();
	return _strcoll(s1, s2, '\0');
}

static struct coll_rec {
	uchar	*str;
	ushort	*next_wgt;
} coll_recs[2];

int
_strcoll( s1, s2, eolc )
uchar *s1, *s2;
uchar eolc;
{
	int w1, w2;
	int sec_cmp = 0;	/* sec_cmp keeps track of the
				   comparison of secondary weights.
				   if all primary weights in s1 match
				   with those in s2, this value is returned */
	setcollate();

	coll_recs[0].str = s1;
	coll_recs[1].str = s2;
	coll_recs[0].next_wgt = 
	coll_recs[1].next_wgt = (ushort *)0;

	do {
		w1 = _wgt_next(&coll_recs[0], eolc);
		w2 = _wgt_next(&coll_recs[1], eolc);
		if (!sec_cmp)
			sec_cmp = (w1 & SECONDARY) - (w2 & SECONDARY);
	} while ((w1 & PRIMARY) == (w2 & PRIMARY) && w1 );

	if ((w1 & PRIMARY) == (w2 & PRIMARY))
		return sec_cmp;
	else
		return (w1 & PRIMARY) - (w2 & PRIMARY);
}

static int
_wgt_next( wstru, eolc )
struct coll_rec *wstru;
uchar eolc;
{
	uchar	*ucp;

	if (wstru->next_wgt && *(wstru->next_wgt))
		return *(wstru->next_wgt++);

	for(;;) {
		if (*(wstru->str) == eolc)
			return 0;
		if (head) {
			subs_rec *srp = head;
			while (srp)
				if (advance(wstru->str,srp->src_str)) {
					wstru->str = (uchar *)loc2;
					wstru->next_wgt = srp->subs_values + 1;
					return *srp->subs_values;
				}
				else
					srp = srp->link;
		}
		else {
			if (!_colltbl)
				return *(wstru->str)++;
			if (_colltbl[*(wstru->str)] & ONETOMANY && val_1_to_n) {
				wstru->next_wgt = val_1_to_n[*(wstru->str)++];
				return *(wstru->next_wgt)++;
			}
		}
	
		if ((_colltbl[*(wstru->str)] & TWOTOONE) && 
						*(wstru->str+1) && _2_to_1) {
			ushort tmpc = *(wstru->str) << 8 | *(wstru->str+1);
			ushort *res;
			if (res = (ushort *)bsearch(&tmpc, _2_to_1, n_2to1_map,
					2 *sizeof(ushort), ushort_cmp)) {
				wstru->str += 2;
				return *(res+1);
			}
		}

		if ((_colltbl[*(wstru->str)] & PRIMARY) != 1)
			return _colltbl[*(wstru->str)++];
		else
			*(wstru->str)++;	/* don't care, try next */
	}
}

static int
setcollate()
{
	static char saved_locale[LC_NAMELEN] = "C";
	static char failed_locale[LC_NAMELEN] = "";
	uchar	tmp_re[MAX_REG_EXP];
	ushort	tmpbuf_s[MAX_WEILEN];
	char	pathname[128];
	register int fd = 0;
	uchar *p, *np;
	uchar *tmp_1ton;
	ushort *usp1;
	struct stat fstat_buf;
	uchar c;
	int size, i;

	if (strcmp(_cur_locale[LC_COLLATE], saved_locale) == 0)
		return 0 ;		/* locale not changed */

	if (strcmp(_cur_locale[LC_COLLATE], failed_locale) == 0)
		return 1;		/* if this is the locale we
					   failed last time, don't bother */
	(void)strcpy(pathname, P_locale);
	(void)strcpy(&pathname[L_locale - 1], _cur_locale[LC_COLLATE]);
	(void)strcat(pathname, DEF_COLL);
	free_all();			/* free old memory */

	if ((fd = open(pathname, O_RDONLY)) < 0 ||
	   fstat(fd, &fstat_buf) != 0 ||
	   (mycoll = (uchar *)malloc(fstat_buf.st_size)) == NULL ||
	   (size = read( fd, mycoll, fstat_buf.st_size)) != fstat_buf.st_size) {
		if ( fd >= 0 )
			close( fd );
		goto fail_exit;
	}
	(void)close(fd);

	for (p = mycoll; *p == '\\';) {
		if (!head)
			tail = head = (subs_rec *)malloc(sizeof(subs_rec));
		else {
			tail->link = (subs_rec *)malloc(sizeof(subs_rec));
			tail = tail->link;
		}
		if (!tail)
			goto fail_exit;
		tail->link = (subs_rec *)0;
		tail->subs_values = (ushort *)0;
		np = tmp_re;
		do {
			c = 0;
			while (*++p >= '0' && *p <= '9')
				c = (c << 3) + *p - '0';
		} while ((*np++ = c) != '\026');
		if (!(tail->src_str = (uchar *)malloc( np - tmp_re )))
				goto fail_exit;
		(void)memcpy(tail->src_str,tmp_re,np - tmp_re);
	}
	/*
	 * Update _colltbl only after everything works.
	 */
	_colltbl = (ushort *)p;
#if i386
	swapbytes(_colltbl,SZ_COLLATE);
#endif
	tmp_1ton = (p += SZ_COLLATE);
	while( *p++ )	/* skip until after double NULL */
		while( *p++ );
	n_2to1_map = ((mycoll + size - p + 3) & ~ 3) / 4 - 1;

	/* copy _2_to_1 and val_2_to_1 		  	    */
	/* to a new buffer and sort the table for bsearch() */

	if (n_2to1_map) {
		if (!(_2_to_1 = (ushort *)malloc( 
					     sizeof(ushort) * 2 * n_2to1_map )))
			goto fail_exit;

		usp1 = (ushort *)p + n_2to1_map;

			/*
			 * This strange piece o code is to inc the ushort
			 * pointer by a byte. i.e. 1 not 2 
			 */
		usp1 = (ushort *)((uchar *)usp1 + 1);

		for (i = 0; i < n_2to1_map; i++, usp1++) {
			_2_to_1[2*i]   = *((ushort *)p)++;
			_2_to_1[2*i+1] = ((*usp1) & PRIMARY) << 8;
			_2_to_1[2*i+1] | = ((*usp1) & SECONDARY) >> 8;
		}
		qsort( _2_to_1, n_2to1_map, 2 * sizeof(ushort), ushort_cmp );
	}
	

	/* _2_to_1 and val_2_to_1 now set */

	if (_colltbl != (ushort *)mycoll) {	/* -r flag specified */
		subs_rec *srp = head;
		for (p = tmp_1ton; *p; ) {
			/* setting up regular expression mapping */
			int j = map_2to1( p, tmpbuf_s, &p );
			if (!(srp->subs_values =
					(ushort *)malloc(j * sizeof(ushort))))
				goto fail_exit;
			memcpy(srp->subs_values, tmpbuf_s, j * sizeof(ushort));
			srp = srp->link;
		}
		/* move colltbl to beginning of mycoll so that
						we can free the tail */
		memcpy(mycoll, _colltbl, SZ_COLLATE);
		realloc(_colltbl = (ushort *)mycoll, SZ_COLLATE);
	}
	else {
		if (!(val_1_to_n = (ushort **)malloc(SZ_COLLATE *
							sizeof(ushort **) /
							sizeof(ushort))))
			goto fail_exit;
		for (p = tmp_1ton; *p; ) {	/* building 1 to many mapping */
			int j;
			uchar c = *p++;
			j = map_2to1( p, tmpbuf_s, &p );
			if (!(val_1_to_n[c] = 
					(ushort *)malloc(j * sizeof(ushort *))))
				goto fail_exit;
			memcpy(val_1_to_n[c], tmpbuf_s, j * sizeof(ushort *));
		}
		realloc(_colltbl, SZ_COLLATE);
	}

	(void)strcpy(saved_locale, _cur_locale[LC_COLLATE]);
	return 0;

fail_exit:
		/* clear all allocated memory */
		/* set collate to default     */
		/* and return to caller	      */
	free_all();
	_colltbl = (ushort *)0;
	saved_locale[0] = 'C';
	saved_locale[1] = '\0';
	if (strcmp(_cur_locale[LC_COLLATE], "C"))  /* If C locale don't save */ 
		(void)strcpy(failed_locale, _cur_locale[LC_COLLATE]);

	return 1;
}

static int
map_2to1( str, result, next )
uchar *str;
ushort *result;
uchar **next;
{
	int i, j = 0;
	ushort temp;
	ushort *res;
	while (*str) {
		if ((_colltbl[*str] & TWOTOONE) && *(str+1) && _2_to_1) {
			temp = *str << 8 | *(str+1);
			/* search for match */
			if (res = (ushort *)bsearch(&temp, _2_to_1, n_2to1_map,
					2 * sizeof(ushort), ushort_cmp)) {
				result[j++] = *(res+1);
				str += 2;
				continue;
			}
		}
		/* ignore don't care characters */
		result[j] = _colltbl[*str] & (PRIMARY | SECONDARY);
		if (result[j] != 1)
				j++;
		str++;
	}
	*next = str + 1;
	result[j++] = 0;
	return j;
}

static void
free_all() {
	while (head) {
		tail = head->link;
		if (head->src_str)
			free(head->src_str);
		if (head->subs_values)
			free(head->subs_values);
		free(head);
		head = tail;
	}
	if (mycoll) {
		free(mycoll);
		_colltbl = (ushort *)0;
		mycoll = (uchar *)0;
	}
	if (_2_to_1) {
		free(_2_to_1);
		_2_to_1 = (ushort *)0;
	}
	if (val_1_to_n) {
		int i;
		for ( i = 0; i < SZ_COLLATE / sizeof(ushort); i++ )
			if (val_1_to_n[i])
				free(val_1_to_n);
		free(val_1_to_n);
		val_1_to_n = (ushort **)0;
	}
}

int
ushort_cmp( e1, e2 )
ushort *e1, *e2;
{
	return (int)*e1 - *e2;
}

#if i386
static void
swapbytes(  dst , size )
char dst[];
{
	char c;
	int i;

	for (i=0;i<size;i+=2 ){
		c = dst[i];
		dst[i] = dst[i+1];
		dst[i+1] = c;
	}

}
#endif
