/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libc-port:stdio/cuserid.c	1.8"
/*	3.0 SID #	1.2	*/
/*LINTLIBRARY*/
#include <stdio.h>
#include <pwd.h>
#include <unistd.h>

extern char *strcpy(), *getlogin();
extern struct passwd *getpwuid();
static char res[L_cuserid];

char *
cuserid(s)
char	*s;
{
	register struct passwd *pw;
	register char *p;
	register int sc_cuserid_version;

	/*
	 * Determine the cuserid() implementation to emulate; either
	 * traditional usage, sc_cuserid_version == 0 (i.e., return the name 
	 * associated with the REAL uid of the caller), or the POSIX.1
	 * required interface, sc_cuserid_version == 1 (i.e., return
	 * the name associated with the EFFECTIVE uid of the caller).
	 */
	sc_cuserid_version = sysconf(_SC_CUSERID_VERSION);
	if (sc_cuserid_version == 0) {
		p = getlogin();
		if (p != NULL)
			if (NULL != s)
				return (strcpy(s, p));
			else
				return (strcpy(res, p));
		pw = getpwuid(getuid());
	} else {
		pw = getpwuid(geteuid());
	}
	endpwent();
	if (pw != NULL)
		if (NULL != s)
			return (strcpy(s, pw->pw_name));
		else
			return (strcpy(res, pw->pw_name));
	if (NULL != s) {
		*s = '\0';
		return s;
	}
	return (NULL);
}
