/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred."
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: halfdelay.c 1.3 89/10/10 $@(#)curses:screen/halfdelay.c	1.2.1.1"
/*
 * Routines to deal with setting and resetting modes in the tty driver.
 * See also setupterm.c in the termlib part.
 */
#include "curses.ext"

halfdelay(tenths)
int tenths;
{
	if (tenths > 255)
		tenths = 255;
	else if (tenths <= 0)
		tenths = 1;
	_noraw();
#ifdef SYSV
	PROGTTY.c_iflag &= ~ICRNL;
	PROGTTY.c_lflag &= ~ICANON;
	PROGTTY.c_cc[VMIN] = 0;
	PROGTTY.c_cc[VTIME] = tenths;
# ifdef DEBUG
	if(outf) fprintf(outf, "halfdelay(%d), file %x, SP %x, flags %x\n", tenths, SP->term_file, SP, PROGTTY.c_lflag);
# endif
#else
# ifdef FIONREAD
	cur_term->timeout = tenths;
# else
	/* not possible to get right. use cbreak() until we can. */
	_cbreak();
# endif /* !FIONREAD */
# ifdef DEBUG
	if(outf) fprintf(outf, "halfdelay(%d)\n", tenths);
# endif
#endif
	SP->fl_rawmode = TRUE;
	reset_prog_mode();
}
