
/* 
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident "$Header: catclose.c 1.3 90/05/21 $@(#)catclose.c	1.3 89/12/01"

#include <stdio.h>
#include <sys/mman.h>
#include <nl_types.h>
#include "nl_type2.h"

static	void	msgdetach();

catclose(catd)
  nl_catd catd;
{
  switch(catd->catd_type) {
	case MALLOC:
		free(catd->catd_set);
		catd->catd_type = -1; 
		break;
	case SHARED_LIBRARY:
		msgdetach(catd->catd_msgs);
		catd->catd_type = -1;
		break;
	default:
		return -1;
	}
	return 0;
}

/*
 * msgdetach - remove association with a message database
 *
 * A command message database which was previously acquired via
 * msgattach() is tossed.  Rather than unmap the pages, they are
 * mapped zerofill, so that malloc() can reallocate them.
 */

static void
msgdetach(addr)
int addr;
{
	if (_mmap(addr, ((int*)addr)[-1], PROT_RDWR, MAP_ZEROFILL, 0, 0) < 0)
		return;

	_align_free(((int*)addr)[-2]);
	return;
}
