/* 
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*	Copyright (c) 1987 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident "$Header: nl_strcmp.c 1.1 90/01/09 $@(#)nl_strcmp.c	1.4 89/12/01"

/*
 * nl_strcmp -- X/OPEN international version of strcmp
 *
 * SYNOPSIS:
 *	int
 *	nl_strcmp(s1, s2)
 *	char *s1;
 *	char *s2;
 *
 * DESCRIPTION:
 *	nl_strcmp is specified in the X/OPEN guide.
 *
 * RETURNS:
 *	result of collation
 */

#include	<malloc.h>
#include	<stdio.h>

static void
lookat(s)
char *s;
{
if (!s)
	printf("<<NULL>>");
else
while (*s)
	printf("%x ",*s++);
printf("\n");
}

int
nl_strcmp(s1, s2)
char *s1;
char *s2;
{
	char buf1[512], buf2[512]; /* Not malloc'ed for speed purposes */

	if (strxfrm(buf1, s1, 512) >= 512) 
		return 0 ;
	if (strxfrm(buf2, s2, 512) >= 512) 
		return 0 ;
	lookat(buf1);
lookat(buf2);
	return(strcmp(buf1, buf2));
}

/*
 * nl_strncmp -- international version of strncmp
 *
 * SYNOPSIS:
 *	int
 *	nl_strncmp(s1, s2, n)
 *	char *s1;
 *	char *s2;
 *	int n;
 *
 * DESCRIPTION:
 *	nl_strncmp is specified in the X/OPEN guide.
 *
 * RETURNS:
 *	result of collation
 */
int
nl_strncmp(s1, s2, n)
char *s1;
char *s2;
int n;
{
	char *buf1, *buf2;
	/* Is this bytes or graphical chars ? 
	   we choose bytes */
		
	if ((buf1 = malloc(2*strlen(s1)+2)) == NULL)
		return 0 ;
	if ((buf2 = malloc(2*strlen(s2)+2)) == NULL)
		return 0 ;
	if (strxfrm(buf1, s1, n) >= n)
		return 0 ;
	if (strxfrm(buf2, s2, n) >= n)
		return 0 ;
	return(strncmp(buf1, buf2, n));
}
