# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)libplot:t450/t450.mk	1.7"

#	Makefile for t450 library

ROOT =
LROOT =

DIR = $(ROOT)/$(LROOT)/usr/lib
USRLIB = $(DIR)
USRLIBP = $(DIR)/libp

INC = $(ROOT)/usr/include

LDFLAGS =

CFLAGS = -O -I$(INC)

STRIP = strip

AR = ar

SIZE = size

LIST = lp

#top#
# Generated by makefile 1.47

MAKEFILE = t450.mk


LIBRARY = lib450.a

OBJECTS =  arc.o box.o circle.o close.o dot.o erase.o label.o line.o \
	linmod.o move.o open.o point.o space.o subr.o

SOURCES =  arc.c box.c circle.c close.c dot.c erase.c label.c line.c \
	linmod.c move.c open.c point.c space.c subr.c

ALL:		profiled $(LIBRARY)

.c.o:
	$(CC) -p -DMCOUNT $(CFLAGS) -c $< && \
	mv $*.o profiled/$*.o && \
	$(CC) -UMCOUNT $(CFLAGS) -c $<

profiled:
	mkdir profiled

$(LIBRARY): $&	$(OBJECTS)
	-rm -f $(LIBRARY) profiled/$(LIBRARY)
	$(AR) rc $(LIBRARY) $(OBJECTS)
	cd profiled; $(AR) rc $(LIBRARY) $(OBJECTS)

GLOBALINCS = $(INC)/signal.h $(INC)/stdio.h \
	$(INC)/sys/signal.h $(INC)/sys/termio.h \
	$(INC)/termio.h 

LOCALINCS = con.h 

clean:
	-rm -f $(OBJECTS); cd profiled; rm -f $(OBJECTS)

clobber:
	-rm -f $(OBJECTS) $(LIBRARY); rm -rf profiled

newmakefile:
	makefile -m -f $(MAKEFILE) -L $(LIBRARY)  -s INC $(INC)
#bottom#

all : ALL

install: ALL
	cpset $(LIBRARY) $(USRLIB)/$(LIBRARY) 0444
	cpset profiled/$(LIBRARY) $(USRLIBP)/$(LIBRARY) 0444

size: ALL
	$(SIZE) $(LIBRARY)

strip: ALL

#	These targets are useful but optional

partslist:
	@echo $(MAKEFILE) $(SOURCES) $(LOCALINCS)  |  tr ' ' '\012'  |  sort

productdir:
	@echo $(USRLIB) | tr ' ' '\012' | sort

product:
	@echo $(LIBRARY)  |  tr ' ' '\012'  | \
	sed 's;^;$(USRLIB)/;'

srcaudit:
	@fileaudit $(MAKEFILE) $(LOCALINCS) $(SOURCES) -o $(OBJECTS) $(LIBRARY)

listing:
	pr -n $(MAKEFILE) $(SOURCES) | $(LIST)

listmk:
	pr -n $(MAKEFILE) | $(LIST)
