# $Copyright:	$
#Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
#Sequent Computer Systems, Inc.   All rights reserved.
# 
#This software is furnished under a license and may be used
#only in accordance with the terms of that license and with the
#inclusion of the above copyright notice.   This software may not
#be provided or otherwise made available to, or used by, any
#other person.  No title to or ownership of the software is
#hereby transferred.

ROOT =
USRLIB = $(ROOT)/usr/lib
USRLIBP = $(ROOT)/usr/lib/libp
INC = $(ROOT)/usr/include
CFLAGS = -O

SIZE = size

MAKEFILE = libseq.mk

LIBRARY = libseq.a

# .o files which make up the library

OBJECTS =  sys/cust0.o		sys/cust1.o		sys/cust2.o \
	   sys/cust3.o		sys/cust4.o		sys/cust5.o \
	   sys/cust6.o		sys/cust7.o		sys/cust8.o \
	   sys/cust9.o		sys/getpagesize.o	sys/getdtablesiz.o \
	   sys/setdtablesiz.o	sys/mmap.o		sys/mptrace.o \
	   sys/sigstack.o	sys/sigcontext.o	sys/munmap.o \
	   sys/proc_ctl.o	sys/vm_ctl.o		sys/tmp_affinity.o \
	   sys/tmp_ctl.o	sys/bdflush.o		sys/get_proc_st.o \
	   sys/symlink.o	sys/readlink.o		sys/truncate.o \
	   sys/ftruncate.o	sys/readv.o		sys/writev.o \
	   sys/quotactl.o	sys/setgroups.o		sys/fvhangup.o \
	   sys/adjtime.o \
	   gen/dis.o		gen/geomtab.o		gen/getpseudotty.o \
	   gen/getscsiinfo.o	gen/getzdinfo.o		gen/initgroups.o \
	   gen/mntent.o		gen/nblocks.o		gen/offline_all.o \
	   gen/read_constab.o	gen/usclk.o \
	   gen/valloc.o		sys/getdtablemax.o	sys/DirectRead.o \
	   sys/DirectWrite.o	sys/shfork.o		sys/shvfork.o \
	   sys/getitimer.o	sys/setitimer.o		sys/tmp_affinitypid.o \
	   sys/DIO.o		gen/DIO_subr.o

# source files which make the .0 files

SOURCES =  sys/cust0.s		sys/cust1.s		sys/cust2.s \
	   sys/cust3.s		sys/cust4.s		sys/cust5.s \
	   sys/cust6.s		sys/cust7.s		sys/cust8.s \
	   sys/cust9.s		sys/getpagesize.s	sys/getdtablesiz.s \
	   sys/setdtablesiz.s	sys/mmap.s		sys/mptrace.s \
	   sys/sigstack.s	sys/sigcontext.s	sys/munmap.s \
	   sys/proc_ctl.s	sys/vm_ctl.s		sys/tmp_affinity.s \
	   sys/tmp_ctl.s	sys/bdflush.s		sys/quotactl.s \
	   sys/setgroups.s	sys/fvhangup.s		sys/adjtime.s \
	   gen/dis.c \
	   gen/geomtab.c	gen/getpseudotty.c	gen/mntent.c \
	   gen/getscsiinfo.c	gen/getzdinfo.c		gen/initgroups.c \
	   gen/nblocks.c	gen/offline_all.c	gen/read_constab.c \
	   gen/usclk.c		gen/valloc.c \
	   sys/getdtablemax.c	sys/DirectRead.s	sys/DirectWrite.s \
	   sys/shfork.s		sys/shvfork.s		sys/getitimer.s \
	   sys/setitimer.s	sys/tmp_affinitypid.s \
	   sys/DIO.s		gen/DIO_subr.c


# Adding the I386 for the sake of the dis386, shouldn't effect anything else
.c.o:
	$(CC) -p -DMCOUNT $(CFLAGS) -DI386 -c $*.c && \
	mv $(*F).o profiled/$(*F).o && \
	$(CC)    -UMCOUNT $(CFLAGS) -DI386 -c $*.c && \
	mv $(*F).o $*.o

.s.o:
	$(CPP) -P -DMCOUNT $(INCLUDE) $*.s | $(AS) -o $*.o && \
	mv $*.o profiled/$(*F).o && \
	$(CPP) -P -UMCOUNT $(INCLUDE) $*.s | $(AS) -o $*.o

ALL:	profiled libseq.a libseq_p.a

libseq.a \
libseq_p.a: $& $(OBJECTS)
	cd profiled && $(AR) cru ../libseq_p.a *.o
	$(AR) cru libseq.a $(OBJECTS)

profiled:; mkdir profiled

getpagesize:	$(INC)/sys.s

clean:
	rm -rf $(OBJECTS) profiled
	rm -f *.s

clobber:
	rm -rf $(OBJECTS) libseq.a libseq_p.a profiled

install: ALL
	cpset libseq.a $(USRLIB) 0444
	cpset libseq_p.a $(USRLIBP) 0444
	mv $(USRLIBP)/libseq_p.a $(USRLIBP)/libseq.a

strip:

size:
	$(SIZE) $(LIBRARY)
