# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.
#
#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: libw.mk 1.4 90/06/27 $@(#)libw:libw.mk	1.0"
#
# makefile for libw
#
#
# The variable PROF is null by default, causing both the standard C library
# and a profiled library to be maintained.  If profiled object is not 
# desired, the reassignment PROF=@# should appear in the make command line.
#
# The variable IGN may be set to -i by the assignment IGN=-i in order to
# allow a make to complete even if there are compile errors in individual
# modules.
#
# See also the comments in the lower-level machine-dependent makefiles.
#

VARIANT=
SGS=
CFLAGS=-O
PCFLAGS=
PFX=
CC=$(PFX)cc
AR=ar
LORDER=$(PFX)lorder
ROOT=
LIB=$(ROOT)/lib
USRLIB=$(ROOT)/usr/lib
USRLIBP=$(ROOT)/usr/lib/libp
DONE=
PROF=
NONPROF=
DEFLIST=
MAKE=$(PFX)make
LINT1=$(TOOLS)/lib/lint/lint1
TMPDIR=/usr/tmp

# List of updated libc objects
NEWLIBC=

all:
	$(MAKE) -e -f libw.mk DEFLIST=  nonshared llib-lw.ln

nonshared:
	#
	# compile portable library modules
	cd port; $(MAKE) -e CC="$(CC)"
	#
	# place portable modules in "object" directory
	-rm -rf object
	mkdir object
	cp port/*/*.o object
	$(PROF)cp port/*/*.p object
	#
	# delete temporary libraries
	-rm -f lib.libw
	$(PROF)-rm -f libp.libw
	#
	# build archive out of the remaining modules.
	cd object; $(MAKE) -e -f ../libw.mk archive
	-rm -rf object
	#
	$(DONE)

archive:
	#
	# Note that "archive" is invoked with libw/object as current directory.
	#
	# figure out the correct ordering for all the archive modules
	$(LORDER) *.o | tsort >objlist
	#
	# build the archive with the modules in correct order.
	$(AR) q ../lib.libw `cat objlist`
	$(PROF)#
	$(PROF)# build the profiled library archive, first renaming the
	$(PROF)#	.p (profiled object) modules to .o
	$(PROF)for i in *.p ; do mv $$i `basename $$i .p`.o ; done
	if [ "$(PROF)" != "@#" ]; \
	then \
	$(PROF)$(AR) q ../libp.libw `cat objlist`; \
	fi

move:
	#
	# move the library or libraries into the correct directory
	cp lib.libw libw.a
	install -f $(USRLIB) -m 0444 -u bin -g bin  libw.a
	install -f $(USRLIB) -m 0444 -u bin -g bin  llib-lw.ln
	rm libw.a
	$(PROF)if [ ! -d $(USRLIBP) ]; then \
	$(PROF)	mkdir $(USRLIBP); \
	$(PROF)fi
	$(PROF)cp libp.libw libw.a
	$(PROF)install -f $(USRLIBP) -m 0444 -u bin -g bin  libw.a
	$(PROF)rm libw.a

install: all move

clean:
	#
	# remove intermediate files except object modules and temp library
	-rm -rf lib*.contents obj*
	cd port ;  $(MAKE) clean

clobber:
	#
	# remove intermediate files
	-rm -rf *.o lib*.libw lib*.contents obj*
	cd port ;  $(MAKE) clobber
	#done
	#

llib-lw.ln:  llib-lw $(LINT1)
	$(CC) $(INCLUDE) -E -C -Dlint llib-lw | $(LINT1) -vx -H$(TMPDIR)/hlint >llib-lw.ln 
