/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*	Copyright (c) 1986 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/



#ident	"$Header: wssize.c 1.3 90/04/21 $@(#)libw-port:wstring/wssize.c	1.0"

/*
 * Wssize returns number of bytes in EUC for wchar_t string.
 */

#include "shlib.h"
#include <widec.h>
#include <euc.h>
#include "libw_pcode.h"

extern int  _cswidth[];
extern void _xgetwidth();
extern eucwidth_t _eucwidth;
#define pcw _eucwidth._pcw	/* use for checking wchar_t is 2 or 4 bytes	*/

/* _wccset( wc, mask )	where mask is (wc & EUCMASK) or (wc & F_EUCMASK)
			depending on max euc width.
			it returns the code set number (0-3) of wc, with the
			exception of codeset 2 control characters in which
			case it returns 0.
*/
#define _wccset( wc, mask ) \
		( \
		((mask) == P00 || (mask) == F_P00 ) ? 0 : \
		((mask) == P11 || (mask) == F_P11 ) ? 1 : \
		((mask) == P10 || (mask) == F_P10 ) ? 3 : \
		control1(wc) ? 0 : 2 \
		)

/* __wcsize( wc, bpb, cs )	where bpb is the bits per byte (7 or 8)
				depending on whether the current locale
				is 4 or 2 bytes.  cs is the codeset
				number of wc.  __wcsize assumes wc is not
				codeset 0 and wc is not codeset 2 control
				character.  returns no of bytes in the
				euc equivalent of wc or 0 if wc is invalid.
*/

#define	__wcsize( wc, bpb, cs ) \
	( \
	_cswidth[cs] == 0 ? 0 : \
	controlc(wc) ? 0 : \
	_cswidth[cs] >= 2 && controlc((wc) >> (bpb)) ? 0 : \
	_cswidth[cs] >= 3 && controlc((wc) >> (2 * (bpb))) ? 0 : \
	_cswidth[cs] >= 4 && controlc((wc) >> (3 * (bpb))) ? 0 : \
	((cs) > 1) ? _cswidth[cs]+1 : _cswidth[cs] \
	)

/*	_wssize(s)	modified version.  added error checking.
			returns number of bytes in the euc equivalent of wide 
			string s.  If s contains illegal characters, _wssize(s)
			returns the number of bytes in the euc equivalent of
			the portion of s before the error.
*/
int
_wssize(s)
register wchar_t *s;
{
	register size = 0;
	register n;
	int bpb, mask;

	if (! *_cswidth)
		_xgetwidth();
	if ( pcw > sizeof(unsigned short) ) {
		bpb = 7;
		mask = F_EUCMASK;
	}
	else {
		bpb = 8;
		mask = EUCMASK;
	}

	/* loop until the wchar would convert to a NULL in euc */

	while (*s & (mask | 0x7f)) {
		if (n = _wccset( *s, *s & mask )) {
			if ((n = __wcsize( *s, bpb, n )) == 0 )
				break;
			size += n;
		}
		else
			size++;
		s++;
	}
	return size;
}

/* _wcsizefunc(wc)	this is a modified version of the wcsize macro.
			validation of wc is added.  if wc is invalid,
			0 is returned otherwise no of byte in the euc
			euqivalent of wc.
*/
_wcsizefunc(wc)
register wchar_t wc;
{
	register size = 0;
	register n;
	int bpb, mask;
int m, o;

	if (! *_cswidth)
		_xgetwidth();
	if ( pcw > sizeof(unsigned short) ) {
		bpb = 7;
		mask = F_EUCMASK;
	}
	else {
		bpb = 8;
		mask = EUCMASK;
	}
/*
	return (n = _wccset( wc, wc & mask )) ? 
		__wcsize( wc, bpb, n ) : 1;
*/
	if (n = _wccset( wc, wc & mask ))
		return(__wcsize( wc, bpb, n ));
	else return 1;
}

