# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.



#ident	"$Header: nsl.mk 1.7 89/10/10 $@(#)libnsl:nsl/nsl.mk	1.10.3.1"
# 
# Network services library
#

ROOT=
USRLIB=$(ROOT)/usr/lib
USRLIBP=$(ROOT)/usr/lib/libp
INCRT=$(ROOT)/usr/include
CFLAGS= -I$(INCRT) -O 

LIBOBJS= t_accept.o t_bind.o t_connect.o t_error.o t_close.o\
	 t_getinfo.o t_getstate.o t_listen.o t_look.o\
	 t_rcv.o t_rcvconnect.o t_rcvdis.o t_snd.o t_snddis.o\
	 t_unbind.o t_optmgmt.o\
	 t_rcvudata.o t_rcvuderr.o t_sndudata.o t_sndrel.o t_rcvrel.o\
	 t_alloc.o t_free.o t_open.o t_sync.o\
	 _dummy.o _errlst.o _data.o _data2.o _conn_util.o _utility.o

INCLUDES=  	$(INCRT)/sys/param.h\
		$(INCRT)/sys/types.h\
		$(INCRT)/sys/errno.h\
		$(INCRT)/sys/stream.h\
		$(INCRT)/sys/stropts.h\
		$(INCRT)/sys/tihdr.h\
		$(INCRT)/sys/timod.h\
		$(INCRT)/sys/tiuser.h\
		$(INCRT)/sys/signal.h\
		./_import.h


all:      profiled libnsl.a

.c.o:
	$(CC) -p -DMCOUNT $(CFLAGS) -c $< && \
	mv $*.o profiled/$*.o && \
	$(CC) -UMCOUNT $(CFLAGS) -c $<

profiled:
	mkdir profiled

libnsl.a: $& $(LIBOBJS)
	-rm -f libnsl.a profiled/libnsl.a;
	$(AR) r libnsl.a $(LIBOBJS)
	cd profiled; $(AR) r libnsl.a $(LIBOBJS)

$(LIBOBJS):	$(INCLUDES)

install:  all
	install -f $(USRLIB) libnsl.a;
	$(CH)chown bin $(USRLIB)/libnsl.a
	$(CH)chgrp bin $(USRLIB)/libnsl.a
	$(CH)chmod 444 $(USRLIB)/libnsl.a
	cd profiled; install -f $(USRLIBP) libnsl.a;
	$(CH)chown bin $(USRLIBP)/libnsl.a
	$(CH)chgrp bin $(USRLIBP)/libnsl.a
	$(CH)chmod 444 $(USRLIBP)/libnsl.a

clean:
	-rm -f *.o; cd profiled; rm -f *.o

clobber:	clean
	-rm -f libnsl.a; rm -rf profiled
