# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"$Header: terminfo.mk 1.8 90/05/25 $@(#)terminfo:terminfo.mk	1.5"
#
#	terminfo makefile
#

ROOT=
TERMDIR=$(ROOT)/usr/lib/terminfo
TABDIR=$(ROOT)/usr/lib/tabset
PARTS=	header *.ti trailer
TIC=/usr/bin/tic
COMPILE=$(TIC) -v

all:	ckdir terminfo.src
	umask 022 # (directory 755 and file 644); \
	TERMINFO=$(TERMDIR) 2>&1 $(COMPILE) terminfo.src > errs
	@touch install
	@echo
	@sh ./ckout
	@echo
	@echo
	@echo
	@echo Fixing owner, group of '$(TERMDIR)/*/*'
	@cd $(TERMDIR); \
		find . -type f -print | xargs chown bin; \
		find . -type f -print | xargs chgrp bin;
	@echo
	@if [ -d tabset ] ; then \
		cd tabset; \
		for i in *; do \
			cpset $$i $(TABDIR) 0444; \
		done \
	fi

install: all

terminfo.src:	$(PARTS)
	@cat $(PARTS) > terminfo.src

clean:
	rm -f terminfo.src install errs

clobber: clean

ckdir:
	@echo "terminfo database will be built in $(TERMDIR)."
	@echo "checking for the existence of $(TERMDIR):"
	@echo
	@if [ -d $(TERMDIR) ]; \
	then \
		echo "\t$(TERMDIR) exists"; \
	else  \
		echo "\tbuilding $(TERMDIR)"; \
		mkdir $(TERMDIR); \
		$(CH)chown bin $(TERMDIR); \
		$(CH)chgrp bin $(TERMDIR); \
		$(CH)chmod 775 $(TERMDIR); \
	fi
	@echo
	@echo
	@echo
	@echo "terminfo database will reference file in $(TABDIR)."
	@echo "checking for the existence of $(TABDIR):"
	@echo
	@if [ -d $(TABDIR) ]; \
	then \
		echo "\t$(TABDIR) exists"; \
	else  \
		echo "\tbuilding $(TABDIR)"; \
		mkdir $(TABDIR); \
		$(CH)chown bin $(TABDIR); \
		$(CH)chgrp bin $(TABDIR); \
		$(CH)chmod 775 $(TABDIR); \
	fi
	@echo
	@echo It will take quite some time to generate $(TERMDIR)/*/*.
	@echo
