/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: conf_devsw.c 1.8 90/04/20 $"

/* $Log:	conf_devsw.c,v $
 */

#include <sys/types.h>
#include <sys/param.h>
#include <sys/ufsinode.h>
#include <sys/ufsfilsys.h>
#include "saio.h"

int	nullsys(), nullioctl(), nulllseek();
int	sdstrategy(), sdopen(), sdioctl();
int	tsstrategy(), tsopen(), tsclose(), tsioctl();
int	xtstrategy(), xtopen(), xtclose();
int	zdstrategy(), zdopen(), zdioctl();
int	wdstrategy(), wdopen(), wdioctl();
int	tmstrategy(), tmopen(), tmclose(), tmioctl();
int	fdstrategy(), fdopen(), fdclose(), fdioctl();
int	hdstrategy(), hdopen(), hdioctl();
int	atstrategy(), atopen(), atclose();
int	adstrategy(), adopen(), adioctl();

#if defined(BOOTXX)
struct devsw devsw[] = {
	{ "sd",	sdstrategy, sdopen, 0, 0, 0, D_DISK },
	{ "ts",	tsstrategy, tsopen, 0, 0, 0, D_TAPE },
	{ "xt",	xtstrategy, xtopen, 0, 0, 0, D_TAPE },
	{ "zd",	zdstrategy, zdopen, 0, 0, 0, D_DISK },
	{ "fd",	fdstrategy, fdopen, 0, 0, 0, D_DISK },
	{ "hd",	hdstrategy, hdopen, 0, 0, 0, D_DISK },
	{ "at",	atstrategy, atopen, 0, 0, 0, D_TAPE },
	{ "ad",	adstrategy, adopen, 0, 0, 0, D_DISK },
};
#else	/* BOOTXX */

struct devsw devsw[] = {
#if !defined(SSMFW)
	{ "sd",	sdstrategy, sdopen, nullsys, sdioctl, nulllseek, D_DISK },
	{ "ts",	tsstrategy, tsopen, tsclose, tsioctl, nulllseek, D_TAPE },
	{ "xt",	xtstrategy, xtopen, xtclose, nullsys, nulllseek, D_TAPE },
	{ "zd",	zdstrategy, zdopen, nullsys, zdioctl, nulllseek, D_DISK },
#endif
#if !defined(SCED_DIAGS)
	{ "wd", wdstrategy, wdopen, nullsys, wdioctl, nulllseek, D_DISK },
	{ "tm", tmstrategy, tmopen, tmclose, tmioctl, nulllseek, D_TAPE },
#endif
#if defined(AT386)
	{ "fd",	fdstrategy, fdopen, fdclose, fdioctl, nulllseek, D_DISK },
	{ "hd",	hdstrategy, hdopen, nullsys, hdioctl, nulllseek, D_DISK },
	{ "at",	atstrategy, atopen, atclose, nullsys, nulllseek, D_TAPE },
	{ "ad",	adstrategy, adopen, nullsys, adioctl, nulllseek, D_DISK },
#endif
};

#endif	/* BOOTXX */
int n_devsw = sizeof(devsw)/sizeof(devsw[0]);
