/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/* $Header: conf_scsi.c 1.10 90/04/12 $ */

/* $Log:	conf_scsi.c,v $
 */

#include <sys/types.h>
#include <sys/param.h>
#include <sys/ufsinode.h>
#include <sys/ufsfilsys.h>
#include <sys/vtoc.h>
#include "saio.h"
#include "scsi.h"
#include "scsidisk.h"
#include "ccs.h"

/*
 * drive descriptions for supported SCSI disks.  All device types share the
 * same partition table.  Note: 8K bootstrap (BOOTXX) knows about only
 * one kind of SCSI disk.
 */


struct drive_type drive_table[] = {

	{ "fujitsu",
		"",
		"",
		/* last 3 cyls reserved: 2 for diags, 1 for bad blocks */
		{ 17, 11, 187, 751+3 },
		{ 49181, 35156, V_RAW, 8192, 1024 },
		0,
	},

#ifndef BOOTXX
	{ "hp97544",
		"HP      ",
		"97544S          ",
		{ 56, 8, 448, 1445+2 },
		{ 53760, 153664, V_RAW, 8192, 1024 },
		1, 4, SDF_FORMPG_ND, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "hp97548",
		"HP      ",
		"97548S          ",
		{ 56, 16, 896, 1445+2 },
		{ 570752, 205184, V_RAW, 8192, 1024 },
		1, 4, SDF_FORMPG_ND, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "wren3",
		"CDC     ",
		"94161-9         ",
		{ 35, 9, 315, 965+2 },
		{ 49140, 75915, V_RAW, 8192, 1024 },
		1, 4, SDF_FORMPG_ND, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "wren4",
		"CDC     ",
		"94171-9         ",
		{ 54, 9, 483, 1324+2 },
		{ 53613, 159873, V_RAW, 8192, 1024 },
		1, 4, SDF_FORMPG_ND, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "xt8380s",
		"MAXTOR  ",
		"XT-8380S        ",
		{ 53, 8, 422, 1326 },
		{ 53594, 171754, V_RAW, 8192, 1024 },
		1, 4, SDF_FORMPG_ND, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "xt8380sm",
		"MBF-DISK",
		"XT-8380S        ",
		{ 53, 8, 422, 1326 },
		{ 53594, 171754, V_RAW, 8192, 1024 },
		1, 4, SDF_FORMPG_ND, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

    	{ "m2249sa",
    		"FUJITSU ",
    		"M2249SA         ",
    		{ 35, 15, 525, 1239+2 },
  		{ 54600, 155400, V_RAW, 8192, 1024 },
    		1, 4, SDF_FORMPG_ND, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
    	},

#endif /* BOOTXX */
	{	(char*)0,		/* drive_table[] terminator */
	}
};

#define	MAXBADLIST	256

#ifdef STANDALONE
int	maxbadlist = MAXBADLIST;
int	list[MAXBADLIST];
#endif
