/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: consmemioctl.h 1.6 89/08/07 $"

#ifndef	_SYS_CONSMEMIOCTL_H_


/*
 * consmemioctl.h
 *	Console Memory driver ioctls
 */

/* $Log:	consmemioctl.h,v $
 */

#define STYPE			('s'<<8)
#define	SMIOSTATS		(STYPE|1)	/* smem stats */
#define	SMIOGETREBOOT0		(STYPE|2)	/* get reboot str */
#define SMIOSETREBOOT0		(STYPE|3)	/* set reboot str */
#define	SMIOGETREBOOT1		(STYPE|4)	/* get reboot str */
#define SMIOSETREBOOT1		(STYPE|5)	/* set reboot str */
#define	SMIOGETLOG		(STYPE|6)	/* get mem log */
#define SMIOSETLOG		(STYPE|7)	/* set mem log (SCED only) */


/* 
 * The following structures are used with the consmem
 * ioctls.
 */

/*
 * Structure used to get and set (SCED only) data reguarding the
 * system log.
 */
struct cons_mem {
	char *mm_buffer;	/* address of log buffer */
	char *mm_nextchar;	/* next free char in buffer */
	short mm_size;		/* buffer size */
	short mm_nchar;		/* number valid chars in buf */
};


/*
 * Structure in which device statistics are kept.
 */
struct consmem_stats {
	int	consmem_cmd;		/* number of commands */
	int	consmem_ioctls;		/* number of ioctls */
	int	consmem_xfers;		/* number of transfers */
};

#define	_SYS_CONSMEMIOCTL_H_
#endif	/* _SYS_CONSMEMIOCTL_H_ */
