/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident "$Header: mbad_device.h 1.5 89/09/01 $"

#ifndef	_SYS_MBAD_DEVICE_H_

/*
 * mbad_device.c
 *	Configuration include file for Multi-Bus Adapter/Interface
 */

/* $Log:	mbad_device.h,v $
 */

struct mbad_device {
    int         busnum;                    /* index into system bus table. */
    int         unit;                     /* Unit #, index into config table */
    int 	segsize;		  /* Size of a DMA segment */
    int		segalign;		  /* driver promises this alignment */
    int		nsegs;			  /* this device need this many segs */
    struct      driver_module   *driver;  /* pointer into "drivers[]" */
    struct      dev_on_bus      *on_bus;  /* points into drivers[].on_busses */
    struct      bus             *bus;
    struct      device_config   *config;
    struct      gen_device      *next;    /* Chain of devices on same bus */
    char       *map_origin;               /* sequent addr of map regs. */
    char       *bus_map_addr;             /* start of dma map, bus side. */
    long        map_extent;               /* # of bytes covered by map. */
    int         n_maps;                   /* Number of maps */
    int         nspaces;                  /* length of devreg, below */
    char       *devreg[1];                 /* could point to CSR or CB */
    /* here starts the mbad specific per device fields */
    struct ctlr_desc *cd;		/* System TOC descriptor address */
};


/* Define old mbad device structure for use by mbad devices */

struct mbad_old_mbad_device {
    int         busnum;                    /* index into system bus table. */
    int         unit;                     /* Unit #, index into config table */
    int		segsize;		  /* Size of a DMA segment */
    int		segalign;		  /* driver promises this alignment */
    int		nsegs;			  /* this device need this many segs */
    struct      driver_module   *driver;  /* pointer into "drivers[]" */
    struct      dev_on_bus      *on_bus;  /* points into drivers[].on_busses */
    struct      bus             *bus;
    struct      device_config   *config;
    struct      gen_device      *next;    /* Chain of devices on same bus */
    char       *map_origin;               /* sequent addr of map regs. */
    char       *bus_map_addr;             /* start of dma map, bus side. */
    long        map_extent;               /* # of bytes covered by map. */
    int         n_maps;                   /* Number of maps */
    int         nspaces;                  /* length of devreg, below */
    /* Devreg is really variable length, but the compiler wants a size... */
    long       *devreg;                 /* one CSR for old mbad drivers */
    /*
     * old_ mbad_device specific portion
     */
    struct mbad_dev *mbad_dev;		  /* The sced device structure. */
};

extern struct dev_on_bus mbad_on_busses[];
extern mbad_multibus_probe_setup();
extern void mbad_multibus_alloc_maps();
extern int mbad_multibus_intr_setup();
extern void mbad_multibus_ack_int();
extern int mbad_multibus_dma_setup();
extern char *mbad_multibus_dma_remap();
extern void mbad_multibus_dma_done();

/* stubs for bus controller routines to work with autoconfig */
#define mbad_multibus_dma_flush ((void (*)())0)

#define	_SYS_MBAD_DEVICE_H_
#endif	/* _SYS_MBAD_DEVICE_H_ */
