/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: printer.h 1.5 90/05/01 $"

#ifndef	_SYS_PRINTER_H_

/*
 * printer.h
 *	Structure and defines used to interface between
 *	streams printer drivers and printer processing
 *	modules (lpmod...)
 */

/* $Log:	printer.h,v $
*/

/*
 * M_PCPROTO message structure for requesting configuration
 * data.
 *
 * (Note that lpmod expects this structure to be filled in on
 * return from putnext of the M_PCPROTO message.)
 */
struct pr_config {
	int p_type;
	int p_ops;
	int p_width;
	int p_height;
};

/*
 * p_type values
 */
#define REQUEST_CFG		1	/* request config data */
#define REQUEST_CFG_RESPONSE	2	/* request config response */ 

/*
 * Values for lpm_ops fields (canonical processing mode) 
 */
#define PRSPECIAL	0x00		/* standard mapping */
#define PRCAPS		0x01		/* caps only */
#define PRRAW		0x02		/* no mapping */

#define PIOC		('p' << 8)
#define PIOCSETCANON	(PIOC|1)

#define	_SYS_PRINTER_H_
#endif	/* _SYS_PRINTER_H_ */
