/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: sysi86.h 1.7 89/10/10 $"

#ifndef	_SYS_SYSI86_H_

/* $Log:	sysi86.h,v $
*/


/*
 * Commands for sysi86 system call (1-50)
 */

#define	SI86SWPI	1	/* General swap interface.		  */
#define	SI86CONF	4	/* acquire boot-built configuration table */
#define	SI86BOOT	5	/* acquire timestamp and name of program  */
				/* booted				  */
#define	SI86SWAP	12	/* Declare swap space			  */
#define SI86FPHW	40	/* what (if any?) flting-pnt hardware */
/*
 * Sequent specific sysi86 system calls (51-?)
 */
#define SI86KWPT 	42	/* set kernel watchpoint */
#define STIME 		54	/* set internal time */
#define SETNAME		56	/* rename the system */
#define RTODC		60	/* read time of day clock */
#define SANUPD		63	/* sanity update of kernel buffers */
#define SI86MEM		65	/* return the memory size of system */
#define	SI86DELMEM	69	/* Delete available memory for testing.	*/
#define	SI86ADDMEM	70	/* Add back deleted memory.		*/

/*
 *   71 through 74 reserved for VPIX
 */

#define	SI86V86		71	/* V86 system calls */
#define SI86SLTIME	72	/* Set local time correction */
#define	SI86DSCR	75	/* Set a segment or gate descriptor */
#define RDUBLK		76	/* Swap in U Block */
#define	SI86FPOVR	78	/* Turn fl. pt. overflow catching on/off */

/* Floating point enable/disable flag; also defined in *
 * /usr/include/ieeefp.h .                             */

#define	FP_DISABLE	0	/* exception will be ignored	*/
#define	FP_ENABLE	1	/* exception will cause SIGFPE	*/

#define	_SYS_SYSI86_H_
#endif	/* _SYS_SYSI86_H_ */
