/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: cmpt_space.c 1.20 90/06/26 $"

/*
 * Binary configuration data for 4.2 non-VTOC disk compatibility driver
 */

/* $Log:	cmpt_space.c,v $
 */

#include "sys/types.h"
#include "sys/cmpt.h"
#include "sys/param.h"
#include "sys/devsw.h"

#define CMPT_MEM_INIT   10 * NBPG       /* 128 disks, 16 partitions each */
#define CMPT_MEM_CLICK   1 * NBPG

int     cmpt_mem_init = CMPT_MEM_INIT;
int     cmpt_mem_click = CMPT_MEM_CLICK;


/*
 *	Partition tables.
 */

struct cmptsize vertex[CMPT_NUMPART] = {      /* Vertex model 170 */
		0,	    15884,	/* s0 */
	    15884,	    33440,	/* s1 */
	    	0,	   117096,	/* s2 */
	    49324,	    15884,	/* s3 */
	    65208,	    51888,	/* s4 */
	        0,	        0,	/* s5 */
	    49324,	    67772,	/* s6 */
	        0,	        0,	/* s7 */
};

struct cmptsize fujitsu[CMPT_NUMPART] = {      /* Fujitsu model 2243AS */
		0,	    15884,	/* s0 */
	    15884,	    33440,	/* s1 */
	    	0,	   140436,	/* s2 */
	    49324,	    15884,	/* s3 */
	    65208,	    75228,	/* s4 */
	        0,	        0,	/* s5 */
	    49324,	    91112,	/* s6 */
	        0,	        0,	/* s7 */
};

struct cmptsize maxtor[CMPT_NUMPART] = {      /* Maxtor model XT1140 */
		0,	    15884,	/* s0 */
	    15884,	    33440,	/* s1 */
	    	0,	   233324,	/* s2 */
	    49324,	    15884,	/* s3 */
	    65208,	   168116,	/* s4 */
	        0,	        0,	/* s5 */
	    49324,	   184000,	/* s6 */
	        0,	        0,	/* s7 */
};

struct cmptsize wren3[CMPT_NUMPART] = {      /* CDC Wren III 94161 */
		0,	    15884,	/* s0 */
	    15884,	    33440,	/* s1 */
	    	0,	   303975,	/* s2 */
	    49324,	    15884,	/* s3 */
	    65208,	   238767,	/* s4 */
	        0,	        0,	/* s5 */
	    49324,	   254651,	/* s6 */
	        0,	        0,	/* s7 */
};

struct cmptsize wren4[CMPT_NUMPART] = {	   /* CDC Wren IV 94171 */
		0,	    15884,	/* s0 */
	    15884,	    33440,	/* s1 */
	    	0,	   639333,	/* s2 */
	    49324,	    15884,	/* s3 */
	    65208,	   574125,	/* s4 */
	        0,	        0,	/* s5 */
	    49324,	   590009,	/* s6 */
	        0,	        0,	/* s7 */
};

struct cmptsize m2249sa[CMPT_NUMPART] = {	/* Fujitsu M2249SA */
		0,	    15884,	/* s0 */
	    15884,	    33440,	/* s1 */
	    	0,	   650475,	/* s2 */
	    49324,	    15884,	/* s3 */
	    65208,	   585267,	/* s4 */
	    49324,	   300575,	/* s5 */
	    49324,	   601151,	/* s6 */
	   349899,	   300576,	/* s7 */
};

struct cmptsize m2333k[CMPT_NUMPART] = {      /* Fujitsu M2333K (swallow) */
	335*66*10,	 25*66*10,	/* A=cyl 335 thru 359 */
	360*66*10,	102*66*10,	/* B=cyl 360 thru 461 */
	  1*66*10,	820*66*10,	/* C=cyl   1 thru 820 */
	  1*66*10,	410*66*10,	/* D=cyl   1 thru 410 */
	411*66*10,	410*66*10,	/* E=cyl 411 thru 820 */
	  1*66*10,	359*66*10,	/* F=cyl   1 thru 359 */
	462*66*10,	359*66*10,	/* G=cyl 462 thru 820 */
	  1*66*10,	334*66*10,	/* H=cyl   1 thru 334 */
};

struct cmptsize m2351a[CMPT_NUMPART] = {	/* Fujitsu M2351A (Eagle) */
	366*46*20,	 18*46*20,	/* A=cyl 366 thru 383 */
	384*46*20,	 73*46*20,	/* B=cyl 384 thru 456 */
	  1*46*20,	839*46*20,	/* C=cyl   1 thru 839 */
	  1*46*20,	419*46*20,	/* D=cyl   1 thru 419 */
	420*46*20,	419*46*20,	/* E=cyl 420 thru 838 */
	  1*46*20,	383*46*20,	/* F=cyl   1 thru 383 */
	457*46*20,	383*46*20,	/* G=cyl 457 thru 839 */
	  1*46*20,	365*46*20,	/* H=cyl   1 thru 365 */
};

struct cmptsize m2344k[CMPT_NUMPART] = {	/* Fujitsu M2344K (swallow 4) */
	282*66*27,	 10*66*27,	/* A=cyl 282 thru 291 */
	292*66*27,	 38*66*27,	/* B=cyl 292 thru 329 */
	  1*66*27,	621*66*27,	/* C=cyl   1 thru 621 */
	  1*66*27,	310*66*27,	/* D=cyl   1 thru 310 */
	311*66*27,	311*66*27,	/* E=cyl 311 thru 621 */
	  1*66*27,	291*66*27,	/* F=cyl   1 thru 291 */
	330*66*27,	292*66*27,	/* G=cyl 330 thru 621 */
	  1*66*27,	281*66*27,	/* H=cyl   1 thru 281 */
};

struct cmptsize m2382k[CMPT_NUMPART] = {	/* Fujitsu M2382K (swallow 5) */
	348*81*27,	 8*81*27,	/* A=cyl 348 thru 355 */
	356*81*27,	 32*81*27,	/* B=cyl 356 thru 387 */
	  1*81*27,	742*81*27,	/* C=cyl   1 thru 742 */
	  1*81*27,	371*81*27,	/* D=cyl   1 thru 371 */
	372*81*27,	371*81*27,	/* E=cyl 372 thru 742 */
	  1*81*27,	355*81*27,	/* F=cyl   1 thru 355 */
	388*81*27,	355*81*27,	/* G=cyl 388 thru 742 */
	  1*81*27,	347*81*27,	/* H=cyl   1 thru 347 */
};

struct cmptsize m2392k[CMPT_NUMPART] = {	/* Fujitsu M2392K (swallow 6) */
	931*81*21,	 12*81*21,	/* A=cyl 931 thru 943 */
	943*81*21,	 41*81*21,	/* B=cyl 943 thru 984 */
	  1*81*21,	1913*81*21,	/* C=cyl   1 thru 1913 */
	  1*81*21,	956*81*21,	/* D=cyl   1 thru 956 */
	957*81*21,	957*81*21,	/* E=cyl 957 thru 1913 */
	  1*81*21,	942*81*21,	/* F=cyl   1 thru 942 */
	984*81*21,	930*81*21,	/* G=cyl 984 thru 1913 */
	  1*81*21,	930*81*21,	/* H=cyl   1 thru 930 */
};

struct cmptsize cdc9720_850[CMPT_NUMPART] = {	/* CDC 9720-850 (EMD) */
	640*68*15,	 17*68*15,	/* A=cyl 640 thru 656 */
	657*68*15,	 66*68*15,	/* B=cyl 657 thru 722 */
	1*68*15,	1378*68*15,	/* C=cyl   1 thru 1378 */
	1*68*15,	689*68*15,	/* D=cyl   1 thru 689 */
	690*68*15,	689*68*15,	/* E=cyl 690 thru 1378 */
	1*68*15,	656*68*15,	/* F=cyl   1 thru 656 */
	723*68*15, 	656*68*15,	/* G=cyl 723 thru 1378 */
	1*68*15,	639*68*15,	/* H=cyl   1 thru 639 */
};

struct cmptsize cdc9720_1230[CMPT_NUMPART] = { 	/* CDC 9720-1230 (EMD) */
	769*83*15,	  16*83*15,	/* A=cyl 769 thru 784 */
 	785*83*15,	  55*83*15,	/* B=cyl 785 thru 839 */
        1*83*15,	1632*83*15,	/* C=cyl   1 thru 1632 */
 	1*83*15,	 816*83*15,	/* D=cyl   1 thru 816 */
 	817*83*15,	 816*83*15,	/* E=cyl 817 thru 1632 */
 	1*83*15,	 784*83*15,	/* F=cyl   1 thru 784 */
 	840*83*15,	 793*83*15,	/* G=cyl 840 thru 1632 */
 	1*83*15,	 768*83*15,	/* H=cyl   1 thru 768 */
};

struct cmptsize sabre5_1230[CMPT_NUMPART] = { /* SABRE5-1230 (EMD) new format */
	769*83*15,	  16*83*15,	/* A=cyl 769 thru 784 */
 	785*83*15,	  55*83*15,	/* B=cyl 785 thru 839 */
        1*83*15,	1632*83*15,	/* C=cyl   1 thru 1632 */
 	1*83*15,	 816*83*15,	/* D=cyl   1 thru 816 */
 	817*83*15,	 816*83*15,	/* E=cyl 817 thru 1632 */
 	1*83*15,	 784*83*15,	/* F=cyl   1 thru 784 */
 	840*83*15,	 793*83*15,	/* G=cyl 840 thru 1632 */
 	1*83*15,	 768*83*15,	/* H=cyl   1 thru 768 */
};

struct cmptsize *cmptparts[] = {
	vertex,			/* 0 - Vertex model 170 */
	fujitsu,		/* 1 - Fujitsu model 2243AS */
	maxtor,			/* 2 - Maxtor model XT1140 */
	wren3,			/* 3 - CDC Wren III 94161 */
	wren4,			/* 4 - CDC Wren IV 94171 */
	m2249sa,                /* 5 - Fujitsu M2249SA */
        m2333k,                 /* 6 - Fujitsu M2333K (swallow) */
        m2351a,                 /* 7 - Fujitsu M2351A (Eagle) */
        m2344k,                 /* 8 - Fujitsu M2344K (swallow 4) */
        m2382k,                 /* 9 - Fujitsu M2382K (swallow 5) */
        m2392k,                 /* 10 - Fujitsu M2392K (swallow 6) */
	cdc9720_850,		/* 11 - CDC 9720-850 (EMD) */
	cdc9720_1230,		/* 12 - CDC 9720-1230 (EMD) */
	sabre5_1230,		/* 13 - CDC sabre5-1230 (EMD) */
};

int     cmpt_maxtypes     = sizeof (cmptparts) / sizeof(struct cmptsize *);


/* device operations */

extern	int	cmptopen();
extern	int	cmptclose();
extern	int	cmptioctl();
extern	int	nulldev();
extern	int	nostrmsgio();
extern	int	nostrpoll();

struct	devops	cmptops = {
	cmptopen,			/* d_open */
	cmptclose,			/* d_close */
	nulldev,			/* d_strategy */
	nulldev,			/* d_minphys */
	nulldev,			/* d_size */
	nulldev,			/* d_print */
	nulldev,			/* d_read */
	nulldev,			/* d_write */
	cmptioctl,			/* d_ioctl */
	nulldev,			/* d_mmap */
	nulldev,			/* d_shutdown */
	NULL,				/* d_str */
	nostrmsgio,			/* d_strmsgio */
	nostrpoll			/* d_strpoll */
};

