/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: lpmod.h 1.7 89/08/07 $"

#ifndef	_SYS_LPMOD_H_

/*
 * lpmod.h
 *	Defines for parallel printer canonical processing
 *	module.
 */

/* $Log:	lpmod.h,v $
*/

/*
 * lpmod info structure
 */
struct lpmod_info {
	queue_t *lpm_qptr;		/* write queue ptr */
	int	lpm_state;		/* module state */
	lock_t	lpm_lock;		/* data structure lock */
	sema_t  lpm_wait;		/* semaphore */
	int	lpm_ops;		/* mode of processing */
	int	lpm_width;		/* page width */
	int	lpm_height;		/* page length */
	int	lpm_line;		/* current line */
	int	lpm_col;		/* current physical col */
	int	lpm_lcol;		/* logical column */
};

/*
 * lpm_state bit flags
 */
#define	LPM_MESSAGES		0x1	/* messages in queue */
#define LPM_SLEEP		0x2	/* waiting for queue to drain */

#define LPMOD_SPL		SPLSTR	/* interrupt level to mask */

/*
 * Miscellaneous defines
 */
#define FORMFEED		'\f'	/* formfeed char */
#define LPMSMALLBLK		8	/* small stream buffer */
#define LPMBLKSIZ	     	4096	/* processing buffer size */
#define LPM_DEF_OPS		PRRAW	/* default processing mode */
#define LPM_DEF_WIDTH		132	/* default page width */
#define LPM_DEF_HEIGHT		66	/* default page length */
#define LPMLONGLINE		1000	/* maximum line length */

#define	_SYS_LPMOD_H_
#endif	/* _SYS_LPMOD_H_ */
