/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: mbad_ioconf.h 1.6 89/08/07 $"

#ifndef	_SYS_MBAD_IOCONF_H_

/*
 * mbad_ioctl.h
 *	Configuration description of a device on a Multi-Bus Adapter .
 */


/* 
 * $Log:	mbad_ioconf.h,v $
 */

extern	ulong			MBAd_IOwindow;	/* 1/4Meg for IO window */

/*
 * mbad_conf entry points at array of mbad_dev's; each mbad_dev structure
 * describes a single MBAd board.
 *
 * After probing, driver boot procedure is called with a pointer to an
 * array of these.
 */

struct	mbad_dev {
	int		md_idx;			/* mbad index; -1 == wildcard */
	ulong		md_csr;			/* command/status register */
	ulong		md_flags;		/* flags (arbitrary) */
	ushort		md_mapwant;		/* # map registers needed */
	unchar		md_bin;			/* interrupt bin # */
	unchar		md_level;		/* multibus interrupt level */
/*
 * The remaining fields are filled in when the configure() runs.
 * Initial implementation copies md_mapwant to md_nmaps.
 * md_vector of 1st mbad_dev in a set defines "base" vector.
 */
	struct	mb_desc	*md_desc;		/* -> host mb_desc structure */
	ushort		md_basemap;		/* 1st map register allocated */
	ushort		md_nmaps;		/* # maps allocated */
	unchar		md_vector;		/* assigned interrupt vector */
	unchar		md_alive;		/* is alive? */
};



#define	_SYS_MBAD_IOCONF_H_
#endif	/* _SYS_MBAD_IOCONF_H_ */
