/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: sec_space.c 1.10 89/08/07 $"

/*
 * Configuration tables for this device
 */

/* $Log:	sec_space.c,v $
 */
#include "sys/types.h"
#include "sys/sec.h"
#include "sys/autoconf.h"
#include "sys/consmemioctl.h"
#include "sys/sec_ioconf.h"
#include "sys/sec_modes.h"
#include "sys/sec_ctl.h"
#include "sys/sec_device.h"
#include "config.h"

/* Watchdog timer timeout value in seconds for SEC */
int sec_wdt_timeout = SEC_WDT_TIMEOUT;

/* All SB8000 devices use the same configuration, defined in sb8000_space.c */
extern struct device_config sb8000_config[];

/* autoconfig structure linking device configuration with busses */
struct dev_on_bus sec_on_busses[] = {
	{ SB8000, 1, sb8000_config }, 
	{ NOBUS,},
};

/*
 * WARNING:  All devices on the SEC_SCSI bus share one configuration table.
 * This table has the following conventions, known to the individual device
 * drivers and used by them to speed probing.  
 *
 * Configurations with dev_len == 0 and logical unit == -1 are wildcards.
 * These apply equally to embedded and non-embedded SCSIs.  Configurations with
 * dev_len == 8 are for embedded scsi (and take up all luns for the given
 * target adapter).  Configurations with dev_len == 1 are for non-embedded
 * SCSI. Each of these groups appear as a single block in the table.
 *
 * Changing this table in voilation of this convention is not recommended and
 * may result in erratic probing behavior and possibly looping.
 *
 * ****** sec.c  will eventaully validate this table.
 */

/* All sec_scsi devices use the same configuration, defined below */
struct device_config sec_scsi_config[] = {
	/* length, target_adaptor, logical_unit, unused */
	/* Probes with SCSI logical unit number wild */
/*  0 */	{ 0, 0, -1, 5 },
/*  1 */	{ 0, 1, -1, 5 },
/*  2 */	{ 0, 2, -1, 5 },
/*  3 */	{ 0, 3, -1, 5 },
/*  4 */	{ 0, 4, -1, 5 },
/*  5 */	{ 0, 5, -1, 5 },
/*  6 */	{ 0, 6, -1, 5 },
/*  7 */	{ 0, 7, -1, 5 },
	/* Probe embedded SCSIs up */
/*  8 */	{ 8, 0, 0, 5 },
/*  9 */	{ 8, 1, 0, 5 },
/* 10 */	{ 8, 2, 0, 5 },
/* 11 */	{ 8, 3, 0, 5 },
/* 12 */	{ 8, 4, 0, 5 },
/* 13 */	{ 8, 5, 0, 5 },
/* 14 */	{ 8, 6, 0, 5 },
/* 15 */	{ 8, 7, 0, 5 },
	/* Probe non-embedded SCSIs down in target adapter, up in lun */
/* 16 */	{ 1, 7, 0, 5 },
/* 17 */	{ 1, 7, 1, 5 },
/* 18 */	{ 1, 7, 2, 5 },
/* 19 */	{ 1, 7, 3, 5 },
/* 20 */	{ 1, 7, 4, 5 },
/* 21 */	{ 1, 7, 5, 5 },
/* 22 */	{ 1, 7, 6, 5 },
/* 23 */	{ 1, 7, 7, 5 },
/* 24 */	{ 1, 6, 0, 5 },
/* 25 */	{ 1, 6, 1, 5 },
/* 26 */	{ 1, 6, 2, 5 },
/* 27 */	{ 1, 6, 3, 5 },
/* 28 */	{ 1, 6, 4, 5 },
/* 29 */	{ 1, 6, 5, 5 },
/* 30 */	{ 1, 6, 6, 5 },
/* 31 */	{ 1, 6, 7, 5 },
/* 32 */	{ 1, 5, 0, 5 },
/* 33 */	{ 1, 5, 1, 5 },
/* 34 */	{ 1, 5, 2, 5 },
/* 35 */	{ 1, 5, 3, 5 },
/* 36 */	{ 1, 5, 4, 5 },
/* 37 */	{ 1, 5, 5, 5 },
/* 38 */	{ 1, 5, 6, 5 },
/* 39 */	{ 1, 5, 7, 5 },
/* 40 */	{ 1, 4, 0, 5 },
/* 41 */	{ 1, 4, 1, 5 },
/* 42 */	{ 1, 4, 2, 5 },
/* 43 */	{ 1, 4, 3, 5 },
/* 44 */	{ 1, 4, 4, 5 },
/* 45 */	{ 1, 4, 5, 5 },
/* 46 */	{ 1, 4, 6, 5 },
/* 47 */	{ 1, 4, 7, 5 },
/* 48 */	{ 1, 3, 0, 5 },
/* 49 */	{ 1, 3, 1, 5 },
/* 50 */	{ 1, 3, 2, 5 },
/* 51 */	{ 1, 3, 3, 5 },
/* 52 */	{ 1, 3, 4, 5 },
/* 53 */	{ 1, 3, 5, 5 },
/* 54 */	{ 1, 3, 6, 5 },
/* 55 */	{ 1, 3, 7, 5 },
/* 56 */	{ 1, 2, 0, 5 },
/* 57 */	{ 1, 2, 1, 5 },
/* 58 */	{ 1, 2, 2, 5 },
/* 59 */	{ 1, 2, 3, 5 },
/* 60 */	{ 1, 2, 4, 5 },
/* 61 */	{ 1, 2, 5, 5 },
/* 62 */	{ 1, 2, 6, 5 },
/* 63 */	{ 1, 2, 7, 5 },
/* 64 */	{ 1, 1, 0, 5 },
/* 65 */	{ 1, 1, 1, 5 },
/* 66 */	{ 1, 1, 2, 5 },
/* 67 */	{ 1, 1, 3, 5 },
/* 68 */	{ 1, 1, 4, 5 },
/* 69 */	{ 1, 1, 5, 5 },
/* 70 */	{ 1, 1, 6, 5 },
/* 71 */	{ 1, 1, 7, 5 },
/* 72 */	{ 1, 0, 0, 5 },
/* 73 */	{ 1, 0, 1, 5 },
/* 74 */	{ 1, 0, 2, 5 },
/* 75 */	{ 1, 0, 3, 5 },
/* 76 */	{ 1, 0, 4, 5 },
/* 77 */	{ 1, 0, 5, 5 },
/* 78 */	{ 1, 0, 6, 5 },
/* 79 */	{ 1, 0, 7, 5 },
        { -1, },
};
