/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: ssm_space.c 1.7 89/08/07 $"

/*
 * ssm_space.c
 *	Configuration tables for the SSM.
 */

/* $Log:	ssm_space.c,v $
 */

#include "sys/types.h"
#include "sys/param.h"
#include "sys/autoconf.h"
#include "sys/scsi.h"
#include "sys/scsi_adapter.h"
#include "sys/ssm.h"
#include "sys/ssm_misc.h"
#include "sys/ssm_scsi.h"
#include "sys/ssm_vme.h"
#include "sys/ssm_cb.h"
#include "sys/ssm_comblock.h"
#include "sys/ssm_device.h"
#include "config.h"

/* Watchdog timer timeout value in seconds for SSM */
int ssm_wdt_timeout = SSM_WDT_TIMEOUT;

/* All SB8000 devices use the same configuration, defined in sb8000_space.c */
extern struct device_config sb8000_config[];

/* autoconfig structure linking device configuration with busses */
struct dev_on_bus ssm_on_busses[] = {
	{ SB8000, 1, sb8000_config }, 
	{ NOBUS,},
};

/* All SSM_SCSI devices share a common config array, below */
struct device_config ssm_scsi_config[] = {
	/* length, target_adaptor, logical_unit, unused */
/* 0 */		{ 8, 0, 0, 0},
/* 1 */		{ 8, 1, 0, 0},
/* 2 */		{ 8, 2, 0, 0},
/* 3 */		{ 8, 3, 0, 0},
/* 4 */		{ 8, 4, 0, 0},
/* 5 */		{ 8, 5, 0, 0},
/* 6 */		{ 8, 6, 0, 0},
/* 7 */		{ 8, 7, 0, 0},
		{ -1,},
};
