/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: st_space.c 1.20 90/03/06 $"

/*
 * st_space.c
 *	Systech binary configuration file.
 */

/* $Log:	st_space.c,v $
 */

#include "sys/types.h"
#include "sys/devsw.h"
#include "sys/session.h"
#include "sys/stream.h"
#include "sys/termio.h"
#include "sys/st.h"
#include "sys/st_device.h"

/* Initial line state */
stcflags = CS8 | B9600 | CREAD | HUPCL;

/*
 * Below are parameters that can be modified
 * to change driver actions.
 */
int	stfifotimeout = 100000;	/* aprox. 1/2 sec timeout */
int	sttimerrate = STT_88;	/* rate sttimer() is called */
int	sttimerave = 30;	/* amount rate changes each tick */
int	stvdwait = 5;		/* spins in stintr() to wait for valid data */
unchar	stprintoverflow = 1;	/* non-zero prints message on input overflow */
unchar	stprintalocfail = 0;	/* non-zero prints message on allocb fail */
unchar	stprintupstreamblkd = 1;/* non-zero prints message on blocked upstream*/
int	staddwait = 1;		/* additional amount of time to wait for drain*/
/*
 * Block input low water / high water table.
 * SLOW mode is a block input with a termination count of 1. 
 * Fast mode is a block input with a termination count of CBSIZE.
 * For baud rates less than 600, block input is never a win
 * so we set up the table so it can't happen.
 */
struct	stlh stlh[16] = {
	{  25,    50 },		/* 0 */
	{ 100, 10000 },		/* 50 */
	{ 100, 10000 },		/* 75 */
	{ 100, 10000 },		/* 110 */
	{ 100, 10000 },		/* 134 */
	{ 100, 10000 },		/* 150 */
	{ 100, 10000 },		/* 200 */
	{ 100, 10000 },		/* 300 */
	{ 100, 10000 },		/* 600 */
	{   3,     6 },		/* 1200 */
	{   4,     9 },		/* 1800 */
	{   6,    12 },		/* 2400 */
	{  12,    21 },		/* 4800 */
	{  14,    25 },		/* 9600 */
	{  18,    31 },		/* 19200 */
	{  25,    50 },		/* 38400 */
};
#include "sys/autoconf.h"
#include "sys/multibus.h"
#include "config.h"

unchar st_bin = 4;
int st_flags = 0;

/* configuration table for the st device on the multibus bus */
struct device_config st_multibus_config[] = {
/*              length, space,          address, interrupt */
/* st0 */	{ 0x10, MULTIBUS_IO_SPACE, 0x200, 3 },
/* st1 */	{ 0x10, MULTIBUS_IO_SPACE, 0x210, 4 },
/* st2 */	{ 0x10, MULTIBUS_IO_SPACE, 0x220, 5 },
/* st3 */	{ 0x10, MULTIBUS_IO_SPACE, 0x230, 6 },
/* st4 */	{ 0x10, MULTIBUS_IO_SPACE, 0x240, 3 },
/* st5 */	{ 0x10, MULTIBUS_IO_SPACE, 0x250, 4 },
/* st6 */	{ 0x10, MULTIBUS_IO_SPACE, 0x260, 5 },
/* st7 */	{ 0x10, MULTIBUS_IO_SPACE, 0x270, 6 },
/* st8 */	{ 0x10, MULTIBUS_IO_SPACE, 0x280, 3 },
/* st9 */	{ 0x10, MULTIBUS_IO_SPACE, 0x290, 4 },
/* st10 */	{ 0x10, MULTIBUS_IO_SPACE, 0x2a0, 5 },
/* st11 */	{ 0x10, MULTIBUS_IO_SPACE, 0x2b0, 6 },
/* st12 */	{ 0x10, MULTIBUS_IO_SPACE, 0x2c0, 3 },
/* st13 */	{ 0x10, MULTIBUS_IO_SPACE, 0x2d0, 4 },
/* st14 */	{ 0x10, MULTIBUS_IO_SPACE, 0x2e0, 5 },
/* st15 */	{ 0x10, MULTIBUS_IO_SPACE, 0x2f0, 6 },
	{ -1, },
};

/* autoconfig structure linking device configuration with busses */
struct dev_on_bus st_on_busses[] = {
	{ MULTIBUS, 1, st_multibus_config }, 
	{ NOBUS,},
};


/* device operations */

extern	struct	streamtab	stinfo;
extern	int	nodev();
extern	int	nulldev();
extern	int	nostrmsgio();
extern	int	nostrpoll();


struct	devops	stdevops = {
	nulldev,		/* d_open */
	nulldev,		/* d_close */
	nulldev,		/* d_strategy */
	nulldev,		/* d_minphys */
	nulldev,		/* d_psize */
	nulldev,		/* d_print */
	nulldev,		/* d_read */
	nulldev,		/* d_write */
	nodev,			/* d_ioctl */
	nulldev,		/* d_mmap */
	nulldev,		/* d_intr */
	&stinfo,		/* d_str */
	nostrmsgio,		/* d_strmsgio */
	nostrpoll		/* d_strpoll */
};
