/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident "$Header: tg_device.h 1.3 89/08/07 $"

#ifndef	_SYS_TG_DEVICE_H_

/*
 * tg_device.h
 *	Configuration include file for HP 88780 SCSI tape driver
 */

/* $Log:	tg_device.h,v $
 */

/*
 * Define the driver's device structure.  It must
 * begin with a generic SCSI device structure and
 * is followed by driver dependent fields.  Attempt
 * to use simple definitions so that the config
 * utility and conf.c don't have to know about tg.h.
 */

struct tg_device {
	/* Generic device description */
    int         busnum;                    /* index into system bus table. */
    int         unit;                     /* Unit #, index into config table */
    int 	segsize;		  /* Size of a DMA segment */
    int		segalign;		  /* driver promises this alignment */
    int		nsegs;			  /* this device need this many segs */
    struct      driver_module   *driver;  /* pointer into "drivers[]" */
    struct      dev_on_bus      *on_bus;  /* points into drivers[].on_busses */
    struct      bus             *bus;
    struct      device_config   *config;
    struct      gen_device      *next;    /* Chain of devices on same bus */
    char       *map_origin;               /* sequent addr of map regs. */
    char       *bus_map_addr;             /* start of dma map, bus side. */
    long        map_extent;               /* # of bytes covered by map. */
    int         n_maps;                   /* Number of maps */
    int         nspaces;                  /* length of devreg, below */
    /* Devreg is really variable length, but the compiler wants a size... */
    char       *devreg[1];                 /* could point to CSR or CB */

    /*
     * SCSI specific fields for the wd_device.
     */
	ulong ident;			/* Adapter specific i.d. of device */
	int (*polled_cmd)();		/* Adapter specific scsi_polled_cmd
					 * interface for this device */
	ulong (*start_cmd)();		/* Adapter specific scsi_start_cmd
					 * interface for this device */
	caddr_t (*alloc)();		/* Adapter specific allocation function
					 * to ensure data alignment. */
	caddr_t adapt; 			/* Adapter specific info for device */
	unchar info_id;			/* Device's index into the driver's
					 * unit information table. */
	unchar drive_id;		/* Device's index into the driver's
					 * tg_drives configuration table. */
};

typedef struct tg_device tgdev_t;

extern struct dev_on_bus tg_on_busses[];

#define	_SYS_TG_DEVICE_H_
#endif	/* _SYS_TG_DEVICE_H_ */
