/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: tm_space.c 1.13 90/01/25 $"

/*
 * conf_tm.c 
 * 	SSM/SCSI tape device driver configuration file.
 */

/* $Log:	tm_space.c,v $
 */

#include "sys/types.h"
#include "sys/devsw.h"
#include "sys/param.h"
#include "sys/buf.h"
#include "sys/tm.h"			/* driver local structures */
#include "sys/tm_device.h"

/*
 * Configure the device's tuning parameters.
 *
 * The number to the far right will be the unit 
 * number portion of the devices major/minor pair.
 *
 * The bits field is or'd into scsi[1] of the command 
 * block to determine whether the immediate bit is set 
 * or not (adsi requires this set).
 */
struct tm_bconf tm_bconf[] = {
	/* buf_sz,	cflags,		 bits */
	{ 64, TMC_AUTORET, 1 }, 	/*0*/
	{ 64, TMC_AUTORET, 1 }, 	/*1*/
	{ 64, TMC_AUTORET, 1 }, 	/*2*/
	{ 64, TMC_AUTORET, 1 }, 	/*3*/
};

/* table of possible minor device number permutations per unit */
int tm_minor[] = {
	0,
	TM_NOREWFLAG
};

int tm_max_ndevs = sizeof(tm_bconf) / sizeof(struct tm_bconf);
#include "sys/autoconf.h"
#include "config.h"

unchar tm_bin = 5;

/* All ssm_scsi devices use the same configuration */
extern struct device_config ssm_scsi_config[];

/* autoconfig structure linking device configuration with busses */
struct dev_on_bus tm_on_busses[] = {
	{ SSM_SCSI, 1, ssm_scsi_config }, 
	{ NOBUS,},
};


/* device operations */

extern	int	tmopen();
extern	int	tmclose();
extern	int	tmstrat();
extern	int	tmminphys();
extern	int	tmread();
extern	int	tmwrite();
extern	int	tmioctl();
extern	int	nulldev();
extern	int	nostrmsgio();
extern	int	nostrpoll();

struct	devops	tmdevops = {
	tmopen,			/* d_open */
	tmclose,		/* d_close */
	tmstrat,		/* d_strategy */
	tmminphys,		/* d_minphys */
	nulldev,		/* d_size */
	nulldev,		/* d_print */
	tmread,			/* d_read */
	tmwrite,		/* d_write */
	tmioctl,		/* d_ioctl */
	nulldev,		/* d_mmap */
	nulldev,		/* d_intr */
	NULL,			/* d_str */
	nostrmsgio,		/* d_strmsgio */
	nostrpoll		/* d_strpoll */
};
