/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */


#ident	"$Header: ts_space.c 1.19 90/01/25 $"

/*
 * cont_ts.c - SCSI tape device driver configuration file
 */

/* $Log:	ts_space.c,v $
 */

#include "sys/types.h"
#include "sys/devsw.h"
#include "sys/param.h"
#include "sys/buf.h"
#include "sys/sec.h"
#include "sys/ts.h"
#include "sys/ts_device.h"

/*
 * Configure the device's tuning parameters.
 *
 * The number to the far right will be the unit number portion of the
 * devices major/minor pair.
 *
 *	The bits field is or'd into scsi[1] of the command block to
 *	determine whether the immediate bit is set or not
 *	(adsi requires this set).
 */
struct ts_bconf tsbconf[] = {		/*
buf_sz,	cflags,			bits */
{64,	TSC_AUTORET,		1}, /*0*/
{64,	TSC_AUTORET,		1}, /*1*/
{64,	TSC_AUTORET,		1}, /*2*/
{64,	TSC_AUTORET,		1}, /*3*/
};

int 	tsspintime = 2000000;

/* device operations */
extern	int	tsopen(), tsclose(), tsstrat(), tsminphys(), 
		tsread(), tswrite(), tsioctl(), nulldev(),
		nostrmsgio(), nostrpoll();

struct devops tsdevops = {
	tsopen,			/* d_open */
	tsclose,		/* d_close */
	tsstrat,		/* d_strategy */
	tsminphys,		/* d_minphys */
	nulldev,		/* d_size */
	nulldev,		/* d_print */
	tsread,			/* d_read */
	tswrite,		/* d_write */
	tsioctl,		/* d_ioctl */
	nulldev,		/* d_mmap */
	nulldev,		/* d_intr */
	NULL,			/* d_str */
	nostrmsgio,		/* d_strmsgio */
	nostrpoll		/* d_strpoll */
};

/* minor device number permutations */
int	ts_minor[] = {
	TS_DEFAULT,
	TS_NOREWIND
};

/*
 * DON'T CHANGE ANY THING BELOW THIS LINE OR ALL BETS ARE OFF!
 */
int	tsmaxminor = sizeof(tsbconf)/sizeof(struct ts_bconf);
int	tssensebuf_sz = 32 * sizeof(char);
#include "sys/autoconf.h"
#include "config.h"

int ts_req_size = 4;
int ts_doneq_size = 4;
int ts_flags = 0;
unchar ts_bin = 5;

/* All sec_scsi devices use the same configuration */
extern struct device_config sec_scsi_config[];

/* autoconfig structure linking device configuration with busses */
struct dev_on_bus ts_on_busses[] = {
	{ SEC_SCSI, 1, sec_scsi_config }, 
	{ NOBUS,},
};
