/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: wp_space.c 1.10 90/01/25 $"

/*
 * wp_space.c
 *	Configuration data for the wp, ssm parallel printer driver.
 */

/* $Log:	wp_space.c,v $
*/

#include "sys/types.h"
#include "sys/devsw.h"
#include "sys/session.h"
#include "sys/stream.h"
#include "sys/ssm_cb.h"
#include "sys/wp.h"	
#include "sys/printer.h"

/*
 * For details on configuration, see wp(7).  The special_map field is
 * defined to contain one of:
 *
 * PRSPECIAL: 		Align the form on device open and close and
 *			interpret newlines, backspaces, tabs and form feeds.
 * PRCAPS:		Upper case only mode - printer assumed to have a
 *			small character set.
 * PRRAW:		Pass all 8 bits to the printer without interpretation.
 *
 * The interface field is defined to contain
 * 	0		- Centronics printer interface
 *	1		- Data Products printer interface
 *
 * Note that the the mode and width fields are not interpreted
 * by the driver and are only used by a module pushed on top
 * of the driver (lpmod).  Without the module, the printer will
 * always be in PRRAW mode.
 */
struct	wp_printer	wpconfig[] = {

/*	cols,	special_map,	interface	 lp# */

{	132,	PRRAW,		0	} ,	/* 0 */
};

int	wpprinters = sizeof(wpconfig) / sizeof(struct wp_printer);

unchar wp_bin = 5;

/* device operations */
extern	struct	streamtab	wpinfo;
extern	int	nulldev();
extern	int	nodev();
extern	int	nostrmsgio();
extern	int	nostrpoll();

struct	devops	wpdevops = {
	nulldev,		/* d_open */
	nulldev,		/* d_close */
	nulldev,		/* d_strat */
	nulldev,		/* d_minphys */
	nulldev,		/* d_size */
	nulldev,		/* d_print */
	nulldev,		/* d_read */
	nulldev,		/* d_write */
	nodev,			/* d_ioctl */
	nulldev,		/* d_mmap */
	nulldev,		/* d_intr */
	&wpinfo,		/* d_str */
	nostrmsgio,		/* d_strmsgio */
	nostrpoll		/* d_strpoll */
};
