/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: xs_space.c 1.27 90/08/09 $"

/*
 * xs_space.c
 *	configuration parameters for Xylogics 781 STREAMS driver
 */

/* $Log:	xs_space.c,v $
 */

#include "sys/types.h"
#include "sys/devsw.h"
#include "sys/session.h"
#include "sys/stream.h"
#include "sys/termio.h"
#include "sys/xs.h"
#include "sys/xs_device.h"

/* Initial line state */
int xscflags = CS8 | B9600 | CREAD | HUPCL;
ushort xsrxtime = 20;  /* 0.1 sec */

int xsaddwait  = 1;
int xsinputmin = 255;		/* NOTE: xsinputmin must be <= 255 */
unchar xsprintoverflow = 0;	/* 0 = don't print overflow messages */
unchar xsprintalocfail = 0;	/* 0 = don't print allocb fail messages */
int xsbreaktime = 250;		/* Break duration in milliseconds */
uint xstimeout = 400000;	/* Approx. 4 seconds */

int xslowwater = XSLOWWATER;

#include "sys/autoconf.h"
#include "config.h"

/*  >>>>>  configuration table for xs devices on the VME bus <<<<<    */
/* Since the Xylogics 781 uses two VME address modifiers, one for the
 * control register accesses and one for data transfers, we must supply
 * two configuration lines per 781.  The first line shows the address
 * modifier for csr access and the base address of the 781 board.  The
 * second line shows the address modifier for the 781<->host data transfers.
 * NOTE: It is required that two lines be added to this structure for
 * *each* 781 configured into the system.
 */
struct device_config xs_vme_config[] = {
/*Board    length, space,        address, interrupt */
/* 0 */ {   0x10,  XS_CSR_AMOD,  0xC000,    2    },  /* csr access */
/* 0 */ {   0x0,   XS_DMA_AMOD,  0,         2    },  /* data transfers */
/* 1 */ {   0x10,  XS_CSR_AMOD,  0xC010,    2    },
/* 1 */ {   0x0,   XS_DMA_AMOD,  0,         2    },
/* 2 */ {   0x10,  XS_CSR_AMOD,  0xC020,    2    },
/* 2 */ {   0x0,   XS_DMA_AMOD,  0,         2    },
/* 3 */ {   0x10,  XS_CSR_AMOD,  0xC040,    2    },
/* 3 */ {   0x0,   XS_DMA_AMOD,  0,         2    },
/* 4 */ {   0x10,  XS_CSR_AMOD,  0xC080,    2    },
/* 4 */ {   0x0,   XS_DMA_AMOD,  0,         2    },
	{ -1, },
};

unchar xs_bin  = 4;		/* 781 slic bin */

/* Autoconfig structure linking device configuration with busses.
 * The "2" in the following structure tells the autoconfig code how many
 * device_config entries correspond to each 781 board.  This allows the
 * autoconfig code to understand the xs_vme_config table defined above.
 * This value must not be changed..
 */
struct dev_on_bus xs_on_busses[] = {
   { VME, 2, xs_vme_config },
	{ NOBUS,},
};


/* device operations */

extern	struct	streamtab	xsinfo;
extern	int	nodev();
extern	int	nulldev();
extern	int	nostrmsgio();
extern	int	nostrpoll();

struct	devops	xsdevops = {
	nulldev,		/* d_open */
	nulldev,		/* d_close */
	nulldev,		/* d_strategy */
	nulldev,		/* d_minphys */
	nulldev,		/* d_psize */
	nulldev,		/* d_print */
	nulldev,		/* d_read */
	nulldev,		/* d_write */
	nodev,			/* d_ioctl */
	nulldev,		/* d_mmap */
	nulldev,		/* d_intr */
	&xsinfo,		/* d_str */
	nostrmsgio,		/* d_strmsgio */
	nostrpoll		/* d_strpoll */
};
