/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident "$Header: zdc_device.h 1.5 89/09/01 $"

#ifndef	_SYS_ZDC_DEVICE_H_

/*
 * zdc_device.c
 *	Configuration include file for ZDC disk controller
 */

/* $Log:	zdc_device.h,v $
 */

struct zdc_device {
    int         busnum;                    /* index into system bus table. */
    int         unit;                     /* Unit #, index into config table */
    int 	segsize;		  /* Size of a DMA segment */
    int		segalign;		  /* driver promises this alignment */
    int		nsegs;			  /* this device need this many segs */
    struct      driver_module   *driver;  /* pointer into "drivers[]" */
    struct      dev_on_bus      *on_bus;  /* points into drivers[].on_busses */
    struct      bus             *bus;
    struct      device_config   *config;
    struct      gen_device      *next;    /* Chain of devices on same bus */
    char       *map_origin;               /* sequent addr of map regs. */
    char       *bus_map_addr;             /* start of dma map, bus side. */
    long        map_extent;               /* # of bytes covered by map. */
    int         n_maps;                   /* Number of maps */
    int         nspaces;                  /* length of devreg, below */
    char       *devreg[1];                 /* could point to CSR or CB */
    /* here starts the zdc specific per device fields */
    struct ctlr_desc *cd;		/* System TOC descriptor address */
};

extern struct dev_on_bus zdc_on_busses[];

/* stubs for bus controller routines to work with the new autoconfig */
#define zdc_smde_probe_setup ((int (*)())0)
#define zdc_smde_dma_setup ((int (*)())0)
#define zdc_smde_dma_remap ((char *(*)())0)
#define zdc_smde_alloc_maps ((void (*)())0)
#define zdc_smde_dma_done ((void (*)())0)
#define zdc_smde_dma_flush ((void (*)())0)
#define zdc_smde_intr_setup ((int (*)())0)
#define zdc_smde_ack_int ((void (*)())0)

#define	_SYS_ZDC_DEVICE_H_
#endif	/* _SYS_ZDC_DEVICE_H_ */
