/* 
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: autop_space.c 1.14 90/06/28 $"

/*
 * Streams autopush configuration
 */

/* $Log:	autop_space.c,v $
 */

#include	"sys/conf.h"
#include	"sys/strap.h"

/*
 * format
 *       driver name    lower  upper  module name   index of next 
 *    or module name    minor  minor                   module
 *
 * Note a driver may specify a list of modules to be pushed.
 * a module may be composed of other modules but those modules must
 * be "real" ie no more recursion may take place.
 */

struct str_ap str_ap[] = {
	{ "st",		0,	-1,	"ld",  		-1 },	/* 0 */
	{ "co",		0,	-1,	"fl",  		 3 },   /* 1 */
	{ "sc",		0,	-1,	"fl",  		 3 },	/* 2 */
	{ "flavours",	0,	-1,	"ld",  		-1 },	/* 3 */
	{ "lp",		0,	-1,	"lpmod",	-1 },	/* 4 */
	{ "wp",		0,	-1,	"lpmod",	-1 },	/* 5 */
	{ "pts",	0,	-1,	"ld",  		-1 },	/* 6 */
	{ "xs",		0,	-1,	"ld",  		-1 },	/* 7 */
        { "kd",         0,      -1,     "fl",            3 },   /* 8 */
        { "asy",        0,      -1,     "fl",            3 },   /* 9 */
        { "db",         0,      -1,     "ld",           -1 },   /* 10 */
        { "pp",         0,      -1,     "lpmod",        -1 },   /* 11 */
	0
};

/*
 * examples
 * xxt is a driver that has xyt then ldterm pushed on it
 * yyt is a driver that has ldterm pushed on it
 * ldt is a module composed of ptem pushed on ld0
 * ld0 is a module coposed of ld0 pushed on echop
 * ld1 is a module coposed of echop pushed on ld1
 *
 *    { "xxt",	0,	-1,	"xyt",		1  }	 0 
 *    { "",	0,	-1,	"ldterm",	-1 }	 1 
 *    { "yyt",	0,	-1,	"ldterm",	-1 }	 2 
 *    { "ldt",	0,	-1,	"ptem",		4  }	 3 
 *    { "",	0,	-1,	"ld0",		-1 }	 4 
 *    { "ld0",	0,	-1,	"echop",	6 }	 5 
 *    { "",	0,	-1,	"ld0",		-1 }	 6 
 *    { "ld1",	0,	-1,	"ld1",		8 }	 7 
 *    { "",	0,	-1,	"echop",	-1 }	 8 
 *
 * note entries 1 and 2 are equivalent as are 4 and 6 
 * (the first field of a continuation is ignored).
 * and could be coded as:
 *
 *    { "xxt",	0,	-1,	"xyt",		1  }	 0 
 *    { "yyt",	0,	-1,	"ldterm",	-1 }	 1
 *    { "ldt",	0,	-1,	"ptem",		4  }	 2
 *    { "",	0,	-1,	"ld0",		-1 }	 3
 *    { "ld0",	0,	-1,	"echop",	3 }	 5
 *    { "ld1",	0,	-1,	"ld1",		8 }	 6
 *    { "",	0,	-1,	"echop",	-1 }	 7
 */

