/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: mmap_space.c 1.7 89/08/07 $"

/*
 * mmap_space.c
 *	Vnode type -> mmap operations map.
 */

/* $Log:	mmap_space.c,v $
 */

#include "sys/types.h"
#include "sys/devsw.h"
#include "sys/signal.h"
#include "sys/param.h"
#include "sys/debug.h"
#include "sys/systm.h"
#include "sys/mutex.h"
#include "sys/user.h"
#include "sys/vnode.h"

/*
 * vnode_mmap[] is indexed by the vnode type to determine mapping operations.
 * Thus order must exactly match enum vtype (h/vnode.h).
 */

extern	struct	mapops	mmap_reg;
extern	struct	mapops	mmap_chr;
extern	struct	mapops	mmap_null;

struct	mapops	*vnode_mmap[] = {
	&mmap_null,		/* VNON */
	&mmap_reg,		/* VREG */
	&mmap_null,		/* VDIR */
	&mmap_null,		/* VBLK */
	&mmap_chr,		/* VCHR */
	&mmap_null,		/* VLNK */
	&mmap_null,		/* VSOCK */
	&mmap_null,		/* VFIFO */
	&mmap_null,		/* VBAD */
};
