/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident "$Header: stats_space.c 1.2 89/08/07 $"

/*
 * stats_space.c
 *	Disk and tape statistics configurables
 */

/* $Log:	stats_space.c,v $
 */

#include "sys/types.h"
#include "sys/buf.h"
#include "sys/stats_disk.h"
#include "sys/stats_tape.h"

/*
 * Disk statistics configurables
 */

unsigned ds_arraysize = 16;	/* number of structures allocated at a time */
unchar	ds_keep_cylinfo = 1;	/* nonzero => keep histogram of cylinder */
				/* accesses  and seek distances */
/*
 * For disk devices that present a logical block interface and knowledge
 * of cylinder boundaries is not available, "cylinder" access stats are
 * kept as "range of blocks" access stats.  ds_blocks_per_bucket is the number
 * of blocks (sectors) in a histogram bucket.  blocks are assumed to be
 * DEV_BSIZE bytes.
 */
unsigned ds_blocks_per_bucket = 2048;

/*
 * Tape statistics configurables
 */

unsigned tp_arraysize = 16;	/* number of structures allocated at a time */
