/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: vec_space.c 1.7 90/04/20 $"

/*
 * vec_space.c
 *
 * This file contains the definition of software
 * interrupt and trap vectors.
 */

/* $Log:	vec_space.c,v $
 */

/*
 * Software Interrupt Vectors.
 */

#include "sys/types.h"

#ifdef	i386
/*
 * Fake software interrupts by setting bits in memory on machines
 * that don't have a SYMMETRY SLIC or VAX AST style interrupt capability.
 */

unchar	bin0mask;
#endif	/* i386 */

extern	int	undef(), softclock(), resched(), runqueues();
extern	int	FlushTLBIntr();

int	(*softvec[8])() = {
	runqueues,    	/* 0 */
	FlushTLBIntr,	/* 1 */
	undef,   	/* 2 */
	undef,		/* 3 */
	softclock, 	/* 4 */
	undef, 		/* 5 */
	undef, 		/* 6 */
	resched,	/* 7 */
};

/*
 * Software Trap Vectors.
 */

extern	int	swt_undef(), vpffintr(), profswt();

extern	int	swt_fpu_pgxbug();

int	(*swtrapvec[8])() = {
	vpffintr,    	/* 0 */
	profswt,	/* 1 */
	swt_undef,   	/* 2 */
	swt_undef,	/* 3 */
	swt_undef, 	/* 4 */
	swt_undef, 	/* 5 */
	swt_undef, 	/* 6 */
	swt_fpu_pgxbug,	/* 7 */
};
