/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: init_sysent1.c 1.28 89/08/07 $"

/* $Log:	init_sysent1.c,v $
 */

#include "sys/types.h"
#include "sys/param.h"
#include "sys/debug.h"
#include "sys/systm.h"

/*
 * System V.3.1 src compatible system calls.
 * This table is the switch used to transfer
 * to the appropriate routine for processing a system call.
 * Each row contains the number of arguments expected,
 * and a pointer to the routine.
 */

int alarm(), chdir(), chmod(), chown(), chroot(), close(), creat(), dup();
int exec(), exece(), fcntl(), fork(), fstat(), getgid(), getpid(), getuid();
int gtime(), gtty(), ioctl(), kill(), link(), lock(), mknod(), msgsys();
int nice(), nosys(), open(), pause(), pipe(), profil(), ptrace();
int read(), rexit(), saccess(), sbreak(), lseek(), semsys(), setgid(), setpgrp();
int setuid(), shmsys(), smount(), ssig(), stat(), stime(), stty(), sumount();
int sync(), sysacct(), times(), ulimit(), umask(), unlink(), utime(), utssys();
int wait(), write(), rmdir(), mkdir(), getdents(), statfs(), fstatfs();
int getmsg(), poll(), putmsg(), sysi86(), uadmin();
int sysconf(), pathconf(), fpathconf(), rename();
int waitpid(),setsid(), setpgid(), getgroups();
int dup2();

struct sysent sysent1[] =
{
	0, nosys,			/*  0 = indir */
	1, rexit,			/*  1 = exit */
	0, fork,			/*  2 = fork */
	3, read,			/*  3 = read */
	3, write,			/*  4 = write */
	3, open,			/*  5 = open */
	1, close,			/*  6 = close */
	0, wait,			/*  7 = wait */
	2, creat,			/*  8 = creat */
	2, link,			/*  9 = link */
	1, unlink,			/* 10 = unlink */
	2, exec,			/* 11 = exec */
	1, chdir,			/* 12 = chdir */
	0, gtime,			/* 13 = time */
	3, mknod,			/* 14 = mknod */
	2, chmod,			/* 15 = chmod */
	3, chown,			/* 16 = chown; now 3 args */
	1, sbreak,			/* 17 = break */
	2, stat,			/* 18 = stat */
	3, lseek,			/* 19 = lseek */
	0, getpid,			/* 20 = getpid */
	6, smount,			/* 21 = mount */
	1, sumount,			/* 22 = umount */
	1, setuid,			/* 23 = setuid */
	0, getuid,			/* 24 = getuid */
	1, stime,			/* 25 = stime */
	4, ptrace,			/* 26 = ptrace */
	1, alarm,			/* 27 = alarm */
	2, fstat,			/* 28 = fstat */
	0, pause,			/* 29 = pause */
	2, utime,			/* 30 = utime */
	2, stty,			/* 31 = stty */
	2, gtty,			/* 32 = gtty */
	2, saccess,			/* 33 = access */
	1, nice,			/* 34 = nice */
	4, statfs,			/* 35 = statfs */
	0, sync,			/* 36 = sync */
	2, kill,			/* 37 = kill */
	4, fstatfs,			/* 38 = fstatfs */
	1, setpgrp,			/* 39 = setpgrp */
	0, nosys,			/* 40 = tell - obsolete */
	1, dup,				/* 41 = dup */
	0, pipe,			/* 42 = pipe */
	1, times,			/* 43 = times */
	4, profil,			/* 44 = prof */
	1, lock,			/* 45 = proc lock */
	1, setgid,			/* 46 = setgid */
	0, getgid,			/* 47 = getgid */
	4, ssig,			/* 48 = sig */
	6, msgsys,			/* 49 = IPC message */
	4, sysi86,			/* 50 = Machine-specific system call */
	1, sysacct,			/* 51 = turn acct off/on */
	4, shmsys,			/* 52 = shared memory */
	5, semsys,			/* 53 = IPC semaphores */
	3, ioctl,			/* 54 = ioctl */
	3, uadmin,			/* 55 = uadmin */
	0, nosys,			/* 56 = reserved for exch */
	3, utssys,			/* 57 = utssys */
	0, nosys,			/* 58 = reserved for USG */
	3, exece,			/* 59 = exece */
	1, umask,			/* 60 = umask */
	1, chroot,			/* 61 = chroot */
	3, fcntl,			/* 62 = fcntl */
	2, ulimit,			/* 63 = ulimit */
	0, nosys,			/* 64 +0 = nosys, 64-69 for Safari 4 */
	0, nosys,			/* 64 +1 = nosys */
	0, nosys,			/* 64 +2 = nosys */
	0, nosys,			/* 64 +3 = file locking call */
	0, nosys,			/* 64 +4 = local system calls */
	0, nosys,			/* 64 +5 = inode open */
	0, nosys,			/* 70 = advfs */
	0, nosys,			/* 71 = unadvfs */
	0, nosys,			/* 72 = rmount */
	0, nosys,			/* 73 = rumount */
	0, nosys,			/* 74 = rfstart */
	0, nosys,			/* 75 = not used */
	0, nosys,			/* 76 = rdebug */
	0, nosys,			/* 77 = rfstop */
	0, nosys,			/* 78 = rfsys */
	1, rmdir,			/* 79 = rmdir */
	2, mkdir,			/* 80 = mkdir */
	4, getdents,			/* 81 = getdents */
	0, nosys,			/* 82 = libattach */
	0, nosys,			/* 83 = libdetach */
	0, nosys,			/* 84 = sysfs */
	4, getmsg,			/* 85 = getmsg */
	4, putmsg,			/* 86 = putmsg */
	3, poll,			/* 87 = poll */
	0, nosys,			/* 88 = reserved */
	0, nosys,			/* 89 = reserved */
	0, nosys,			/* 90 = reserved */
	0, nosys,			/* 91 = reserved */
	0, nosys,			/* 92 = reserved */
	0, nosys,			/* 93 = reserved */
	0, nosys,			/* 94 = reserved */
	0, nosys,			/* 95 = reserved */
	0, nosys,			/* 96 = reserved */
	0, nosys,			/* 97 = reserved */
	0, nosys,			/* 98 = reserved */
	0, nosys,			/* 99 = reserved */
	3, waitpid,			/* 100=POSIX waitpid() */
	0, setsid,			/* 101=POSIX setsid() */
	2, setpgid,			/* 102=POSIX setpgid() */
	1, sysconf,			/* 103=POSIX sysconf() */
	2, pathconf,			/* 104=POSIX pathconf() */
	2, fpathconf,			/* 105=POSIX fpathconf() */
	2, rename,			/* 106=POSIX rename() */
	2, getgroups,			/* 107=POSIX getgroups */
	2, dup2,			/* 108=POSIX dup2 */
};
int	nsysent1 = sizeof (sysent1) / sizeof (sysent1[0]);
