/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident		"$Header: init_sysent2.c 1.28 90/05/03 $"

/* $Log:	init_sysent2.c,v $
 */

#include "sys/types.h"
#include "sys/param.h"
#include "sys/debug.h"
#include "sys/systm.h"

/*
 * DYNIX/ptx(R) specific system calls
 */

int cust0(), cust1(), cust2(), cust3(), cust4(), cust5(), cust6(), cust7();
int cust8(), cust9(), getpagesize(), mmap(), munmap(), mptrace();
int proc_ctl(), vm_ctl(), tmp_ctl(), affinity(), nosys();
int sigcleanup(), getdtablesize(), setdtablesize(), bdflush();
int get_process_stats(), symlink(), readlink(), lstat(), truncate();
int ftruncate(), readv(), writev();
int sigstack(),sigcontext();
int setgroups(), vfork();
int vhangup();
int shfork(), shvfork();
int getitimer(), setitimer();
int DirectRead(), DirectWrite();
int affinitypid();
int adjtime();
int DIO();
#ifdef QUOTA
int	quotactl();
#endif /* QUOTA */

struct sysent sysent2[] =
{
	0, cust0,			/* 0 = Reserved for Customer use */
	1, cust1,			/* 1 = Reserved for Customer use */
	2, cust2,			/* 2 = Reserved for Customer use */
	3, cust3,			/* 3 = Reserved for Customer use */
	4, cust4,			/* 4 = Reserved for Customer use */
	5, cust5,			/* 5 = Reserved for Customer use */
	6, cust6,			/* 6 = Reserved for Customer use */
	1, cust7,			/* 7 = Reserved for Customer use */
	1, cust8,			/* 8 = Reserved for Customer use */
	1, cust9,			/* 9 = Reserved for Customer use */
	0, getpagesize,			/* 10 = getpagesize */
	6, mmap,			/* 11 = mmap */
	2, munmap,			/* 12 = munmap */
	4, mptrace,			/* 13 = mptrace */
	3, proc_ctl,			/* 14 = process control functions */
	2, vm_ctl,			/* 15 = VM information/tuning */
	2, tmp_ctl,			/* 16 = TMP information and control */
	1, affinity,			/* 17 = processor/process affinity */
	0, sigcleanup,			/* 18 = signal clean up */
	0, getdtablesize,		/* 19 = getdtablesize */
	1, setdtablesize,		/* 20 = setdtablesize */
	2, bdflush,			/* 21 = bdflush */
	4, get_process_stats,		/* 22 = get_process_stats */
	2, symlink,			/* 23 = symlink */
	3, readlink,			/* 24 = readlink */
	2, lstat,			/* 25 = lstat */
	2, truncate,			/* 26 = truncate */
	2, ftruncate,			/* 27 = ftruncate */
	3, readv,			/* 28 = readv */
	3, writev,			/* 29 = writev */
	2, sigstack,			/* 30 = sigstack */
#ifdef QUOTA
        4, quotactl,			/* 31 = quotactl */
#else
        0, nosys,			/* 31 = not configured */
#endif /* QUOTA */
	2, sigcontext,			/* 32 = sigcontext */
	2, setgroups,			/* 33 = setgroups */
	0, vfork,			/* 34 = vfork */
	1, vhangup,			/* 35 = vhangup */
	1, shfork,			/* 36 = shfork */
	1, shvfork,			/* 37 = shvfork */
	2, getitimer,			/* 38 = getitimer */
	3, setitimer,			/* 39 = setitimer */
	4, DirectRead,			/* 40 = DirectRead */
	4, DirectWrite,			/* 41 = DirectWrite */
	2, affinitypid,			/* 42 = affinitypid */
	2, adjtime,			/* 43 = adjtime */
	6, DIO,				/* 44 = DIO */
};
int	nsysent2 = sizeof (sysent2) / sizeof (sysent2[0]);
