#ident	"$Header: str_ap.c 1.14 89/08/07 $"

/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/* $Log:	str_ap.c,v $
 */

/*
 * str_aoutp() has been added at the end of str_open().
 * and the I_PUSH case in str_ioctl().
 */

#include "sys/types.h"
#include "sys/mutex.h"
#include "sys/intctl.h"
#include "sys/file.h"
#include "sys/sysmacros.h"
#include "sys/param.h"
#include "sys/errno.h"
#include "sys/signal.h"
#include "sys/user.h"
#include "sys/conf.h"
#include "sys/debug.h"
#include "sys/session.h"
#include "sys/stream.h"
#include "sys/stropts.h"
#include "sys/strstat.h"
#include "sys/buf.h"
#include "sys/vfs.h"
#include "sys/vnode.h"
#include "sys/timer.h"
#include "sys/proc.h"
#include "sys/uio.h"
#include "sys/cmap.h"
#include "sys/snode.h"
#include "sys/ufsfilsys.h"
#include "sys/var.h"
#include "sys/poll.h"
#include "sys/systm.h"
#include "sys/callo.h"
#include "sys/gate.h"
#include "sys/cmn_err.h"
#include "sys/strap.h"


#ifdef DEBUG
int	strap_debug = 0;
#endif /*DEBUG*/

extern	struct	str_ap	str_ap[];	/* autop_space.c */
static struct str_ap *get_ap();

/*
 * str_autop() is called at spl0 without locks.
 * it search a table for instructions on what to push on an existing
 * stream.
 */
int
str_autop(stp, sp)
	struct stdata	*stp;
	struct snode 	*sp;	
{
	char		*name;
	int		m;
	spl_t		spl;

	/*
	 * first look up the name of the already attached module
	 * in the str_ap table
	 */
	
	ASSERT_DEBUG(stp->sd_wrq->q_next, "str_push wrq not set");
	m = minor(sp->s_dev);

	spl = p_lock(&stp->sd_mutex, SPLSTR);
	name = stp->sd_wrq->q_next->q_qinfo->qi_minfo->mi_idname;
	v_lock(&stp->sd_mutex, spl);
	str_ap_expand(name, m, stp, sp);
	return (u.u_error);
}


str_ap_expand(name, m, stp, sp)
	char		*name;
	int		m;
	struct stdata	*stp;
	struct snode 	*sp;	
{
	struct	str_ap	*sap;
	int		i;

	for (sap = get_ap(name, m); sap; sap = &str_ap[sap->strap_next]) {
		str_ap_expand(sap->strap_module, m, stp, sp );
		if (((i = findmod(sap->strap_module))) == -1) {
#ifdef DEBUG
			if (strap_debug)
				printf("str_autp_expand: find %s failed\n",
						sap->strap_module);
#endif
			if (sap->strap_next == -1) {
				return;
			}
			name = sap->strap_module;
			continue;
		}
		/*
		 * now push the module.
		 */
#ifdef DEBUG
		if (strap_debug)
			printf("str_autp_expand: driver\"%s\" pushing mod#%d \"%s\"\n", 
			name, i, sap->strap_module);
#endif
		if (u.u_error=str_push(i, stp, sp)) {
#ifdef DEBUG
			if (strap_debug)
				printf("str_autp: push failed\n");
#endif
			return;
		}
		if (sap->strap_next == -1) {
			return;
		}
		name = sap->strap_module;
	}
}

/*
 * get_ap() returns the idex of a matching entry from 
 * the "str_ap" table.
 * If no entry can be found a value of -1 is returned.
 */

static struct str_ap *
get_ap(name, m)
char	*name;
int	m;
{
	struct	str_ap	*sap;
	int		i;

#ifdef DEBUG
	if (strap_debug)
		printf("get_ap:I_LOOK driver\"%s\" minor %d ", name, m);
#endif
	for (sap = str_ap; *sap->strap_driver; sap++) {
		for (i = 0; i < FMNAMESZ; i++) {
			if (name[i] != sap->strap_driver[i]) 
				break;
			if (((name[i] == '\0') || (i == FMNAMESZ-1))
					   && (m >= sap->strap_lminor) 
				           && (m <= sap->strap_hminor)) {
				/*
				 * The name checks out and the minor is
				 * within range. 
				 */
#ifdef DEBUG
				if (strap_debug)
					printf(" <-- module\"%s\"\n", 
							sap->strap_module);
#endif
				return (sap);
			}
		}
	}
#ifdef DEBUG
	if (strap_debug)
		printf("get_ap: - is not found\n");
#endif
	return (struct str_ap *)NULL;
}
