/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: errno.h 1.11 90/07/29 $"

#ifndef	_SYS_ERRNO_H_

/* $Log:	errno.h,v $
 */

/*____________________________________________________________________*
 * This file forms part of the POSIX requirement described in section *
 * 2.5 of 1003.1-1988 which should be refered to before making any    *
 * changes.							      *
 *____________________________________________________________________*/


/*
 * Error codes
 */

#define	EPERM	1	/* Not super-user			*/
#define	ENOENT	2	/* No such file or directory		*/
#define	ESRCH	3	/* No such process			*/
#define	EINTR	4	/* interrupted system call		*/
#define	EIO	5	/* I/O error				*/
#define	ENXIO	6	/* No such device or address		*/
#define	E2BIG	7	/* Arg list too long			*/
#define	ENOEXEC	8	/* Exec format error			*/
#define	EBADF	9	/* Bad file number			*/
#define	ECHILD	10	/* No children				*/
#define	EAGAIN	11	/* No more processes			*/
#define	ENOMEM	12	/* Not enough core			*/
#define	EACCES	13	/* Permission denied			*/
#define	EFAULT	14	/* Bad address				*/
#ifndef	_POSIX_SOURCE
#define	ENOTBLK	15	/* Block device required		*/
#endif	/*_POSIX_SOURCE*/
#define	EBUSY	16	/* Mount device busy			*/
#define	EEXIST	17	/* File exists				*/
#define	EXDEV	18	/* Cross-device link			*/
#define	ENODEV	19	/* No such device			*/
#define	ENOTDIR	20	/* Not a directory			*/
#define	EISDIR	21	/* Is a directory			*/
#define	EINVAL	22	/* Invalid argument			*/
#define	ENFILE	23	/* File table overflow			*/
#define	EMFILE	24	/* Too many open files			*/
#define	ENOTTY	25	/* Not a typewriter			*/
#ifndef	_POSIX_SOURCE
#define	ETXTBSY	26	/* Text file busy			*/
#endif	/*_POSIX_SOURCE*/
#define	EFBIG	27	/* File too large			*/
#define	ENOSPC	28	/* No space left on device		*/
#define	ESPIPE	29	/* Illegal seek				*/
#define	EROFS	30	/* Read only file system		*/
#define	EMLINK	31	/* Too many links			*/
#define	EPIPE	32	/* Broken pipe				*/
#define	EDOM	33	/* Math arg out of domain of func	*/
#define	ERANGE	34	/* Math result not representable	*/
#ifndef	_POSIX_SOURCE
#define	ENOMSG	35	/* No message of desired type		*/
#define	EIDRM	36	/* Identifier removed			*/
#define	ECHRNG	37	/* Channel number out of range		*/
#define	EL2NSYNC 38	/* Level 2 not synchronized		*/
#define	EL3HLT	39	/* Level 3 halted			*/
#define	EL3RST	40	/* Level 3 reset			*/
#define	ELNRNG	41	/* Link number out of range		*/
#define	EUNATCH 42	/* Protocol driver not attached		*/
#define	ENOCSI	43	/* No CSI structure available		*/
#define	EL2HLT	44	/* Level 2 halted			*/
#endif	/*_POSIX_SOURCE*/
#define	EDEADLK	45	/* Deadlock condition.			*/
#define	ENOLCK	46	/* No record locks available.		*/

#ifndef	_POSIX_SOURCE

/* Convergent Error Returns */
#define EBADE	50	/* invalid exchange			*/
#define EBADR	51	/* invalid request descriptor		*/
#define EXFULL	52	/* exchange full			*/
#define ENOANO	53	/* no anode				*/
#define EBADRQC	54	/* invalid request code			*/
#define EBADSLT	55	/* invalid slot				*/
#define EDEADLOCK 56	/* file locking deadlock error		*/

#define EBFONT	57	/* bad font file fmt			*/

/* stream problems */
#define ENOSTR	60	/* Device not a stream			*/
#define ENODATA	61	/* no data (for no delay io)		*/
#define ETIME	62	/* timer expired			*/
#define ENOSR	63	/* out of streams resources		*/

#define ENONET	64	/* Machine is not on the network	*/
#define ENOPKG	65	/* Package not installed                */
#define EREMOTE	66	/* The object is remote			*/
#define ENOLINK	67	/* the link has been severed */
#define EADV	68	/* advertise error */
#define ESRMNT	69	/* srmount error */

#define	ECOMM	70	/* Communication error on send		*/
#define EPROTO	71	/* Protocol error			*/
#define	EMULTIHOP 74	/* multihop attempted */
#define	EDOTDOT 76	/* Cross mount point (not really error)*/
#define EBADMSG 77	/* trying to read unreadable message	*/

#define ENOTUNIQ 80	/* given log. name not unique */
#define EBADFD	 81	/* f.d. invalid for this operation */
#define EREMCHG	 82	/* Remote address changed */

/* shared library problems */
#define ELIBACC	83	/* Can't access a needed shared lib.	*/
#define ELIBBAD	84	/* Accessing a corrupted shared lib.	*/
#define ELIBSCN	85	/* .lib section in a.out corrupted.	*/
#define ELIBMAX	86	/* Attempting to link in too many libs.	*/
#define ELIBEXEC	87	/* Attempting to exec a shared library.	*/

#endif	/*_POSIX_SOURCE*/

/* Begin Sequent errno's */
#define ENAMETOOLONG	88	/* file name or path too long  (POSIX)	*/
#ifndef	_POSIX_SOURCE
#define ELOOP		89	/* too many levels of symbolic links	*/
#define	EDQUOT		90	/* Disc quota exceeded */
#endif	/*_POSIX_SOURCE*/
#define	ENOSYS		91	/* function not implemented 		*/
#define	ENOTEMPTY	92	/* directory not empty 			*/

#ifndef _POSIX_SOURCE

/* Generic network error, use specific error request for more detail
*/

#define ENETERR	93		/* Sequent network error */

/* socket emulation lib errors */

/* non-blocking and interrupt i/o */
#define	EWOULDBLOCK	94		/* Operation would block */
#define	EINPROGRESS	95		/* Operation now in progress */
#define	EALREADY	96		/* Operation already in progress */

/* ipc/network software */
	
	/* argument errors */
#define	ENOTSOCK	97		/* Socket operation on non-socket */
#define	EDESTADDRREQ	98		/* Destination address required */
#define	EMSGSIZE	99		/* Message too long */
#define	EPROTOTYPE	100		/* Protocol wrong type for socket */
#define	ENOPROTOOPT	101		/* Protocol not available */
#define	EPROTONOSUPPORT	102		/* Protocol not supported */
#define	ESOCKTNOSUPPORT	103		/* Socket type not supported */
#define	EOPNOTSUPP	104		/* Operation not supported on socket */
#define	EPFNOSUPPORT	105		/* Protocol family not supported */
#define	EAFNOSUPPORT	106		/* Address family not supported by protocol family */
#define	EADDRINUSE	107		/* Address already in use */
#define	EADDRNOTAVAIL	108		/* Can't assign requested address */

	/* operational errors */
#define	ENETDOWN	109		/* Network is down */
#define	ENETUNREACH	110		/* Network is unreachable */
#define	ENETRESET	111		/* Network dropped connection on reset */
#define	ECONNABORTED	112		/* Software caused connection abort */
#define	ECONNRESET	113		/* Connection reset by peer */
#define	ENOBUFS		114		/* No buffer space available */
#define	EISCONN		115		/* Socket is already connected */
#define	ENOTCONN	116		/* Socket is not connected */
#define	ESHUTDOWN	117		/* Can't send after socket shutdown */
#define	ETOOMANYREFS	118		/* Too many references: can't splice */
#define	ETIMEDOUT	119		/* Connection timed out */
#define	ECONNREFUSED	120		/* Connection refused */

/* should be rearranged */
#define	EHOSTDOWN	121		/* Host is down */
#define	EHOSTUNREACH	122		/* No route to host */

/* Network File System */
#define	ESTALE		123		/* Stale NFS file handle */

/*
 * This section of error numbers is used by the Trusted System Kit.
 */
#define	EBADACL		124	/* Truncated or invalid ACL encountered */
#define	EINVMLBL	125	/* Invalid MAC label */
#define	ESINGL		126	/* Invalid operation on a SLFS */

/* MNLS */
#define EILSEQ		127		/* MNLS illegal byte sequence */

#endif /* _POSIX_SOURCE */

#define	_SYS_ERRNO_H_
#endif	/*_SYS_ERRNO_H_*/

