/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident	"$Header: mount.h 1.7 89/08/24 $"

#ifndef	_SYS_MOUNT_H_

/*
 * mount.h
 *	mount options, argument definitions, etc.
 */

/* $Log:	mount.h,v $
 */

/*
 * mount options
 */
#define MS_RDONLY	0x01	/* mount fs read only */
#define	MS_FSS		0x02	/* Old (4-argument) mount (compatibility) */
#define	MS_DATA		0x04	/* 6-argument mount */

#define MS_NOSUID	0x10	/* mount fs with setuid not allowed */

/*
 * File system types, these corespond to entries in fsconf
 */
#define	MOUNT_INVAL	0
#define	MOUNT_UFS	1
#define	MOUNT_NFS	2

#ifdef	INKERNEL
/*
 * mount filesystem type switch table
 */
extern int mount_ntypes;
extern struct vfsops *vfssw[];
#endif

#define	_SYS_MOUNT_H_
#endif	/* _SYS_MOUNT_H_ */
