/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ident "$Header: strid.h 1.32 90/10/22 $"

#ifndef	_SYS_STRID_H_

/* $Log:	strid.h,v $
 */

/*  STRID.H - Module ID information */

#define STRID_LD0	1		/* Module ID for DYNIX/ptx(R) ld0 module */
#define STRID_LOD	2		/* loopback driver */
#define STRID_LMODA	3		/* loopback module (trace module) */
#define STRID_LP	4		/* lp driver */
#define STRID_CO	5		/* Module Id for DYNIX/ptx(R) co() driver */
#define STRID_LPMOD	6		/* parallel printer processing module */
#define STRID_WP	7		/* wp driver */
#define STRID_LOG	8		/* log/trace driver */
#define STRID_XS	9		/* xs driver */
#define STRID_SC	10		/* ssm console driver */
#define STRID_PTS	11		/* pty slave driver */
#define STRID_PTM	12		/* pty master driver */
#define STRID_SPX	13		/* streams pipe driver */
#define STRID_ST	14		/* Module ID for DYNIX/ptx(R) st() driver */
#define STRID_CLONE	15		/* streams clone driver */
#define STRID_SE	16		/* SCED Ethernet */
#define STRID_EG	17		/* VME Ethernet */
#define STRID_ECHO	18		/* Ethernet Echo */
#define STRID_LLC	19		/* LLC class 2 driver */
#define STRID_DDN	20		/* IP -> X.25 */
#define STRID_UDP	21		/* UDP protocol */
#define STRID_IP	22		/* IP mutiplixer */
#define STRID_TCP	23		/* TCP protocol */
#define STRID_LOOP	24		/* IP loopback */
#define STRID_SLIP	25		/* Serial Line IP */
#define STRID_PLP	26		/* X.25 packet level protocol */
#define STRID_DCP	27		/* Systech DCP 8804/8820 driver */
#define STRID_X29	28		/* X29 pad functions */
#define STRID_X3	29		/* X3 pad functions */
#define STRID_LAPB	30		/* protocol for X25 links */
#define STRID_ARP	31		/* Address Resolution Protocol */
#define STRID_SNAP	32		/* IP on 802.2 */
#define STRID_RLOGIN	33		/* rlogin to ld0 protocol */
#define STRID_TELNET	34		/* telnet to ld0 protocol. */
#define STRID_TIVC	35		/* connection oriented */
#define STRID_TIDG	36		/* connectionless */
#define STRID_TIRDWR    37		/* tirdwr id */
#define STRID_TIMOD	38		/* timod id */
#define STRID_LMODE	39		/* lmode id */
#define STRID_LMODR	40		/* lmodr id */
#define STRID_LMODB	41		/* lmodb id */
#define STRID_FL	42		/* flavours id */
#define	STRID_KRPC	43		/* kernel RPC (used only by NFS) */
#define	STRID_KD	44		/* PC/3AT console driver */
#define	STRID_ASY	45		/* PC/3AT async driver */
#define	STRID_PP	46		/* PC/3AT parallel printer driver */
#define	STRID_CLNS	47		/* OSI Connection-Less Network Protocol */
#define	STRID_COTS	48		/* OSI TP4 over CLNP */
#define	STRID_CLTS	49		/* OSI CLTP over CLNP */
#define	STRID_SNDCF	50		/* OSI CLNP to X25 conversion */
#define	STRID_WE	51		/* PC/3AT WD8003E Ethernet driver */
#define STRID_NIMOD	52		/* Network Library Interface module */
#define STRID_NIRDWR	53		/* READ/WRITE on NLI interface */
#define STRID_DT	54		/* Distributed Terminal Interface */
#define	STRID_DNA	55		/* Digital Network Architecture */
#define STRID_COXS	56		/* OSI TP0/2/4 over X.25 */
#define STRID_CLXS	57		/* OSI CLTP over X.25 */
#define STRID_DB	58		/* PC/3AT DigiBoard driver */
#define STRID_ELD0	59		/* Module ID alias for ld0 module */
#define STRID_KBD	60		/* NLS keyboard mapping module */
#define	STRID_TR	61		/* Token Ring */
#define	STRID_DICT	62		/* JIO dictionary module */
#define	STRID_XMOD	63		/* JIO translation module  */
#define	STRID_X25TRACE	64		/* X.25 Streams trace device */
#define STRID_TICOTS    65		/* For sockets support */
#define STRID_TICLTS	66		/* For sockets support */
#define	STRID_SOCK	67		/* For sockets support */
#define	STRID_NITIF	68		/* tcp/lan version 2 */
#define	STRID_NBUF	69		/* tcp/lan version 2 */
#define	STRID_ITX	70		/* ptx/ITX module */

#define STRID_OEM00	200		/* OEM Reserved */
#define STRID_OEM01	201		/* OEM Reserved */
#define STRID_OEM02	202		/* OEM Reserved */
#define STRID_OEM03	203		/* OEM Reserved */
#define STRID_OEM04	204		/* OEM Reserved */
#define STRID_OEM05	205		/* OEM Reserved */
#define STRID_OEM06	206		/* OEM Reserved */
#define STRID_OEM07	207		/* OEM Reserved */
#define STRID_OEM08	208		/* OEM Reserved */
#define STRID_OEM09	209		/* OEM Reserved */
#define STRID_OEM10	210		/* OEM Reserved */
#define STRID_OEM11	211		/* OEM Reserved */
#define STRID_OEM12	212		/* OEM Reserved */
#define STRID_OEM13	213		/* OEM Reserved */
#define STRID_OEM14	214		/* OEM Reserved */
#define STRID_OEM15	215		/* OEM Reserved */
#define STRID_OEM16	216		/* OEM Reserved */
#define STRID_OEM17	217		/* OEM Reserved */
#define STRID_OEM18	218		/* OEM Reserved */
#define STRID_OEM19	219		/* OEM Reserved */
#define STRID_OEM20	220		/* OEM Reserved */
#define STRID_OEM21	221		/* OEM Reserved */
#define STRID_OEM22	222		/* OEM Reserved */
#define STRID_OEM23	223		/* OEM Reserved */
#define STRID_OEM24	224		/* OEM Reserved */
#define STRID_OEM25	225		/* OEM Reserved */
#define STRID_OEM26	226		/* OEM Reserved */
#define STRID_OEM27	227		/* OEM Reserved */
#define STRID_OEM28	228		/* OEM Reserved */
#define STRID_OEM29	229		/* OEM Reserved */
#define STRID_OEM30	230		/* OEM Reserved */
#define STRID_OEM31	231		/* OEM Reserved */
#define STRID_OEM32	232		/* OEM Reserved */
#define STRID_OEM33	233		/* OEM Reserved */
#define STRID_OEM34	234		/* OEM Reserved */
#define STRID_OEM35	235		/* OEM Reserved */
#define STRID_OEM36	236		/* OEM Reserved */
#define STRID_OEM37	237		/* OEM Reserved */
#define STRID_OEM38	238		/* OEM Reserved */
#define STRID_OEM39	239		/* OEM Reserved */
#define STRID_OEM40	240		/* OEM Reserved */
#define STRID_OEM41	241		/* OEM Reserved */
#define STRID_OEM42	242		/* OEM Reserved */
#define STRID_OEM43	243		/* OEM Reserved */
#define STRID_OEM44	244		/* OEM Reserved */
#define STRID_OEM45	245		/* OEM Reserved */
#define STRID_OEM46	246		/* OEM Reserved */
#define STRID_OEM47	247		/* OEM Reserved */
#define STRID_OEM48	248		/* OEM Reserved */
#define STRID_OEM49	249		/* OEM Reserved */
#define STRID_OEM50	250		/* OEM Reserved */
#define STRID_OEM51	251		/* OEM Reserved */
#define STRID_OEM52	252		/* OEM Reserved */
#define STRID_OEM53	253		/* OEM Reserved */
#define STRID_OEM54	254		/* OEM Reserved */
#define STRID_OEM55	255		/* OEM Reserved */
#define STRID_OEM56	256		/* OEM Reserved */
#define STRID_OEM57	257		/* OEM Reserved */
#define STRID_OEM58	258		/* OEM Reserved */
#define STRID_OEM59	259		/* OEM Reserved */
#define STRID_OEM60	260		/* OEM Reserved */
#define STRID_OEM61	261		/* OEM Reserved */
#define STRID_OEM62	262		/* OEM Reserved */
#define STRID_OEM63	263		/* OEM Reserved */
#define STRID_OEM64	264		/* OEM Reserved */
#define STRID_OEM65	265		/* OEM Reserved */
#define STRID_OEM66	266		/* OEM Reserved */
#define STRID_OEM67	267		/* OEM Reserved */
#define STRID_OEM68	268		/* OEM Reserved */
#define STRID_OEM69	269		/* OEM Reserved */
#define STRID_OEM70	270		/* OEM Reserved */
#define STRID_OEM71	271		/* OEM Reserved */
#define STRID_OEM72	272		/* OEM Reserved */
#define STRID_OEM73	273		/* OEM Reserved */
#define STRID_OEM74	274		/* OEM Reserved */
#define STRID_OEM75	275		/* OEM Reserved */
#define STRID_OEM76	276		/* OEM Reserved */
#define STRID_OEM77	277		/* OEM Reserved */
#define STRID_OEM78	278		/* OEM Reserved */
#define STRID_OEM79	279		/* OEM Reserved */
#define STRID_OEM80	280		/* OEM Reserved */
#define STRID_OEM81	281		/* OEM Reserved */
#define STRID_OEM82	282		/* OEM Reserved */
#define STRID_OEM83	283		/* OEM Reserved */
#define STRID_OEM84	284		/* OEM Reserved */
#define STRID_OEM85	285		/* OEM Reserved */
#define STRID_OEM86	286		/* OEM Reserved */
#define STRID_OEM87	287		/* OEM Reserved */
#define STRID_OEM88	288		/* OEM Reserved */
#define STRID_OEM89	289		/* OEM Reserved */
#define STRID_OEM90	290		/* OEM Reserved */
#define STRID_OEM91	291		/* OEM Reserved */
#define STRID_OEM92	292		/* OEM Reserved */
#define STRID_OEM93	293		/* OEM Reserved */
#define STRID_OEM94	294		/* OEM Reserved */
#define STRID_OEM95	295		/* OEM Reserved */
#define STRID_OEM96	296		/* OEM Reserved */
#define STRID_OEM97	297		/* OEM Reserved */
#define STRID_OEM98	298		/* OEM Reserved */
#define STRID_OEM99	299		/* OEM Reserved */

#define	_SYS_STRID_H_
#endif	/* _SYS_STRID_H_ */
